2022-02-18  Stefan Kangas  <stefankangas@gmail.com>

	* Version 28.3 released.

2023-02-17  Stefan Kangas  <stefankangas@gmail.com>

	Update HISTORY for Emacs 28.3

2023-02-17  Stefan Kangas  <stefankangas@gmail.com>

	Bump Emacs version to 28.3

	* README:
	* configure.ac:
	* msdos/sed2v2.inp:
	* nt/README.W32: Bump Emacs version to 28.3.

2023-02-17  Stefan Kangas  <stefankangas@gmail.com>

	Update NEWS for Emacs 28.3

	* etc/NEWS: Update for Emacs 28.3.

2023-02-17  Stefan Kangas  <stefankangas@gmail.com>

	Update ChangeLog and AUTHORS for Emacs 28.3

	* ChangeLog.3:
	* etc/AUTHORS: Update for Emacs 28.3.

2023-02-17  Xi Lu  <lx@shellcodes.org>

	Fix etags local command injection vulnerability

	* lib-src/etags.c: (escape_shell_arg_string): New function.
	(process_file_name): Use it to quote file names passed to the
	shell.  (Bug#59817)

	(cherry picked from commit 01a4035c869b91c153af9a9132c87adb7669ea1c)

2023-02-17  Xi Lu  <lx@shellcodes.org>

	Fixed ctags local command execute vulnerability

	* lib-src/etags.c:

	(clean_matched_file_tag): New function
	(do_move_file): New function
	(readline_internal):
	Add `leave_cr` parameter, if true, include the \r character

	* test/manual/etags/CTAGS.good_crlf: New file
	* test/manual/etags/CTAGS.good_update: New file
	* test/manual/etags/crlf: New file
	* test/manual/etags/Makefile: Add `ctags -u` test cases

	(cherry picked from commit d48bb4874bc6cd3e69c7a15fc3c91cc141025c51)

2023-02-17  Xi Lu  <lx@shellcodes.org>

	Fix ruby-mode.el local command injection vulnerability (bug#60268)

	* lisp/progmodes/ruby-mode.el
	(ruby-find-library-file): Fix local command injection vulnerability.

	(cherry picked from commit 9a3b08061feea14d6f37685ca1ab8801758bfd1c)

2023-02-17  Xi Lu  <lx@shellcodes.org>

	Fix htmlfontify.el command injection vulnerability.

	* lisp/htmlfontify.el (hfy-text-p): Fix command injection
	vulnerability.  (Bug#60295)

	(cherry picked from commit 1b4dc4691c1f87fc970fbe568b43869a15ad0d4c)

2022-12-19  Eli Zaretskii  <eliz@gnu.org>

	Fix storing email into nnmail by Gnus

	Backporting suggested by Florian Weimer, since this is
	a denial-of-service issue.
	* lisp/gnus/nnml.el (nnml--encode-headers): Wrap
	'rfc2047-encode-string' calls with 'ignore-errors', to avoid
	disrupting email workflows due to possibly-invalid headers.
	Reported by Florian Weimer <fweimer@redhat.com>.

	(cherry picked from commit 23f7c9c2a92e4619b7c4d2286d4249f812cd695d)

2022-11-14  Robert Pluim  <rpluim@gmail.com>

	Explain how to bind keys to non-ASCII sequences

	* doc/emacs/custom.texi (Init Rebinding): Explain how to use `kbd'
	when binding keys to non-ASCII sequences.

2022-11-12  Eli Zaretskii  <eliz@gnu.org>

	Document that 'transient-mark-mode' is off in batch mode

	* doc/emacs/mark.texi (Mark, Disabled Transient Mark): Document,
	belatedly, that 'transient-mark-mode' is turned on by default only
	in interactive sessions.  (Bug#59201)

2022-10-14  Eli Zaretskii  <eliz@gnu.org>

	Document how to control where the *.eln files are written

	* doc/lispref/compile.texi (Native Compilation): Document the
	trick of pointing $HOME to a non-existent directory.
	(Native-Compilation Variables): Document the role of
	'native-comp-eln-load-path' in determining where *.eln files are
	written.

2022-10-14  Robert Pluim  <rpluim@gmail.com>

	Add cross-reference to alternative syntaxes for Unicode

	These alternative syntaxes allow you to specify Unicode codepoints
	using only ASCII, which helps avoid decoding issues.

	* doc/emacs/custom.texi (Init Non-ASCII): Add cross reference to
	"General Escape Syntax" in the Emacs Lisp Reference Manual.

2022-10-07  Lars Ingebrigtsen  <larsi@gnus.org>

	Update name of hs-mouse-toggle-hiding in Emacs manual

	* doc/emacs/programs.texi (Hideshow): Update the name of
	hs-mouse-toggle-hiding (bug#58331).

2022-10-06  Stefan Kangas  <stefankangas@gmail.com>

	Fix typo in `(emacs) Lisp Doc'

	* doc/emacs/programs.texi (Lisp Doc): Fix reference to
	'eldoc-echo-area-display-truncation-message'.  (Bug#58324)

2022-10-06  Stefan Kangas  <stefankangas@gmail.com>

	Fix references to 'default-indent-new-line'

	* doc/emacs/programs.texi (Comment Commands)
	(Multi-Line Comments): Fix references to
	'default-indent-new-line'.  (Bug#58325)

2022-10-04  Andreas Schwab  <schwab@linux-m68k.org>

	* src/emacs.c (load_pdump): Properly handle case when executable
	wasn't found.

2022-10-04  Eli Zaretskii  <eliz@gnu.org>

	Avoid assertion violations in STRING_CHAR

	* src/xdisp.c (handle_composition_prop):
	* src/editfns.c (styled_format): Don't call 'STRING_CHAR' on
	unibyte strings.  This avoids assertion violation in
	'string_char_and_length'.

	(cherry picked from commit d52d6e1e106117eb4bba81a65e256e2e793037b6)

2022-10-03  Stefan Kangas  <stefankangas@gmail.com>

	Fix documentation  of 'TAB' in cc-mode

	* doc/emacs/programs.texi (C Indent): Fix documentation of 'TAB'
	in cc-mode.  (Bug#58258)

2022-10-03  Stefan Kangas  <stefankangas@gmail.com>

	Fix 'org-export-dispatch' command name in manual

	* doc/emacs/text.texi (Org Authoring): Fix 'org-export-dispatch'
	command name.  (Bug#58260)

2022-10-02  Andreas Schwab  <schwab@linux-m68k.org>

	* src/emacs.c (load_pdump): Fix use of xpalloc.

2022-10-02  Eli Zaretskii  <eliz@gnu.org>

	Avoid assertion violation in 'xpalloc'

	* src/emacs.c (load_pdump): Ensure the 3rd argument of xpalloc is
	always positive.  (Bug#58232)

2022-09-30  Michael Albinus  <michael.albinus@gmx.de>

	Fix connection property incompatibility in Tramp

	* lisp/net/tramp.el (tramp-get-remote-tmpdir): Remove obsolete
	connection property "tmpdir".  (Bug#57800)

2022-09-29  Lars Ingebrigtsen  <larsi@gnus.org>

	Update some Gnus documentation in the Emacs manual

	* doc/emacs/misc.texi (Gnus Group Buffer, Gnus Summary Buffer):
	Update documentation (bug#58145).

2022-09-28  Eli Zaretskii  <eliz@gnu.org>

	Clarify image file search

	* doc/lispref/display.texi (Defining Images, Image Descriptors):
	* lisp/image.el (create-image): Clarify that non-absolute image
	files are searched along 'image-load-path'.  (Bug#52931)

2022-09-28  Stefan Kangas  <stefankangas@gmail.com>

	.mailcap: Some additional fixes.

2022-09-28  Eli Zaretskii  <eliz@gnu.org>

	Avoid assertion violations in 'pop_it'

	* src/xdisp.c (pop_it): Avoid assertion violations when handling
	lists or vectors of display properties.  (Bug#58122)

2022-09-28  Stefan Kangas  <stefankangas@gmail.com>

	Add .mailmap for proper git log output

	This file is used to fix a few misspelled names in various git
	listings (e.g., "git log").  This can be used to fix incorrect
	attribution, poor display, or names showing up more than once.
	It also allows updating an old email addresses to a new one.
	See "man git-shortlog" for more information on the format.

	* .mailmap: New file.

2022-09-27  Stefan Kangas  <stefankangas@gmail.com>

	* doc/emacs/ack.texi (Acknowledgments): Update maintainers.

2022-09-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/progmodes/hideshow.el (hs-toggle-hiding): Fix `interactive` form

	This fixes the first part of bug#52092, which is a regression
	introduced by commit d0e9113de97.

2022-09-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	Fix shaping with bitmap-only fonts on HarfBuzz 5.2.0 (Bug#57976)

	* src/ftcrfont.c (ftcrhbfont_begin_hb_font): Undo last change for
	HarfBuzz 5.2.0.

2022-09-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/text-modes/tex-mode.el (tex-mode): Fix AUCTeX regression

	As discussed in
	https://lists.gnu.org/r/auctex/2022-08/msg00004.html
	AUCTeX installs its own advice to redefine `tex-mode`, and that
	advice used to take precedence before commit 6075a7c5ae3fa456cd.

2022-09-20  Robert Pluim  <rpluim@gmail.com>

	Add vc-annotate-switches to manual

	* doc/emacs/maintaining.texi (Old Revisions): Add description of
	`vc-annotate-switches' and `vc-BACKEND-annotate-switches'.

2022-09-20  Robert Pluim  <rpluim@gmail.com>

	Remove mention of non-existent `annotate-switches'

	* lisp/vc/vc.el (vc-annotate-switches): Remove mention of
	`annotate-switches'.  As far as I can tell this has never existed in
	Emacs.

2022-09-20  Robert Pluim  <rpluim@gmail.com>

	Mention that src/macuvs.h sometimes needs committing

	* admin/notes/unicode: src/macuvs.h is generated, but needs to be
	committed sometimes.

2022-09-19  Gerd Möllmann  <gerd@gnu.org>

	MacOS ld warning from native compilation (bug#57849)

	* lisp/emacs-lisp/comp.el (native-comp-driver-options): Add "-Wl,-w"
	on Darwin systems.
	* etc/NEWS: Describe change.

2022-09-18  Michael Albinus  <michael.albinus@gmx.de>

	Fix Tramp error with eshell integration

	* lisp/net/tramp-integration.el (tramp-eshell-directory-change):
	Respect local `default-directory'.  (Bug#57556)

2022-09-17  Michael Albinus  <michael.albinus@gmx.de>

	Sync with Tramp 2.5.3.2.  Don't merge with master

	* doc/misc/tramp.texi (Android shell setup): Rework.
	(Frequently Asked Questions): Improve recommendations for speeding up.

	* doc/misc/trampver.texi:
	* lisp/net/trampver.el: Change version to "2.5.4-pre".

	* lisp/net/tramp-adb.el (tramp-methods): Use "%d".
	(tramp-adb-handle-directory-files-and-attributes): Fix "." and
	".." in listing.
	(tramp-adb-handle-file-attributes)
	(tramp-adb-handle-directory-files-and-attributes)
	(tramp-adb-handle-file-name-all-completions): Pipe "ls" output
	through "cat", in order to avoid quoting special characters.
	(tramp-adb-maybe-open-connection): Compute args from `tramp-login-args'.

	* lisp/net/tramp-compat.el (tramp-compat-replace-regexp-in-region):
	New defalias.

	* lisp/net/tramp-gvfs.el (tramp-gvfs-do-copy-or-rename-file):
	Adapt check for proper remote command.

	* lisp/net/tramp.el (tramp-methods): Adapt docstring.
	(tramp-handle-make-process): Check for adb device if indicated.
	(tramp-get-remote-tmpdir): Cache result in temporary connection
	property.

	* test/lisp/net/tramp-tests.el  (tramp-test17-insert-directory)
	(tramp-test22-file-times, tramp--test-utf8): Adapt tests.
	(tramp--test-shell-file-name): Do not depend on `tramp--test-adb-p'.
	(tramp-test46-unload): Ignore autoload functions in
	`tramp-file-name' structure tests, since `tramp-file-name-handler'
	is also autoloaded in Emacs 29.

2022-09-17  Stefan Kangas  <stefankangas@gmail.com>

	Simplify regexp in make-news-html-file

	* admin/admin.el (make-news-html-file): Simplify regexp.
	Suggested by Mattias Engdegård <mattiase@acm.org>.

2022-09-16  Stefan Kangas  <stefankangas@gmail.com>

	* admin/admin.el (make-news-html-file): Set id on correct tag.

2022-09-16  Stefan Kangas  <stefankangas@gmail.com>

	Add version headlines to HTML NEWS export

	This allows linking to, e.g. "NEWS.28.html#28.1" to go directly to
	those release notes.
	* admin/admin.el (admin--org-export-headers-format)
	(make-news-html-file): Add XX.Y version headlines with an HTML anchor.

2022-09-16  Stefan Kangas  <stefankangas@gmail.com>

	Improve HTML export of NEWS file

	* admin/admin.el (admin--org-export-headers-format)
	(admin--org-html-postamble): New variables.
	(admin--require-external-package): New function.
	(make-news-html-file): Improve HTML export.

2022-09-16  Stefan Kangas  <stefankangas@gmail.com>

	Delete "etc/NEWS*.html" from .gitignore

	We actually do want to see it when preparing a release, so that we
	don't include it in a tarball by mistake.
	* .gitignore: Don't ignore "etc/NEWS*.html".

2022-09-16  Stefan Kangas  <stefankangas@gmail.com>

	Recommend NonGNU ELPA over MELPA

	* doc/misc/org.org (Using CDLaTeX to enter math, Footnotes): Recommend
	NonGNU ELPA over MELPA.

2022-09-16  Stefan Kangas  <stefankangas@gmail.com>

	Minor doc fixes in picture.el

	* lisp/textmodes/picture.el: Improve Commentary.
	(picture-forward-column, picture-backward-column)
	(picture-move-down, picture-move-up, picture-movement-nw)
	(picture-movement-ne, picture-movement-sw, picture-movement-se)
	(picture-set-motion, picture-clear-line, picture-newline)
	(picture-tab, picture-yank-rectangle)
	(picture-yank-rectangle-from-register, picture-insert-rectangle)
	(picture-draw-rectangle): Minor doc fixes.

2022-09-16  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/textmodes/page-ext.el: Improve Commentary.

2022-09-14  Stefan Kangas  <stefankangas@gmail.com>

	Automate exporting etc/NEWS to HTML

	* admin/admin.el (make-news-html-file): New function.
	* .gitignore: Ignore generated "etc/NEWS*.html" file.

2022-09-14  Eli Zaretskii  <eliz@gnu.org>

	* Makefile.in (uninstall): Remove the *.eln files.  (Bug#57771)

2022-09-12  Stefan Kangas  <stefankangas@gmail.com>

	Update HISTORY for Emacs 28.2

	* etc/HISTORY: Update for the Emacs 28.2 release.

2022-09-07  Stefan Kangas  <stefankangas@gmail.com>

	Bump Emacs version to 28.2

	* README:
	* configure.ac:
	* msdos/sed2v2.inp:
	* nt/README.W32: Bump Emacs version to 28.2.

2022-09-07  Stefan Kangas  <stefankangas@gmail.com>

	Update ChangeLog and AUTHORS for Emacs 28.2

	* ChangeLog.3:
	* etc/AUTHORS:
	* etc/NEWS: Update for Emacs 28.2.

2022-09-06  Stefan Kangas  <stefankangas@gmail.com>

	* doc/misc/idlwave.texi (Troubleshooting): Don't say "Emacsen".

2022-09-06  Stefan Kangas  <stefankangas@gmail.com>

	Don't mention very old Emacs versions in docs

	* doc/misc/mh-e.texi (Conventions):
	* doc/misc/reftex.texi (Problems and Work-Arounds):
	* doc/misc/viper.texi (Loading Viper): Delete references to
	very old versions of Emacs.

2022-09-05  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/server.el: Improve Commentary.

2022-09-05  Gregory Heytings  <gregory@heytings.org>

	Explain how the font appearance can be fine-tuned in fbterm.

	* doc/misc/efaq.texi (Emacs in a Linux console): Briefly document
	Xft font specifications with which the font appearance can be
	fine-tuned.

2022-09-04  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.5

2022-09-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/emacs-lisp/comp.el (comp-run-async-workers): Fail more gracefully

	Otherwise Emacs may fail to start if it can't find a writable
	`~/.emacs.d/eln-cache` directory.
	Fixes bug#57562.  See also Debian's bug #1017739.

2022-09-03  Stefan Kangas  <stefankangas@gmail.com>

	Update acknowledgments

	* doc/emacs/ack.texi (Acknowledgments): Update.
	* doc/emacs/emacs.texi (Acknowledgments): Add several names from
	Author: headers.

2022-09-01  Stefan Kangas  <stefankangas@gmail.com>

	Make some versions in docs match package version

	* doc/emacs/misc.texi (Interactive Shell): Bump Emacs version.
	* doc/misc/ediff.texi:
	* doc/misc/flymake.texi:
	* doc/misc/viper.texi: Fix version to match package.
	* lisp/emulation/viper.el: Make version match variable.

2022-09-01  Stefan Kangas  <stefankangas@gmail.com>

	Minor doc fix; improve sorting of VC backends

	* doc/emacs/maintaining.texi (Version Control Systems): Minor doc fix;
	rearrange list to put git, cvs and subversion at the top.

2022-09-01  Eli Zaretskii  <eliz@gnu.org>

	Clarify the doc string of 'set-face-attribute'

	* lisp/faces.el (set-face-attribute): Clarify the issue with
	resetting attribute values to 'unspecified' for future frames.
	(Bug#57499)

2022-08-30  Gregory Heytings  <gregory@heytings.org>

	Enable 256 colors in fbterm.

	* lisp/term/fbterm.el: New file.

	* doc/misc/efaq.texi (Emacs in a Linux console): Document the TERM
	environment variable with which the new file is used.

2022-08-30  Eli Zaretskii  <eliz@gnu.org>

	One more fix for find-file.el

	* lisp/find-file.el (ff-get-file-name): Use 'expand-file-name'
	instead of 'concat', which doesn't DTRT with absolute file names.
	(ff-other-file-alist): Yet another doc fix.  (Bug#57325)

2022-08-29  Gregory Heytings  <gregory@heytings.org>

	Recommend using fbterm in the Linux console.

	* doc/misc/efaq.texi (Emacs in a Linux console): New node.
	(Common requests): Entry for the new node.

	* etc/PROBLEMS (Linux console problems...): Mention the new FAQ node.

2022-08-29  Eli Zaretskii  <eliz@gnu.org>

	* lisp/find-file.el (ff-other-file-alist): Doc fix.  (Bug#57325)

2022-08-28  Eli Zaretskii  <eliz@gnu.org>

	* lisp/info.el (Info-mode): Support the Linux console better.

2022-08-28  Eli Zaretskii  <eliz@gnu.org>

	Improve the documentation of glyphless-character display

	* lisp/international/characters.el (glyphless-char-display-control):
	* src/xdisp.c (syms_of_xdisp) <glyphless-char-display>: Mention
	the 'glyphless-char' face in the doc string.

	* doc/lispref/display.texi (Glyphless Chars): Index
	'glyphless-char' face.

2022-08-27  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of 'glyphless-char-display'

	* src/xdisp.c (syms_of_xdisp)<glyphless-char-display>: Doc fix.
	(gui_produce_glyphs, lookup_glyphless_char_display): Fix
	indentation.

2022-08-25  Robert Pluim  <rpluim@gmail.com>

	Treat smtp-auth method from auth-info as a symbol

	The lookup of the SMTP auth method is done based on symbols, but
	sometimes the requested value comes from `auth-info', in which case it
	is a string, so call `intern-soft' to convert it to a symbol (which
	does nothing if it's already a symbol).

	* lisp/mail/smtpmail.el (smtpmail-try-auth-methods): Call
	`intern-soft' on the smtp-auth key's value.  (Bug#57373)

	Do not merge to master

2022-08-25  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/wdired.el: Improve "Commentary" section.

	* lisp/wdired.el: Doc fix; don't mention obsolete variable.

	* lisp/progmodes/etags.el (next-file): Minor doc fix.

2022-08-25  Andreas Schwab  <schwab@suse.de>

	* configure.ac: Move AC_LANG_PUSH/POP out of AC_CACHE_CHECK.  (Bug#57380)

	(cherry picked from commit ce82300221f270241fdda1f5dfb567bdb1208543)

2022-08-21  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.4-19-g4dff42

2022-08-21  Eli Zaretskii  <eliz@gnu.org>

	* lisp/find-file.el (ff-other-file-alist): Doc fix.  (Bug#57325)

2022-08-19  Stefan Kangas  <stefankangas@gmail.com>

	Resurrect obsoletion warning for two functions

	These were supposed to have been deleted, but never were.  Resurrect
	their obsoletion warning and let's delete them in Emacs 29 instead.

	* lisp/subr.el (process-filter-multibyte-p)
	(set-process-filter-multibyte): Resurrect obsoletion warning.
	* etc/NEWS: Don't announce their deletion.

2022-08-19  Alan Mackenzie  <acm@muc.de>

	* src/window.c (select_window): Fix assert for buffer = non-active minibuffer

2022-08-19  Gerd Möllmann  <gerd@gnu.org>

	Find libgccjit on macOS with Homebrew differently

	* configure.ac (MAC_LIBS): Find libgccjit's directory slightly
	differently for brew installations.

2022-08-18  Stefan Kangas  <stefankangas@gmail.com>

	Improve image-mode-as-hex docstring

	* lisp/image-mode.el: Fix typos.
	(image-mode-as-hex): Doc fix; say that it uses 'hexl-mode' and reflow.

2022-08-18  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/image-mode.el (image-mode-as-hex): Fix toggle instructions.

	* lisp/image-mode.el: Improve commentary.

2022-08-18  Colin Woodbury  <colin@fosskers.ca>

	cl-reduce doc string improvement

	* lisp/emacs-lisp/cl-seq.el (cl-reduce): Explain what happens when
	using :from-end (bug#57273).

2022-08-18  Paul Eggert  <eggert@cs.ucla.edu>

	Backport tempname changes from master (bug#57129)

	* lib/tempname.c: Backport from master, which uses current Gnulib.

2022-08-16  Stefan Kangas  <stefankangas@gmail.com>

	Revert "; * doc/lispintro/emacs-lisp-intro.texi: Fix typo."

	This reverts commit 9d0dba44da7ac83d018fff3c26d33dac12ebd806.

	This was not a typo, but incorrectly matching parens in Info-mode.

2022-08-16  Stefan Kangas  <stefankangas@gmail.com>

	* doc/misc/gnus.texi (Article Washing): Fix Links URL.

2022-08-12  Stefan Kangas  <stefankangas@gmail.com>

	Delete references to deleted library hilit19.el

	* doc/misc/gnus.texi (Compatibility):
	* lisp/progmodes/f90.el:
	* lisp/ps-print.el:
	* lisp/vc/ediff.el: Delete references to hilit19.el.

2022-08-12  Stefan Kangas  <stefankangas@gmail.com>

	Delete stale comments from Lisp Intro manual

	* doc/lispintro/emacs-lisp-intro.texi (Args as Variable or List)
	(print-elements-of-list, Miscellaneous): Delete some references to
	Emacs 22.

2022-08-11  Stefan Kangas  <stefankangas@gmail.com>

	Don't list Emacs as requirement for built-in package

	* doc/misc/htmlfontify.texi (Requirements): Don't list Emacs as
	requirement for built-in package.

2022-08-11  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	Fix wrong metrics for bitmap-only fonts with HarfBuzz 5

	* src/ftcrfont.c (ftcrhbfont_begin_hb_font): Always use the standard
	position unit value on HarfBuzz 5 and later regardless of whether the
	font is bitmap-only or not.  (Bug#57066)

2022-08-09  Stefan Kangas  <stefankangas@gmail.com>

	Improve wording when documenting other TRAMP syntaxes

	* doc/misc/tramp.texi (Change file name syntax): Improve wording.
	(Bug#57061)

2022-08-08  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/vc/diff-mode.el: Don't mention XEmacs.

2022-08-08  Stefan Kangas  <stefankangas@gmail.com>

	Don't mention XEmacs toolbar in ediff manual

	* doc/misc/ediff.texi (Other Session Commands): Don't mention XEmacs
	specific toolbar support for now.  This can be changed back once the
	toolbar is ported to Emacs.

2022-08-06  Eli Zaretskii  <eliz@gnu.org>

	* etc/PROBLEMS: Problems with Alacritty and Emoji.  (Bug#56952)

2022-08-06  Yuga Ego  <yet@ego.team>

	Link from (emacs)Init Syntax to (elisp)Introduction

	* doc/emacs/custom.texi (Init Syntax): Link to the ELisp manual (Bug#56870)

2022-08-06  Stefan Kangas  <stefankangas@gmail.com>

	Don't mention removed XEmacs support in reftex manual

	* doc/misc/reftex.texi (Installation, Imprint): Don't mention
	removed XEmacs support.

2022-08-06  Stefan Kangas  <stefankangas@gmail.com>

	Don't mention removed XEmacs support in idlwave manual

	* doc/misc/idlwave.texi (Lesson I---Development Cycle)
	(Syntax Highlighting, Windows and macOS, Troubleshooting): Delete
	most references to XEmacs.  Support for it was deleted in 28.1.

2022-08-05  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/play/fortune.el: Doc fixes.

2022-08-04  Stefan Kangas  <stefankangas@gmail.com>

	* doc/lispref/loading.texi (Autoload by Prefix): Fix typo.

2022-08-03  Philipp Stephani  <phst@google.com>

	* lisp/uniquify.el (uniquify-buffer-name-style): Quote apostrophe.

2022-08-02  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/term.el: Doc fix; don't mention rlogin.

2022-07-31  Eli Zaretskii  <eliz@gnu.org>

	* src/lisp.h (CHECK_INTEGER): Fix the predicate.  (Bug#56856)

2022-07-30  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of column-related functions

	* doc/lispref/text.texi (Primitive Indent, Columns):
	* src/indent.c (Fcurrent_indentation, Fmove_to_column): Document
	that column counting ignores invisible text.  (Bug#56837)

2022-07-30  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* src/macfont.m (macfont_open): Initialize font->space_width.  (Bug#56808)

2022-07-30  Eli Zaretskii  <eliz@gnu.org>

	Improve indexing of keymap variables

	* doc/lispref/maps.texi (Standard Keymaps):
	* doc/lispref/display.texi (Button Buffer Commands)
	(Button Properties):
	* doc/lispref/keymaps.texi (Translation Keymaps): Improve indexing
	of keymaps.  (Bug#56816)

2022-07-29  Alan Mackenzie  <acm@muc.de>

	CC Mode: fontify variables/functions after line comments ending in spaces

	* lisp/progmodes/cc-engine.el (c-forward-comment-minus-1): Take account of
	spaces preceding a linefeed when scanning a putative line comment end.

2022-07-28  Stefan Kangas  <stefankangas@gmail.com>

	Bump Emacs version to 28.1.91

	* README:
	* configure.ac:
	* msdos/sed2v2.inp:
	* nt/README.W32: Bump Emacs version to 28.1.91.

2022-07-28  Stefan Kangas  <stefankangas@gmail.com>

	Update ChangeLog and AUTHORS for 28.1.91 pretest

	* ChangeLog.3:
	* etc/AUTHORS: Update.

2022-07-28  Lars Ingebrigtsen  <larsi@gnus.org>

	Revert the `...' documentation back to actual usage

	* doc/lispref/tips.texi (Documentation Tips): Document how `...'
	is really used now (bug#55780).  ‘...’ is not really used in the
	Emacs sources.

	(cherry picked from commit 1ed9c1c7f9fe32ff5123091033350beb1ccae4ca)

2022-07-28  Paul Pogonyshev  <pogonyshev@gmail.com>

	Release the desktop lock in 'kill-emacs-hook'

	* lisp/desktop.el: Run 'desktop--on-kill' in 'kill-emacs-hook'.
	(desktop--on-kill): New function, refactored from 'desktop-kill'.
	(desktop-kill): Call 'desktop--on-kill'.  (Bug#56800)

2022-07-25  Eli Zaretskii  <eliz@gnu.org>

	Avoid infloop in 'recenter'

	* src/window.c (Frecenter): Avoid infinite loop in the minibuffer
	under 'fido-vertical-mode'.  (Bug#56765)

2022-07-25  Eli Zaretskii  <eliz@gnu.org>

	Fix inaccuracies in "lax search" documentation

	* doc/emacs/search.texi (Lax Search): Update the examples of
	character folding in search.  (Bug#56747)

2022-07-24  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.4-17-g6e991f

2022-07-24  Eugene Ha  <eha@posteo.de>  (tiny change)

	Find libgccjit.dylib on Homebrew Macos

	* configure.ac: Also find libggcjit on Homebrew (bug#55173).

	(cherry picked from commit faa29fa2c9e9d5a5d7544a1a39b2a89cf57a8439)

2022-07-23  Michael Albinus  <michael.albinus@gmx.de>

	Set `default-directory' of Tramp archive connection buffer

	* lisp/net/tramp-archive.el (tramp-archive-file-name-handler):
	Set `default-directory' of Tramp connection buffer.  (Bug#56628)

2022-07-23  Eli Zaretskii  <eliz@gnu.org>

	Update the documentation of 'declare' forms

	* doc/lispref/compile.texi (Native-Compilation Variables): Mention
	the 'declare' alternative for 'native-comp-speed'.
	* doc/lispref/functions.texi (Declare Form): Document 'declare'
	forms that were previously undocumented.

2022-07-23  Eli Zaretskii  <eliz@gnu.org>

	Fix bookmark support for Help functions in native-compilation builds

	* lisp/help.el (describe-key--helper, describe-function--helper):
	New helper functions.
	(describe-key): Call 'describe-key--helper' instead of a
	lambda-function.
	* lisp/help-fns.el (describe-function): Call
	'describe-function--helper' instead of a lambda-function.
	(Bug#56643)

2022-07-23  Miha Rihtarsic  <miha@kamnitnik.top>

	Fix mode line mouse-1 binding when showing only column numbers

	* lisp/bindings.el (mode-line-position): Fix the mouse-1 binding
	when showing only column numbers (bug#56694).  Do not merge to
	master.

2022-07-23  Stefan Kangas  <stefankangas@gmail.com>

	Adjust help-fns.el tests for recent change

	* test/lisp/help-fns-tests.el (help-fns-test-lisp-defun)
	(help-fns-test-lisp-defsubst): Adjust tests for recent change.

2022-07-22  Robert Pluim  <rpluim@gmail.com>

	* src/terminal.c (Fframe_terminal): Use active voice

2022-07-22  Robert Pluim  <rpluim@gmail.com>

	Improve 'terminal-live-p' docstring some more

	* src/terminal.c (Fterminal_live_p): Improve description of
	arguments and return value.

2022-07-22  Robert Pluim  <rpluim@gmail.com>

	Improve terminal-live-p docstring

	* src/terminal.c (Fterminal_live_p): Explain what happens when the
	argument is nil.

2022-07-22  Robert Pluim  <rpluim@gmail.com>

	* lisp/net/tramp-gvfs.el (tramp-gvfs-dbus-event-vector): Fix grammar

2022-07-21  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/progmodes/cperl-mode.el: Don't mention obsolete archive.

2022-07-21  Eli Zaretskii  <eliz@gnu.org>

	Make 'describe-function' say "byte-compiled" when appropriate

	* lisp/help-fns.el (help-fns-function-description-header): Say
	"byte-compiled" when describing byte-compiled functions.

2022-07-21  Eli Zaretskii  <eliz@gnu.org>

	;Improve documentation of locale-specific string comparison

	* doc/lispref/strings.texi (Text Comparison): Mention the Unicode
	collation rules and buffer-local case-tables.

2022-07-19  Gerd Moellmann  <gerd.moellmann@gmail.com>

	Prevent GC of window referenced from EmacsScroller

	* src/nsterm.m (EmacsScroller.mark, mark_nsterm): New functions.
	* src/nsterm.h (EmacsScroller.mark, mark_nsterm): Declare.
	* src/alloc.c (garbage_collect) [MAVE_NS]: Call mark_nsterm.
	(Bug#56095)

	(cherry picked from commit 5f1bd872478927ad4bc635502e74628d39885286)

2022-07-16  Stefan Kangas  <stefankangas@gmail.com>

	Fix obsoletion of nntp-authinfo-file

	* lisp/gnus/nntp.el (nntp-authinfo-file): Fix obsoletion.

2022-07-15  Philipp Stephani  <phst@google.com>

	Build Seccomp filter only if we have a 64-bit userspace (Bug#56549)

	* configure.ac (SIZEOF_LONG): New variable.
	* lib-src/Makefile.in (SIZEOF_LONG): New variable; added conditional.

2022-07-14  Stefan Kangas  <stefankangas@gmail.com>

	Update the Samaritan's contact details in M-x doctor

	* lisp/play/doctor.el (doctor-death): Update the Samaritans's contact
	details; anon.twwells.com is no longer valid.  Add link to Wikipedia.

2022-07-14  Eli Zaretskii  <eliz@gnu.org>

	* etc/PROBLEMS: Describe problems with remote files.  (Bug#56499)

2022-07-13  Andrea Corallo  <akrl@sdf.org>

	Remove uneffective test

	* test/src/comp-tests.el (45603-1): Remove test.
	* test/src/comp-resources/comp-test-45603.el: Delete.

2022-07-13  Andrea Corallo  <akrl@sdf.org>

	Mark async worker tmp file as utf-8-emacs-unix (bug#48029)

	* lisp/emacs-lisp/comp.el (comp-final): Mark async worker tmp file
	as utf-8.
	* test/src/comp-tests.el (48029-1): New test.
	* test/src/comp-resources/comp-test-funcs.el
	(comp-test-48029-nonascii-žžž-f): New function.

2022-07-13  Michael Albinus  <michael.albinus@gmx.de>

	Adapt Tramp version (don't merge)

	* doc/misc/trampver.texi:
	* lisp/net/trampver.el: Change version to "2.5.3.28.2".
	(customize-package-emacs-version-alist):
	Add Tramp version integrated in Emacs 28.2.

2022-07-13  Michael Albinus  <michael.albinus@gmx.de>

	Adapt Tramp doc

	* doc/misc/tramp.texi (Configuration): Mention enable-remote-dir-locals.
	(Traces and Profiles): Fix tramp-verbose description.

	* lisp/net/tramp.el (tramp-verbose): Fix docstring.

2022-07-12  Stefan Kangas  <stefankangas@gmail.com>

	Don't mention cl-cXXXr aliases in cl-lib manual

	* doc/misc/cl.texi (Lists, List Functions, Efficiency Concerns): Don't
	mention 'cl-cXXXr' compatibility aliases for built-in 'cXXXr'
	functions.  They shouldn't be used in new code.

2022-07-11  Ken Brown  <kbrown@cornell.edu>

	etc/PROBLEMS: Describe issues with native compilation on Cygwin

2022-07-11  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/find-dired.el (find-dired): Doc fix; add cross-reference.

2022-07-08  Stefan Kangas  <stefankangas@gmail.com>

	Doc fix; don't mention obsolete variable

	* src/window.c (Fset_window_hscroll): Doc fix; don't mention obsolete
	variable.

2022-07-05  Stefan Kangas  <stefankangas@gmail.com>

	Add index entry for "ignore case"

	* doc/emacs/glossary.texi (Glossary): Add index entry for "ignore
	case" pointing to "Case Folding".

2022-07-05  Stefan Kangas  <stefankangas@gmail.com>

	Expand docstrings related to auto-saving

	* lisp/files.el (auto-save-visited-mode):
	* lisp/simple.el (auto-save-mode): Expand docstring.

2022-07-04  Lars Ingebrigtsen  <larsi@gnus.org>

	Don't bug out in manual-html-fix-index-2 on newer makeinfo versions

	Backport from master.

	* admin/admin.el (manual-html-fix-index-2): Don't bug out if the
	makeinfo version doesn't include <ul>.

	(cherry picked from commit e0e3f2b672bc42da52ac9c7596c7560a88684651)

2022-07-04  Lars Ingebrigtsen  <larsi@gnus.org>

	Preserve <title> in the Emacs manuals

	Backport from master.

	* admin/admin.el (manual-html-fix-headers): Preserve the <title>
	element (bug#48334).

	(cherry picked from commit b778e71af7ca8c59917334b4bb1b34cdb52faca9)

2022-07-03  Eli Zaretskii  <eliz@gnu.org>

	Document 'jit-lock-debug-mode'

	* doc/lispref/modes.texi (Other Font Lock Variables): Document
	'jit-lock-debug-mode'.

2022-07-02  Alan Mackenzie  <acm@muc.de>

	* lisp/progmodes/cc-mode.el (c-common-init): Bind case-fold-search to nil

	Backport:  This fixes bug #53605.

2022-07-02  Alan Mackenzie  <acm@muc.de>

	CC Mode: Fix a c-backward-token-2 call wrongly jumping back over macros.

	This fixes bug #56256.

	* lisp/progmodes/cc-fonts.el (c-font-lock-c++-lambda-captures): Replace a
	c-backward-token-2, which could jump back too far leading to an infinite
	loop, with a save-excursion to remember the point we've got to go back to.

2022-07-02  Stefan Kangas  <stefankangas@gmail.com>

	Doc fixes; don't use obsolete names

	* etc/compilation.txt:
	* lisp/mh-e/mh-funcs.el (mh-kill-folder): Don't use obsolete
	names.

2022-07-02  Stefan Kangas  <stefankangas@gmail.com>

	Don't refer to obsolete alias for insert-char

	* lisp/leim/quail/persian.el: Don't refer to obsolete alias for
	insert-char.

2022-07-02  Stefan Kangas  <stefankangas@gmail.com>

	Don't use obsolete face name in manoj-dark-theme

	* etc/themes/manoj-dark-theme.el (change-log-acknowledgment): Don't
	use obsolete/non-existent face name.

2022-07-01  Eli Zaretskii  <eliz@gnu.org>

	Fix "C-u C-x =" for SPC

	* lisp/descr-text.el (describe-char): Don't report 'nobreak-space'
	face for SPC.  (Bug#56337)

2022-06-30  Stefan Kangas  <stefankangas@gmail.com>

	Doc fixes: don't refer to some obsolete items

	* admin/notes/multi-tty:
	* lisp/chistory.el (command-history):
	* lisp/emacs-lisp/nadvice.el:
	* lisp/vc/diff-mode.el: Doc fix; don't refer to obsolete variables and
	functions.

2022-06-30  Stefan Kangas  <stefankangas@gmail.com>

	Remove obsolete cust-print from elisp index

	* doc/lispref/edebug.texi (Printing in Edebug): Remove obsolete
	library "cust-print" from index.

2022-06-30  Stefan Kangas  <stefankangas@gmail.com>

	* admin/make-tarball.txt: Minor clarifications.

2022-06-30  Eli Zaretskii  <eliz@gnu.org>

	Fix external image conversion on MS-Windows

	* lisp/image/image-converter.el (image-converter--convert-magick)
	(image-converter--convert): Force encoding/decoding to avoid any
	text or EOL conversions, since we are reading/writing binary
	data.  (Bug#56317)

2022-06-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* doc/emacs/buffers.texi (Indirect Buffers): Mention modification hook quirk

2022-06-29  Stefan Kangas  <stefankangas@gmail.com>

	Bump Emacs version to 28.1.90

	* README:
	* configure.ac:
	* msdos/sed2v2.inp:
	* nt/README.W32: Bump Emacs version to 28.1.90.

2022-06-29  Stefan Kangas  <stefankangas@gmail.com>

	Update ChangeLog and AUTHORS for 28.1.90 pretest

	* ChangeLog.3:
	* etc/AUTHORS: Update.

2022-06-29  Michael Albinus  <michael.albinus@gmx.de>

	Update Tramp version (don't merge with master)

	* doc/misc/trampver.texi:
	* lisp/net/trampver.el: Change version to "2.5.3".

2022-06-28  Michael Albinus  <michael.albinus@gmx.de>

	Tramp shall not trap unrelated D-Bus errors

	* lisp/net/tramp-gvfs.el (tramp-gvfs-dbus-event-vector): Declare.
	(tramp-gvfs-file-name-handler): Let-bind it.
	(tramp-gvfs-dbus-event-vector): Fix docstring.
	(tramp-gvfs-maybe-open-connection): Do not set it globally.  (Bug#56162)

2022-06-28  Basil L. Contovounesios  <contovob@tcd.ie>

	Fix hash table function return values in manual

	* doc/lispref/hash.texi (Hash Access): Reconcile documented return
	values of puthash and clrhash with their respective
	docstrings (bug#55562).

2022-06-27  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.4-3-g6dc785

2022-06-27  Paul Eggert  <eggert@cs.ucla.edu>

	Mention Solaris 10 'make clean' and 'make check'

	Mention further crashes on Solaris 10

2022-06-26  Paul Eggert  <eggert@cs.ucla.edu>

	Port distribution tarball to Solaris 10

	* make-dist (taropt): Use 'tar -H ustar' to generate a portable
	tar file format instead of a GNU-specific format.  Needed now that
	Emacs tarballs contain file names longer than 100 bytes, e.g.:
	emacs-28.1/test/lisp/gnus/mml-sec-resources/private-keys-v1.d/C072AF82DCCCB9A7F1B85FFA10B802DC4ED16703.key
	emacs-28.1/test/lisp/emacs-lisp/bytecomp-resources/error-lexical-var-with-run-hook-with-args-until-success.el
	Without this patch, extracting a tarball on Solaris 10 fails with
	many diagnostics like “tar: ././@LongLink: typeflag 'L' not
	recognized, converting to regular file”.

	(cherry picked from commit 4410f5d86997b6b238ff05c2ece338b28e1163b1)

2022-06-24  Stefan Kangas  <stefankangas@gmail.com>

	Avoid treating number as an enum in the org manual

	* doc/misc/org.org (The Agenda Dispatcher): Avoid treating number as
	enum.

2022-06-22  Eli Zaretskii  <eliz@gnu.org>

	Improve last change in autotype.texi

	* doc/misc/autotype.texi (Autoinserting): Fix wording.  Suggested
	by Richard Stallman <rms@gnu.org>.

2022-06-21  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/repeat.el (repeat-mode): Fix message format.

2022-06-21  Earl Hyatt  <okamsn@protonmail.com>

	Clarify autotype.texi text slightly

	* doc/misc/autotype.texi (Autoinserting): Make text slightly
	clearer (bug#56118).

2022-06-20  Eli Zaretskii  <eliz@gnu.org>

	Support builds configured with a separate --bindir

	* src/emacs.c (load_pdump): Don't overwrite the leading
	directories of the Emacs executable just because the pdumper file
	was not found in the expected directory relative to the binary.
	This is needed to support builds with a separate --bindir
	configure-time option and native-compilation.  (Bug#55741)

2022-06-20  Stefan Kangas  <stefankangas@gmail.com>

	* doc/misc/eww.texi (Overview, Basics): Fix typos.

2022-06-18  Richard Hansen  <rhansen@rhansen.org>

	Fix invalid defcustom :group when :predicate is used

	* lisp/emacs-lisp/easy-mmode.el (define-globalized-minor-mode): Fix
	invalid `:group' argument for the `-modes' defcustom that is created
	when `:predicate' is used (bug#56049).

2022-06-17  Lars Ingebrigtsen  <larsi@gnus.org>

	Prune the Gnus FAQ of some outdated data

	* doc/misc/gnus-faq.texi (FAQ 9-2): Remove some outdated advice
	(bug#56042).

2022-06-17  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix efaq-w32.texi build warning

	* doc/misc/efaq-w32.texi (Other useful ports): Fix ordering to
	match nodes (or should the nodes be moved instead?).

	Do not merge to master.

2022-06-17  Lars Ingebrigtsen  <larsi@gnus.org>

	Update cl-struct-sequence-type doc string

	* lisp/emacs-lisp/cl-macs.el (cl-struct-sequence-type): Fix doc
	string to reflect what it does (bug#46523).

2022-06-17  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix a tagging problem in tramp.texi

	* doc/misc/tramp.texi (Frequently Asked Questions): Restore an
	@end lisp removed by accident.

2022-06-17  Lars Ingebrigtsen  <larsi@gnus.org>

	Mention face quirks after the final line in the lispref manual

	* doc/lispref/display.texi (Face Attributes): Mention the quirks
	about point after the final line (bug#56011).

2022-06-17  Stefan Kangas  <stefankangas@gmail.com>

	Delete reference to obsolete library complete.el

	* doc/misc/tramp.texi (Frequently Asked Questions): Delete reference
	to obsolete library complete.el.

2022-06-16  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/textmodes/artist.el: Minor doc fixes.

2022-06-16  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/net/tramp.el (tramp-methods): Fix quoting in docstring.

2022-06-16  Arash Esbati  <arash@gnu.org>

	Update MS Windows FAQ for MinGW64-w64/MSYS2

	* doc/misc/efaq-w32.texi (Compiling, Debugging): Mention
	MinGW64-w64/MSYS2 as the preferred way for building Emacs on
	capable systems.
	(Attachments with Gnus): Catch up with emacs-mime.texi in the
	example given.
	(Spell check): Add the availability of GNU Aspell and Hunspell
	in MSYS2 distribution.
	(Other useful ports): Add an entry for MinGW64-w64/MSYS2.
	Fix link for MinGW homepage.
	Remove entry for defunct UWIN project.  (Bug#55930)

2022-06-15  Robert Pluim  <rpluim@gmail.com>

	Describe 'set-file-modes' argument prompting

	* src/fileio.c (Fset_file_modes): Document that FILENAME is prompted
	for.  (Bug#55984)

2022-06-14  Lars Ingebrigtsen  <larsi@gnus.org>

	Revert "Clarify what a Calc registeri in in calc-insert-register"

	This reverts commit 73400e4002ce8fca060093548e6791b3a784eeaa.

	This has been fixed in Emacs 29 by making it possible to use regular registers in calc.

2022-06-13  Lars Ingebrigtsen  <larsi@gnus.org>

	Clarify what a Calc registeri in in calc-insert-register

	* lisp/calc/calc-yank.el (calc-insert-register): Note that these
	aren't normal registers (bug#55943).

2022-06-11  Eli Zaretskii  <eliz@gnu.org>

	Fix doc strings in whitespace.el

	* lisp/whitespace.el (whitespace-style, whitespace-action):
	Untabify the doc strings.  (Bug#55904)

2022-06-10  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of "etags -I"

	* doc/man/etags.1:
	* doc/emacs/maintaining.texi (Create Tags Table): Elaborate on the
	importance of the '-I' option to 'etags'.  (Bug#45246)

2022-06-09  Lars Ingebrigtsen  <larsi@gnus.org>

	Mention the #f syntax from cl-prin1

	* doc/lispref/objects.texi (Special Read Syntax): Mention #f,
	which is in cl-prin1 output (bug#55853).

2022-06-09  Michael Albinus  <michael.albinus@gmx.de>

	Fix file name quoting in tramp-smb.el (do not merge)

	* lisp/net/tramp-smb.el (tramp-smb-handle-write-region): Quote tmpfile.
	(tramp-smb-get-localname): Remove superfluous test.  (Bug#55855)

	* test/lisp/net/tramp-tests.el (tramp-test03-file-name-method-rules):
	Remove superfluous checks.

2022-06-09  Jeff Walsh  <fejfighter@gmail.com>

	Update error message to reflect variable rename

	* src/comp.c (Fcomp_el_to_eln_filename): Update error message.  (Bug#55861)

2022-06-08  Ken Brown  <kbrown@cornell.edu>

	Fix error reporting in process-async-https-with-delay

	* test/src/process-tests.el (process-async-https-with-delay): Use
	'plist-get' instead of 'assq' in testing for a connection error.
	The 'status' variable is a plist, not an alist.  (Bug#55849)

2022-06-08  Stefan Kangas  <stefankangas@gmail.com>

	* doc/misc/org.org: Remove spurious markup.

2022-06-08  Michael Albinus  <michael.albinus@gmx.de>

	Make Tramp version check more robust

	* lisp/net/trampver.el (tramp-repository-branch)
	(tramp-repository-version): Check for "git" executable.

2022-06-07  Eli Zaretskii  <eliz@gnu.org>

	Fix debugging with GDB when a breakpoint has multiple locations

	* lisp/progmodes/gdb-mi.el (gdb-breakpoints--add-breakpoint-row):
	New function, extracted from 'gdb-breakpoints-list-handler-custom'.
	Don't print "in <unknown>" for header-rows of breakpoints with
	multiple locations that don't have a function name attached.
	(gdb-breakpoints-list-handler-custom): Add to the breakpoint table
	also any locations in multiple-location breakpoints, which are
	supported since GDB 6.8.

2022-06-05  Eli Zaretskii  <eliz@gnu.org>

	Update documentation of 'aset' and 'store-substring'

	* doc/lispref/strings.texi (Modifying Strings): Adjust to
	implementation changes: it is possible for the modified string to
	have fewer or more bytes than the original.  Add recommendations
	regarding unibyte vs multibyte strings and characters.  (Bug#55801)

2022-06-04  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.4

2022-06-04  Eli Zaretskii  <eliz@gnu.org>

	Clarify documentation of 'string-to-unibyte'

	* doc/lispref/nonascii.texi (Converting Representations): Clarify
	what 'string-to-unibyte' does.  Reported by Richard Hansen
	<rhansen@rhansen.org>.  (Bug#55777)

2022-06-02  Ikumi Keita  <ikumi@ikumi.que.jp>  (tiny change)

	Improve keystrokes in doc strings in some find-file functions

	* lisp/files.el (find-file):
	(find-file-other-window):
	(find-file-other-frame): Include the correct keymap so that
	keystrokes are displayed better (bug#55761).

2022-06-02  Eli Zaretskii  <eliz@gnu.org>

	Fix segfaults when starting on 80x26 TTY frames

	* src/dispnew.c (adjust_frame_glyphs_for_frame_redisplay): Make
	sure we have valid frame glyph matrices for the interactive
	session.  (Bug#55760)
	(adjust_frame_glyphs): Add assertions for when we fail to allocate
	valid frame glyph matrices for a TTY frame.

2022-06-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Make it explicit that a couple of _s in lispref are underscores

	* doc/lispref/strings.texi (Custom Format Strings):
	* doc/lispref/control.texi (pcase Macro): Make it explicit that
	it's an underscore (bug#55742).

2022-05-31  Eli Zaretskii  <eliz@gnu.org>

	Remove from FAQ the MS-Windows info about BDF fonts

	* doc/misc/efaq.texi (How to add fonts): Remove the MS-Windows
	specific steps, as BDF fonts are no longer supported on
	MS-Windows.  (Bug#55740)

2022-05-31  Ikumi Keita  <ikumi@ikumi.que.jp>  (tiny change)

	Fix Display Property manual example

	* doc/lispref/display.texi (Display Property): Fix syntax of
	example (bug#55736).

2022-05-29  Michael Albinus  <michael.albinus@gmx.de>

	Some Tramp cleanup on MS Windows

	* lisp/net/tramp.el (tramp-restricted-shell-hosts-alist): Do not add
	localhost when `tramp-encoding-shell' is a POSIX shell.

	* test/lisp/net/tramp-tests.el (tramp-test31-interrupt-process):
	Skip on MS Windows.

2022-05-28  Alan Mackenzie  <acm@muc.de>

	do_switch_frame: before leaving mini-window, check other (mru) window is live

	This fixes bug#55684.  There, with a minibuffer-only frame at start up,
	Emacs tried to switch to this frame, whose selected window was the
	mini-window.  There is no other active window in this frame, so the
	attempt to switch to another window failed.

	* src/frame.c (do_switch_frame): On switching to a frame whose selected
	window is as above, before selecting the most recently used window, check
	this ostensible window is an actual live window.  Otherwise leave the
	mini-window selected.

2022-05-28  Eli Zaretskii  <eliz@gnu.org>

	Fix commands used to produce on-line HTML docs

	* admin/admin.el (manual-meta-string): Only include the first
	line, and move the rest...
	(manual-links-string): ...to this new string.
	(manual-html-fix-headers): Don't remove the '<meta name=' elements
	produced by makeinfo, especially not the 'name="viewport"' one,
	which is essential for viewing the docs on mobile devices.
	Reported by "Facundo Lander via RT" <webmasters-comment@gnu.org>,
	see gnu.org ticket #1840138.

2022-05-28  Eli Zaretskii  <eliz@gnu.org>

	Fix a bad cross-reference in elisp.pdf

	* doc/lispref/control.texi (pcase Macro): Fix a conditional
	cross-reference (bug#55689).

2022-05-28  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of 'string-pad'

	* doc/lispref/strings.texi (Creating Strings): Fix description of
	'string-pad'.  (Bug#55688)

2022-05-27  Juri Linkov  <juri@linkov.net>

	Fix more occurrences of renamed kmacro-keymap command

	* doc/emacs/kmacro.texi (Basic Keyboard Macro): Fix documentation
	after recent kmacro-redisplay command name change.

2022-05-27  Eli Zaretskii  <eliz@gnu.org>

	Mention "unspecified-fg" and "unspecified-bg" in some doc strings

	* lisp/faces.el (face-foreground, face-background)
	(foreground-color-at-point, background-color-at-point):
	* lisp/color.el (color-name-to-rgb): Mention "unspecified-fg" and
	"unspecified-bg" pseudo-colors on TTY frames.  (Bug#55623)

2022-05-26  Hayden Shenk  <hayden.shenk@zetier.com>  (tiny change)

	Fix format specifiers in tramp-adb.el

	* lisp/net/tramp-adb.el (tramp-adb-get-device): Fix format
	specifiers for port.  (Bug#55651)

2022-05-22  Damien Cassou  <damien@cassou.me>

	Improve documentation of mail-user-agent.

	* doc/emacs/sending.texi (Mail Methods):
	* lisp/simple.el (mail-user-agent): Mention additional options
	of non-bundled MUA.  (Bug#5569)

2022-05-21  Eli Zaretskii  <eliz@gnu.org>

	More fixes in abbrev.el doc strings

	* lisp/abbrev.el (inverse-add-global-abbrev, inverse-add-mode-abbrev):
	Document the effect of negative ARG.  (Bug#55527)

2022-05-21  Lars Ingebrigtsen  <larsi@gnus.org>

	Add note about Tramp completion to completion-styles doc string

	* lisp/minibuffer.el (completion-styles): Add note about Tramp
	completion (bug#37954).

2022-05-21  Arash Esbati  <arash@gnu.org>

	Remove mention of removed nnimap-nov-is-evil variable

	* doc/misc/gnus.texi (Slow/Expensive Connection): Remove mention
	of removed nnimap-nov-is-evil variable (bug#55556).

2022-05-21  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation strings and prompts in abbrev.el

	* lisp/abbrev.el (abbrev-file-name, only-global-abbrevs)
	(copy-abbrev-table, insert-abbrevs, list-abbrevs)
	(abbrev-table-name, edit-abbrevs, define-abbrevs)
	(read-abbrev-file, quietly-read-abbrev-file, write-abbrev-file)
	(abbrev-edit-save-to-file, abbrev-edit-save-buffer)
	(add-mode-abbrev, add-global-abbrev, inverse-add-mode-abbrev)
	(inverse-add-global-abbrev, abbrev-prefix-mark)
	(expand-region-abbrevs, abbrev-table-get, abbrev-table-put)
	(abbrev-get, abbrev-minor-mode-table-alist, abbrevs-changed)
	(abbrev-all-caps, last-abbrev-text, last-abbrev-location)
	(clear-abbrev-table, define-abbrev, define-global-abbrev)
	(define-mode-abbrev, abbrev--active-tables, abbrev--symbol)
	(abbrev-symbol, abbrev-expansion, abbrev-insert)
	(abbrev-expand-function, abbrev--suggest-above-threshold)
	(abbrev--suggest-saved-recommendations)
	(abbrev--suggest-shortest-abbrev, abbrev--suggest-get-totals)
	(insert-abbrev-table-description, define-abbrev-table)
	(abbrev-table-menu): Fix doc strings: wording, punctuation,
	clarity.
	(add-abbrev, inverse-add-abbrev): Improve the prompt text.
	(Bug#55527)

2022-05-20  Alan Mackenzie  <acm@muc.de>

	Restore the Fselect_window call in gui_consider_frame_title.

	This fixes bug #55412.  The call to Fselect_window was removed on 2021-03-21
	in the commit "Prevent open minibuffers getting lost when their frame gets
	deleted".  This call is actually needed to determine current elements of the
	pertinent window and frame when these are used in the frame title.

	* src/frame.c (do_switch_frame): When the selected window in the target frame
	is the mini-window, switch away from this window unless there is a valid
	minibuffer there.

	* src/frame.h (struct frame): Add an incidental comment about the element
	selected_window.

	* src/minibuf.c (move_minibuffers_onto_frame): No longer set the selected
	window of the source frame.  This action is now performed later, on returning
	to that frame, in do_switch_frame when needed (see above).

	* src/xdisp.c (gui_consider_frame_title): Replace the Fselect_window call and
	associated ancillary settings.

2022-05-20  Eli Zaretskii  <eliz@gnu.org>

	Advise against settings in the MS-Windows system registry

	* doc/emacs/cmdargs.texi (MS-Windows Registry): Advise against
	setting environment variables in the system registry.  (Bug#16429)

2022-05-17  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix kmacro-keymap binding after previous change

	* lisp/kmacro.el (kmacro-keymap): Fix binding after
	kmacro-redisplay command name change.

2022-05-17  Lars Ingebrigtsen  <larsi@gnus.org>

	Add glossary entries for "interactively"

	* doc/emacs/glossary.texi (Glossary): Mention "interactively" and
	how it relates to the "command" concept (bug#55461).

2022-05-17  Eli Zaretskii  <eliz@gnu.org>

	Fix the name of a kmacro command.

	* lisp/kmacro.el (kmacro-redisplay): Rename from
	'kdb-macro-redisplay' (which was wrong and included a typo).

	* etc/NEWS: Announce the change.  (Bug#55471)

2022-05-17  Michael Albinus  <michael.albinus@gmx.de>

	Fix Tramp sshfs tests (don't merge)

	* test/lisp/net/tramp-tests.el (tramp-fuse-remove-hidden-files): Declare.
	(tramp-test16-directory-files)
	(tramp-test16-file-expand-wildcards)
	(tramp-test26-file-name-completion, tramp--test-check-files): Use it.
	(tramp--test-check-files): Delete directory recursively.

2022-05-17  Michael Albinus  <michael.albinus@gmx.de>

	Some minor Tramp fixes

	* lisp/net/tramp-cmds.el (tramp-list-tramp-buffers)
	(tramp-list-remote-buffers): Add ;;;###tramp-autoload cookie.

	* lisp/net/tramp-fuse.el (tramp-fuse-remove-hidden-files): New defvar.
	(tramp-fuse-remove-hidden-files): Use it.

	* lisp/net/tramp-gvfs.el (tramp-gvfs-handler-askquestion):
	Keep regression tests running.

2022-05-15  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.3-6-gef41f3

2022-05-15  Michael Albinus  <michael.albinus@gmx.de>

	Hide temporary FUSE files in Tramp

	* lisp/net/tramp-fuse.el (tramp-fuse-remove-hidden-files): New defsubst.
	(tramp-fuse-handle-directory-files)
	(tramp-fuse-handle-file-name-all-completions): Use it.

2022-05-15  Michael Albinus  <michael.albinus@gmx.de>

	* test/lisp/net/tramp-tests.el (tramp-test27-load): Adapt test.  Don't merge

2022-05-13  Po Lu  <luangruo@yahoo.com>

	Fix tooltip face overwriting dragged text strings during mouse DND

	* lisp/mouse.el (mouse-drag-and-drop-region): Copy
	`text-tooltip' before showing it.  Do not merge to master.

2022-05-13  Eli Zaretskii  <eliz@gnu.org>

	Fix lexical-binding fallout in vhdl-mode.el

	* lisp/progmodes/vhdl-mode.el (arch-alist, pack-alist)
	(file-alist, unit-alist, rule-alist): Defvar them, since vhdl-aput
	expects them to be dynamically bound.  (Bug#55389)
	(vhdl-speedbar-insert-hierarchy): Rename the PACK-ALIST argument
	to PACKAGE-ALIST, to avoid shadowing the global variable.

2022-05-12  Michael Albinus  <michael.albinus@gmx.de>

	Fix ControlPath quoting in Tramp

	* lisp/net/tramp-sh.el (tramp-ssh-controlmaster-options):
	Adapt docstring.  Do not quote ControlPath.  Reported by Daniel
	Kessler <kesslerd@umich.edu>.

2022-05-09  Eli Zaretskii  <eliz@gnu.org>

	Remove the AUCTeX subsection from MS-Windows FAQ

	* doc/misc/efaq-w32.texi (AUCTeX): Remove the subsection, it is no
	longer useful.  (Bug#55330)

2022-05-09  Arash Esbati  <arash@gnu.org>

	Update AUCTeX FAQ entry

	* doc/misc/efaq-w32.texi (AUCTeX): AUCTeX project isn't providing
	pre-compiled versions for Windows anymore (bug#55330).

2022-05-09  Lars Ingebrigtsen  <larsi@gnus.org>

	Update string-to-number documentation to bignum Emacs

	* doc/lispref/strings.texi (String Conversion): string-to-number
	no longer converts integers to floating point numbers (bug#55334).

2022-05-09  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix doc string references to tags-loop-continue

	* lisp/vc/vc-dir.el (vc-dir-search, vc-dir-query-replace-regexp):
	Fix reference to obsolete tags-loop-continue (bug#55311).

2022-05-08  Visuwesh M  <visuweshm@gmail.com>

	dired-do-query-replace-regexp doc string fix

	* lisp/dired-aux.el (dired-do-query-replace-regexp): Refer
	'fileloop-continue' instead of the obsolete command
	'tags-loop-continue'.  (Bug#55311)

	(cherry picked from commit 4c505203f9171886f47638779326e257a95a1d79)

2022-05-08  Alan Mackenzie  <acm@muc.de>

	Linux console: don't translate ESC TAB to `backtab' in input-decode-map.

	This translation happened after the terminfo entry for <shift>TAB in the linux
	section was changed to kcbt=\E^I in ncurses version 6.3.

	* lisp/term/linux.el (terminal-init-linux): Add a define-key form to remove
	the entry for "\e\t" from input-decode-map.

	* etc/PROBLEMS: Add a new section under "character terminals" about S-TAB
	wrongly doing the same thing as M-TAB, giving tips about amending the Linux
	keyboard layout.

2022-05-08  Michael Albinus  <michael.albinus@gmx.de>

	Handle changed scp protocol in Tramp, don't merge

	* lisp/net/tramp-sh.el (tramp-scp-force-scp-protocol): New defvar.
	(tramp-scp-force-scp-protocol): New defun.
	(tramp-do-copy-or-rename-file-out-of-band): Use it.
	(tramp-methods) <scp, scpx>: Use "%y".

	* lisp/net/tramp.el (tramp-methods): Adapt docstring.

2022-05-06  Michael Albinus  <michael.albinus@gmx.de>

	Fix bug#55274

	* lisp/dired-aux.el (dired-do-compress-to): Use `file-local-name'
	for shell out-file.  (Bug#55274)

2022-05-06  Eli Zaretskii  <eliz@gnu.org>

	Provide reference for OTF tags in the ELisp manual

	* doc/lispref/display.texi (Low-Level Font): Provide the canonical
	reference URL for OTF tags.

2022-05-05  Lars Ingebrigtsen  <larsi@gnus.org>

	Be more resilient towards errors during error handling

	* src/print.c (print_error_message): Avoid infinite recursion if
	`substitute-command-keys' bugs out (bug#55269).

	(cherry picked from commit 8364f058b821eba31f84dcded175cca403a965a5)

2022-04-28  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of font- and face-related attribute functions

	* lisp/faces.el (face-attribute):
	* src/xfaces.c (Fx_family_fonts):
	* src/font.c (Ffont_get, Ffont_put): Improve and clarify the doc
	strings.

	* doc/lispref/display.texi (Low-Level Font): Document the :type
	attribute of a font.  Improve documentation of 'font-get' and
	'font-put'.
	(Attribute Functions): Add cross-reference to the description of
	face attributes.

2022-04-25  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.3-3-gd54104

2022-04-24  Eli Zaretskii  <eliz@gnu.org>

	Improve indexing in "Programmed Completion"

	* doc/lispref/minibuf.texi (Programmed Completion): Improve
	indexing.  (Bug#55095)

2022-04-24  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'set-fontset-font'

	* doc/lispref/display.texi (Fontsets):
	* src/fontset.c (Fset_fontset_font): Improve and clarify the
	documentation of 'set-fontset-font'.  Rename the arguments to be
	more self-explanatory.  (Bug#55086)

2022-04-23  Michael Albinus  <michael.albinus@gmx.de>

	Fix problem with Solaris ls in Tramp

	* lisp/net/tramp-sh.el (tramp-sunos-unames): Move up.
	(tramp-sh--quoting-style-options): Handle erroneous Solaris ls.

2022-04-22  Eli Zaretskii  <eliz@gnu.org>

	Another fix for non-ASCII 'overlay-arrow-string'

	* src/xdisp.c (get_overlay_arrow_glyph_row): Fix yet another place
	that assumed each character is a single byte.

2022-04-21  Eli Zaretskii  <eliz@gnu.org>

	Avoid a redisplay loop when 'overlay-arrow-string' is non-ASCII

	* src/xdisp.c (get_overlay_arrow_glyph_row): Don't assume every
	character in 'overlay-arrow-string' is one byte long.  Reported by
	Yuri D'Elia <wavexx@thregr.org>.

2022-04-21  Eli Zaretskii  <eliz@gnu.org>

	Add minimum instructions to 'query-replace' commands

	* lisp/vc/vc-dir.el (vc-dir-query-replace-regexp):
	* lisp/textmodes/reftex-global.el (reftex-query-replace-document):
	* lisp/progmodes/project.el (project-query-replace-regexp):
	* lisp/progmodes/etags.el (tags-query-replace):
	* lisp/progmodes/ebrowse.el (ebrowse-tags-query-replace):
	* lisp/isearch.el (isearch-query-replace, isearch-occur):
	* lisp/emulation/viper-cmd.el (viper-query-replace):
	* lisp/dired-aux.el (dired-do-query-replace-regexp)
	(dired-do-find-regexp-and-replace):
	* lisp/progmodes/xref.el (xref-query-replace-in-results):
	* lisp/replace.el (query-replace, query-replace-regexp)
	(query-replace-regexp-eval, map-query-replace-regexp): Add minimal
	instructions for dealing with matches, with a link to the command
	that shows the full instructions.  (Bug#55050)

2022-04-21  Eli Zaretskii  <eliz@gnu.org>

	Fix customization-group of 'python-forward-sexp-function'

	* lisp/progmodes/python.el (python-forward-sexp-function): Make it
	be part of both 'python' and 'python-flymake' groups.  (Bug#55027)
	Do not merge to master.

2022-04-20  Paul Eggert  <eggert@cs.ucla.edu>

	Update from gnulib

	(cherry picked from commit 992cf3cb675e074079341cc54c3b16d37a8b9ca8)

	This is a partial backport from master: it only includes the changes below.

	* lib/mini-gmp.c (gmp_assert_nocarry): Avoid many Clang
	unused-variable warnings when building with optimization.
	* lib/verify.h (_GL_HAVE__STATIC_ASSERT): Modify condition for using
	_Static_assert to cope with older Apple builds of Clang exposing
	misleading compiler version numbers.  See discussion starting at
	https://lists.gnu.org/archive/html/emacs-devel/2022-04/msg00779.html

2022-04-20  Lars Ingebrigtsen  <larsi@gnus.org>

	Revert prompting changes in viper-cmd

	* lisp/emulation/viper-cmd.el (viper-quote-region)
	(viper-read-string-with-history, viper-query-replace): Revert
	prompting changes done in 50512e3 -- the way viper prompts in
	command mode is special (bug#55007).

	Do not merge to master.

2022-04-19  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix regression with multiple mode: entries in the prop line

	* lisp/files.el (hack-local-variables): Fix regression with multiple
	mode: entries in the prop line.

	Do not merge to master.

2022-04-18  Lars Ingebrigtsen  <larsi@gnus.org>

	Avoid hangs in python-mode with debug-on-error set

	* lisp/progmodes/python.el (python-nav-end-of-statement): Avoid
	using cl-assert here, because this is called from the font-lock
	machinery, and if debug-on-error is set here, we'll hang Emacs
	(bug#54996).

	Do not merge to master.

2022-04-18  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix major-mode setting regression when there's a mode: cookie

	* lisp/files.el (hack-local-variables): Fix regression in setting
	the major mode when there are mode: cookies in the file (bug#54993).

	Do not merge to master.

2022-04-17  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.2-38-g682ccd

2022-04-17  Eli Zaretskii  <eliz@gnu.org>

	Revert "Don’t assume openat"

	This reverts commit 3cccf0a9107d585173e527550bbc45253624ca2e.

	This is a change with far-reaching effects on MS-Windows at the least,
	where file-related APIs are shadowed to support transparent support
	for UTF-8 encoded file names.  Making such changes on a stable branch
	for the benefit of a proprietary platform with a 13-year old OS is a
	tail wagging the dog.  Please don't do that without discussing first.

2022-04-17  Paul Eggert  <eggert@cs.ucla.edu>

	Don’t assume openat

	Use openat only on platforms with O_PATH.
	This ports to OS X 10.9 and earlier.
	Problem reported by Keith David Bershatsky in:
	https://lists.gnu.org/r/emacs-devel/2022-04/msg00805.html
	* lib-src/emacsclient.c (local_sockname): Use open, not openat.
	* src/sysdep.c (sys_openat): New static function,
	which uses openat only if O_PATH is defined.
	(emacs_openat): Use it instead of openat.
	(emacs_openat_noquit): Remove.
	(emacs_open_noquit): Reimplement as per the old emacs_openat_noquit,
	but use plain 'open'.

2022-04-17  Paul Eggert  <eggert@cs.ucla.edu>

	Fix GC bug in filelock.c

	Fix a bug where if GC occurred at the wrong moment when locking a
	file, the lock file’s name was trashed so file locking did not work.
	This bug was introduced in Emacs 28.1.  The bug sometimes caused
	filelock-tests-detect-external-change test failures on Fedora 35
	x86-64 in an en_US.utf8 locale.
	* src/filelock.c (lock_file_1, current_lock_owner, lock_if_free)
	(lock_file, unlock_file, Ffile_locked_p):
	Use Lisp_Object, not char *, for string, so that GC doesn’t trash
	string contents.
	(make_lock_file_name): Return the encoded name, not the original.
	All callers changed.

2022-04-16  Lars Ingebrigtsen  <larsi@gnus.org>

	Clarify when mode tagging is used

	* etc/NEWS: Clarify when mode tagging is used (bug#54964).

2022-04-16  Lars Ingebrigtsen  <larsi@gnus.org>

	Further vcs-cvs/rcs-responsible-p updates from master

	* lisp/vc/vc-bzr.el (vc-bzr-responsible-p):
	* lisp/vc/vc-sccs.el (vc-sccs-responsible-p):
	* lisp/vc/vc-dav.el (vc-dav-responsible-p): Update doc string.

	* lisp/vc/vc-rcs.el (vc-rcs-responsible-p):
	* lisp/vc/vc-cvs.el (vc-cvs-responsible-p): Further fixes from
	master.

	* lisp/vc/vc-src.el (vc-src-responsible-p): Return the directory.

	* lisp/vc/vc.el: Update comments.

2022-04-16  Mattias Engdegård  <mattiase@acm.org>

	Fix builds on older versions of macOS

	This adds back macOS-specific code replaced earlier (bug#48548),
	specifically to fix build errors on macOS 10.7.5.  See discussion at
	https://lists.gnu.org/archive/html/emacs-devel/2022-04/msg00779.html .

	* src/sysdep.c (HAVE_RUSAGE_INFO_CURRENT, HAVE_PROC_PIDINFO): New.
	(system_process_attributes): Use alternative code or exclude features
	when building on older macOS versions.

2022-04-16  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of Outline minor mode options

	* lisp/outline.el (outline-minor-mode-cycle-filter)
	(outline-minor-mode-cycle, outline-minor-mode-highlight)
	(outline-cycle, outline-cycle-buffer): Doc fixes.  (Bug#54967)

2022-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve discoverability of 'insert-directory-program'

	* lisp/files.el (insert-directory-program): Mention 'dired' in the
	doc string.
	* lisp/dired.el (dired): Mention 'insert-directory-program' in the
	doc string.  (Bug#54962)

2022-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix cursor motion under truncate-lines with Flymake fringe indicator

	* src/indent.c (Fvertical_motion): Don't consider fringe bitmaps
	as "images" for the purpose of vertical-motion logic dealing with
	overshooting buffer positions.  (Bug#54946)

2022-04-14  Lars Ingebrigtsen  <larsi@gnus.org>

	Make all vc-*-responsible-p functions return a string

	* lisp/vc/vc-sccs.el (vc-sccs-responsible-p):
	* lisp/vc/vc-rcs.el (vc-rcs-responsible-p):
	* lisp/vc/vc-dav.el (vc-dav-responsible-p):
	* lisp/vc/vc-cvs.el (vc-cvs-responsible-p): Return a file name
	instead of t when we get a match (which is what
	vc-backend-for-registration expects) (bug#51800).

	This fixes the regression reported in bug#54935.

	Do not merge to master.

2022-04-14  Eli Zaretskii  <eliz@gnu.org>

	Describe problems with invoking Python on MS-Windows

	* etc/PROBLEMS: Describe problems with running an inferior Python
	interpreter due to the MS-Windows "App Execution Aliases" feature.
	(Bug#54860)

2022-04-13  Eli Zaretskii  <eliz@gnu.org>

	A better fix for bug#54800

	* lisp/calc/calc.el (calc-align-stack-window): Improve scrolling
	when windows have non-integral dimensions.

2022-04-13  Lars Ingebrigtsen  <larsi@gnus.org>

	Add a comment about cl-concatenate

	* lisp/emacs-lisp/cl-extra.el (cl-concatenate): Add a comment.

2022-04-13  Lars Ingebrigtsen  <larsi@gnus.org>

	Revert "Make cl-concatenate an alias of seq-concatenate"

	This reverts commit 78f76fe16e2737b40694f82af28d17a90a21ed7b.

	The commit made calls to cl-concatenate bug out, since
	autoloading defaliases doesn't work very well (bug#54901).

2022-04-12  Eli Zaretskii  <eliz@gnu.org>

	Fix 'window-text-pixel-width' when starting from display property

	* src/xdisp.c (Fwindow_text_pixel_size): Handle the case where
	there's a display property at START, and move_it_to overshoots.
	Do not merge to master.  (Bug#54862)

2022-04-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/gnus/mm-encode.el (mm-default-file-encoding): Fix "when" arg

2022-04-11  Eli Zaretskii  <eliz@gnu.org>

	Fix default-directory of buffers visiting files in renamed directories

	* lisp/dired-aux.el (dired-rename-file): Take note of whether FILE
	is a directory before it is renamed, which makes it impossible to
	determine if it was a directory.
	(dired-rename-subdir, dired-rename-subdir-1): Revert to using
	dired-in-this-tree-p instead of file-in-directory-p, for the
	benefit of files that were renamed/removed, because
	file-in-directory-p returns nil in those cases.  (Bug#54838)

2022-04-11  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix a kill-append regression

	* lisp/simple.el (kill-append): Fix a regression when
	kill-ring-max is zero (bug#54842).

2022-04-10  Eli Zaretskii  <eliz@gnu.org>

	* doc/misc/eww.texi (Advanced): Correct outdated info (bug#54839).

2022-04-10  Eli Zaretskii  <eliz@gnu.org>

	Clean up the MSDOS port

	* src/msdos.h (tcdrain): Redirect to '_dos_commit'.
	(openat, fchmodat, futimens, utimensat): Add prototypes.

	* msdos/sed1v2.inp (MAKE_PDUMPER_FINGERPRINT): Fix indentation, so
	that Make won't consider this line a command.
	($(etc)/DOC): Chdir back to ../src, since "make-docfile -d" leaves
	us in a wrong directory.
	* msdos/sedlibmk.inp (GL_GNULIB_GETRANDOM, GL_GNULIB_MEMMEM)
	(GL_GNULIB_SIGDESCR_NP): Define to 1, to get the prototypes from
	Gnulib headers.

2022-04-10  Daniel Martín  <mardani29@yahoo.es>

	Fix typo in next-error-find-buffer-function

	* lisp/simple.el (next-error-find-buffer-function): Fix typo
	(bug#54830).

2022-04-10  Lars Ingebrigtsen  <larsi@gnus.org>

	Revert "Make shell-resync-dirs handle whitespace in directory names"

	This reverts commit 90e65c826fab2092ad2099d7763538194c93e021.

	This change led to hangs (bug#54776).

	Do not merge to master; it has been fixed in a more encompassing way there.

2022-04-09  Eli Zaretskii  <eliz@gnu.org>

	Fix scrolling of the stack window in Calc

	* lisp/calc/calc.el (calc-align-stack-window): Fix off-by-one
	error in computing the window-start point.  (Bug#54800)

2022-04-08  Eli Zaretskii  <eliz@gnu.org>

	Update and fix instructions and scripts for updating the Web pages

	* admin/admin.el (manual-html-fix-index-2): Support Texinfo 6.8
	and later by not converting TOC menus into tables.  (Bug#49719)
	* admin/upload-manuals (New directory): Invoke "cvs add" in
	$webdir, to pick up the correct CVSROOT.
	* admin/make-tarball.txt: Update the section about the Emacs Web
	pages.

	* etc/refcards/Makefile (pl-refcard.dvi): If mex.fmt cannot be
	found, invoke 'mex' instead of 'tex'.

2022-04-08  Michael Albinus  <michael.albinus@gmx.de>

	Extend tramp-archive-test45-auto-load

	* test/lisp/net/tramp-archive-tests.el (tramp-archive-test45-auto-load):
	Extend test.

2022-04-08  Michael Albinus  <michael.albinus@gmx.de>

	Ensure local `default-directory' in Tramp when needed

	* lisp/net/tramp.el (tramp-process-running-p): Ensure local
	`default-directory' when calling `list-system-processes' and
	`process-attributes'.

2022-04-08  Eli Zaretskii  <eliz@gnu.org>

	Clarify "idleness" in the ELisp manual

	* doc/lispref/os.texi (Idle Timers): Clarify that waiting for
	input with timeout doesn't make Emacs idle.  Suggested by Ignacio
	<ignaciocasso@hotmail.com>.  (Bug#54371)

2022-04-07  Jürgen Hötzel  <juergen@archlinux.org>

	Use correct signal oldset in posix_spawn implementation

	posix_spawn was restoring the wrong signal set, which still had
	SIGCHLD and SIGINT masked, causing problems with child processes that
	spawned child processes.  (Bug#54667)

	See the thread ending at
	https://lists.gnu.org/archive/html/emacs-devel/2022-03/msg00067.html
	for more details.

	* src/callproc.c (emacs_spawn): Pass oldset parameter.
	(emacs_posix_spawn_init_attributes): Use correct oldset.
	(emacs_posix_spawn_init): Remove intermediate function.

	(cherry picked from commit 8103b060d89ac63a12c439087bd46c30da72cd97)

2022-04-07  Felix Dietrich  <felix.dietrich@sperrhaken.name>  (tiny change)

	Fix error in tramp-archive-autoload-file-name-handler

	* lisp/net/tramp-archive.el (tramp-archive-autoload-file-name-handler):
	Always call `tramp-autoload-file-name'.  Otherwise, when
	`tramp-archive-enabled’ is nil and
	`tramp-archive-autoload-file-name-handler’ is in the
	`file-name-handler-alist’ results in an error “Invalid handler in
	`file-name-handler-alist” once Emacs calls
	`tramp-archive-autoload-file-name-handler’ with a handler that
	does not expect nil.  Always returning nil is also false in
	general.

2022-04-07  Michael Albinus  <michael.albinus@gmx.de>

	Commit missing file from previous commit (Do not merge with master)

	Commit missing file from previous commit

2022-04-07  Michael Albinus  <michael.albinus@gmx.de>

	Merge with Tramp 2.5.2.3 (Do not merge with master)

	* doc/misc/tramp.texi (Archive file names): Explicitly say how to
	open an archive with Tramp (Bug#25076).

	* doc/misc/trampver.texi:
	* lisp/net/trampver.el: Change version to "2.5.3-pre".

	* lisp/net/tramp-adb.el (tramp-adb-handle-process-file)
	* lisp/net/tramp-sh.el (tramp-sh-handle-process-file):
	* lisp/net/tramp-smb.el (tramp-smb-handle-process-file):
	* lisp/net/tramp-sshfs.el (tramp-sshfs-handle-process-file):
	Improve implementation.  (Bug#53854)

	* lisp/net/tramp-adb.el (tramp-adb-tolerate-tilde):
	* lisp/net/tramp-sshfs.el (tramp-sshfs-tolerate-tilde):
	New defuns.  Advice `shell-mode' with them.

	* lisp/net/tramp.el (tramp-register-autoload-file-name-handlers):
	* lisp/net/tramp-archive.el (tramp-register-archive-file-name-handler):
	Check, whether the real file name handler is already registered.
	rules.  (Bug#54542)

	* lisp/net/tramp.el (tramp-autoload-file-name-handler)
	(tramp-register-autoload-file-name-handlers)
	(tramp-unload-file-name-handlers, tramp-unload-tramp):
	* lisp/net/tramp-archive.el (tramp-archive-autoload-file-name-regexp)
	(tramp-archive-autoload-file-name-handler)
	(tramp-register-archive-file-name-handler):
	Add `tramp-autoload' property.

	* lisp/net/tramp-crypt.el (tramp-crypt-file-name-handler-alist):
	* lisp/net/tramp-rclone.el (tramp-rclone-file-name-handler-alist):
	* lisp/net/tramp-sudoedit.el (tramp-sudoedit-file-name-handler-alist):
	* lisp/net/tramp-sshfs.el (tramp-sshfs-file-name-handler-alist):
	Use `tramp-handle-file-notify-add-watch',
	`tramp-handle-file-notify-rm-watch' and
	`tramp-handle-file-notify-valid-p'.

	* lisp/net/tramp-crypt.el (tramp-crypt-file-name-handler-alist):
	Use `tramp-handle-insert-file-contents'.

	* lisp/net/tramp-gvfs.el (tramp-gvfs-maybe-open-connection):
	* lisp/net/tramp-rclone.el (tramp-rclone-maybe-open-connection):
	* lisp/net/tramp-sshfs.el (tramp-sshfs-maybe-open-connection):
	* lisp/net/tramp-sudoedit.el
	(tramp-sudoedit-maybe-open-connection): Do not set "lock-pid"
	connection-property.
	(tramp-sudoedit-handle-delete-file): Use "rm -f".

	* lisp/net/tramp-gvfs.el (tramp-gvfs-handle-file-executable-p):
	* lisp/net/tramp-sh.el (tramp-sh-handle-file-executable-p):
	Check also for setuid/setgid bit.
	(tramp-gvfs-handle-expand-file-name):
	Respect `tramp-tolerate-tilde'.

	* lisp/net/tramp-sh.el (tramp-sh-handle-insert-directory):
	* lisp/net/tramp-smb.el (tramp-smb-handle-insert-directory):
	Do not modify disk space information when
	`dired--insert-disk-space' is available.  (Bug#54512)

	* lisp/net/tramp-sh.el (tramp-maybe-open-connection): Extend suppression
	(tramp-get-remote-dev-tty): New defun.
	(tramp-sh-handle-make-process): Use it.

	* lisp/net/tramp-sshfs.el (tramp-methods) <sshfs>:
	Add "-t -t" to `tramp-login-args'.
	Add "-o dir_cache=no" to `tramp-mount-args'.  (Bug#54126)
	Add "-o transform_symlinks" to `tramp-mount-args'.
	(tramp-sshfs-file-name-handler-alist):
	Use `tramp-sshfs-handle-file-writable-p'.
	(tramp-sshfs-handle-file-writable-p): New defun.  (Bug#54130)
	(tramp-sshfs-handle-write-region): Set file modification time.
	(Bug#54016)
	(tramp-sshfs-file-name-handler-alist):
	Use `tramp-sshfs-handle-set-file-times'.
	(tramp-sshfs-handle-set-file-times): New defun.

	* test/lisp/net/tramp-tests.el (tramp--test-expensive-test-p):
	Rename from `tramp--test-expensive-test'.  Make it a defun.  Adapt
	all callees.
	(tramp-test07-file-exists-p, tramp-test14-delete-directory)
	(tramp-test18-file-attributes, tramp-test20-file-modes)
	(tramp-test28-process-file, tramp-test29-start-file-process)
	(tramp-test30-make-process, tramp-test32-shell-command)
	(tramp-test33-environment-variables, tramp--test-check-files)
	(tramp--test-special-characters, tramp-test46-unload): Adapt tests.
	(tramp-test39-detect-external-change): New test.
	(tramp-test29-start-file-process)
	(tramp--test--deftest-direct-async-process)
	(tramp-test30-make-process, tramp-test31-interrupt-process)
	(tramp-test34-explicit-shell-file-name)
	(tramp-test44-asynchronous-requests):
	Add :tramp-asynchronous-processes tag.
	(tramp--test-asynchronous-processes-p): New defun.
	(tramp--test-hpux-p, tramp--test-macos-p): Protect against errors.

2022-04-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	cl-generic.el: Fix bug#46722

	Fix longstanding bug due to unexpected interference via side-effect.

	* lisp/emacs-lisp/cl-generic.el (cl--generic-get-dispatcher):
	Copy the `dispatch` arg before storing it into the hash-table.

	Backport from `master` (cherrypick from commit 61f8f7f68f).

2022-04-05  Eli Zaretskii  <eliz@gnu.org>

	Fix fallout from lexical-binding in vhdl-mode.el

	* lisp/progmodes/vhdl-mode.el (vhdl-update-sensitivity-list): Fix
	production of a list with embedded function calls.  (Bug#54730)

2022-04-03  Eli Zaretskii  <eliz@gnu.org>

	Update logs and HISTORY for Emacs 28.1

	* ChangeLog.3:
	* etc/HISTORY:
	* etc/AUTHORS: Update for Emacs 28.1 release.

2022-04-03  Eli Zaretskii  <eliz@gnu.org>

	Bump Emacs version to 28.1

	* README:
	* configure.ac:
	* nt/README.W32:
	* msdos/sed2v2.inp: Bump Emacs version to 28.1

2022-03-30  Tassilo Horn  <tsdh@gnu.org>

	dired: implement feature from 7b50ed553f differently

	* lisp/dired.el (dired-buffers-for-dir): Restore to emacs-27 version.
	(dired-buffers-for-dir-or-subdir): New function.
	(dired-clean-up-after-deletion): Use dired-buffers-for-dir-or-subdir
	instead dired-buffers-for-dir.

2022-03-30  Eli Zaretskii  <eliz@gnu.org>

	Fix regression in 'dired-buffers-for-dir'

	* lisp/dired.el (dired-buffers-for-dir): Fix inadvertently swapped
	arguments.  (Bug#54636)

2022-03-27  Eli Zaretskii  <eliz@gnu.org>

	* lisp/desktop.el (desktop-read): Clarify warning text.

2022-03-26  Po Lu  <luangruo@yahoo.com>

	* doc/emacs/anti.texi (Antinews): Unannounce removal of Motif.

2022-03-25  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix eshell-explicit-command-char doc string typo

	* lisp/eshell/esh-ext.el (eshell-explicit-command-char): Fix typo
	in doc string (bug#54567).

2022-03-24  Eli Zaretskii  <eliz@gnu.org>

	Clarify the description of "selected tags table"

	* doc/emacs/maintaining.texi (Select Tags Table): Clarify the
	distinction between the "selected tags table" and the "current
	list of tags tables".  (Bug#54543)

2022-03-21  Lars Ingebrigtsen  <larsi@gnus.org>

	Add notes about command modes and nativecomp interaction

	* doc/lispref/commands.texi (Command Modes): Note interaction with
	native-compile (bug#54437).

	* src/data.c: Add comment about not being supported.

	Do not merge to master.

2022-03-20  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.2-25-gaf6f12

2022-03-20  Eli Zaretskii  <eliz@gnu.org>

	Improve doc strings of read-char-from-minibuffer-insert-* commands

	* lisp/subr.el (read-char-from-minibuffer-insert-char)
	(read-char-from-minibuffer-insert-other): Clarify the doc strings.
	(Bug#54479)

2022-03-19  Eli Zaretskii  <eliz@gnu.org>

	Fix region highlight in non-selected windows

	* src/xdisp.c (prepare_menu_bars): Include in the windows passed
	to pre-redisplay-functions windows whose point was moved from the
	last recorded position.  (Bug#54450)

2022-03-18  Eli Zaretskii  <eliz@gnu.org>

	Fix a regression in 'decipher-digram-list'

	* lisp/play/decipher.el (decipher-stats-buffer): Don't assume the
	statistics buffer always exists.  (Bug#54443)

2022-03-17  Karl Fogel  <kfogel@red-bean.com>

	Improve documentation of bookmark default sorting

	* lisp/bookmark.el (bookmark-alist, bookmark-store,
	  bookmark-maybe-sort-alist): Update doc strings and comments.

2022-03-15  Juri Linkov  <juri@linkov.net>

	* doc/misc/transient.texi: Fix @dircategory to "Emacs misc features" for dir.

2022-03-13  Jim Porter  <jporterbugs@gmail.com>

	Fix evaluation of negated argument predicates in Eshell

	* lisp/eshell/em-pred.el (eshell-add-pred-func): Let-bind 'pred' so
	the lambdas see the original value (bug#54369).

	Committed on the wrong branch.

	Do not merge to master.

2022-03-12  Eli Zaretskii  <eliz@gnu.org>

	Emacs pretest 28.0.92

	* README:
	* configure.ac:
	* nt/README.W32:
	* msdos/sed2v2.inp: Bump Emacs version to 28.0.92.

	* etc/AUTHORS:
	* lisp/ldefs-boot.el: Update for pretest 28.0.92.

	* ChangeLog.3: Regenerate.

2022-03-10  Eli Zaretskii  <eliz@gnu.org>

	Fix regression in 'custom-prompt-customize-unsaved-options'

	* lisp/cus-edit.el (custom-prompt-customize-unsaved-options):
	Don't depend on the value returned by 'customize-unsaved'.  Fix
	the doc string.  Patch by Sebastian Miele <iota@whxvd.name>.
	(Bug#54329)

2022-03-10  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'map-charset-chars'

	* doc/lispref/nonascii.texi (Character Sets):
	* src/charset.c (Fmap_charset_chars): Clarify the codepoint issue
	in using 'map-charset-chars'.

2022-03-08  Eli Zaretskii  <eliz@gnu.org>

	Avoid assertion violations in 'bidi_resolve_brackets'

	* src/bidi.c (bidi_resolve_brackets): Move assertion to where it
	really matters.  (Bug#54295)

2022-03-07  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix which-func-update doc string

	* lisp/progmodes/which-func.el (which-func-update): Make the doc
	string match the code (bug#54288).

2022-03-07  Eli Zaretskii  <eliz@gnu.org>

	Improve wording of 'dired-jump's description

	* doc/emacs/dired.texi (Dired Enter): Clarify wording.  Reported
	by Natalie <batalie@riseup.net>.

2022-03-06  Lars Ingebrigtsen  <larsi@gnus.org>

	Add a comment for previous browse-url-of-dired-file change

	* lisp/net/browse-url.el (browse-url-of-dired-file): Add a comment
	for previous change.

2022-03-06  Lars Ingebrigtsen  <larsi@gnus.org>

	Restore documented Emacs 27.2 behavior of browse-url-of-dired-file

	* lisp/net/browse-url.el (browse-url-of-dired-file): Restore the
	documented behavior -- open a web browser instead of passing to
	the various handlers.

2022-03-06  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.2-24-g668205

2022-03-05  Andreas Schwab  <schwab@linux-m68k.org>

	* lib-src/seccomp-filter.c (main): Use faccessat2 only if defined.

2022-03-04  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix regression in derived-mode-init-mode-variables

	* lisp/emacs-lisp/derived.el (derived-mode-init-mode-variables):
	Fix regression caused by lexical-binding derived.el (bug#54240).

2022-03-03  Eli Zaretskii  <eliz@gnu.org>

	Avoid crashes when fringe bitmaps are defined in daemon mode

	* src/dispextern.h (gui_define_fringe_bitmap): Add prototype.
	(max_used_fringe_bitmap): Add declaration.
	* src/fringe.c (gui_define_fringe_bitmap): New function.
	* src/w32term.c (w32_draw_fringe_bitmap):
	* src/xterm.c (x_draw_fringe_bitmap) [USE_CAIRO]: Call
	'gui_define_fringe_bitmap' if the terminal-specific bitmap data is
	not available when a fringe bitmap is about to be drawn.  Don't
	try to draw a bitmap that is not known to fringe.c.  (Bug#54183)

2022-03-03  Eli Zaretskii  <eliz@gnu.org>

	One more fix of the BPA implementation

	* src/bidi.c (bidi_find_bracket_pairs): Disable BPA optimization
	when there are no strong directional characters inside the
	bracketed pair.  (Bug#54219)

2022-03-03  Eli Zaretskii  <eliz@gnu.org>

	Fix handling of brackets in BPA

	* src/bidi.c (bidi_resolve_brackets): Fix implementation of UBA's
	N0 rule when there are no strong directional characters inside the
	bracketed pair.  (Bug#54219)

2022-03-02  Po Lu  <luangruo@yahoo.com>

	Correct etc/NEWS entry about bitmapped fonts

	* etc/NEWS: Don't say that bitmap font issues are due to Pango, that's
	not accurate.

2022-03-01  Jim Porter  <jporterbugs@gmail.com>

	Improve/correct documentation about Eshell variable expansion

	* lisp/eshell/esh-var.el: Correct documentation comment.
	(eshell-parse-variable-ref): Correct docstring.

	* doc/misc/eshell.texi (Dollars Expansion): Add documentation for
	$"var"/$'var' and $<command> syntaxes.

2022-03-01  Jim Porter  <jporterbugs@gmail.com>

	Partially revert b03f74e0f2a578b1580e8b1c368665850ee7f808

	That commit regressed '$<command>' forms in Eshell, due to a
	limitation/bug in how 'eshell-do-eval' works.  This fixes
	bug#54190.

	* lisp/eshell/esh-var.el (eshell-parse-variable-ref): Quote a lambda.

	* test/lisp/eshell/eshell-tests.el (eshell-test/interp-temp-cmd):
	New test.

2022-03-01  Paul Eggert  <eggert@cs.ucla.edu>

	Backport: Port pre-commit hook to Git 2.35.0

	* build-aux/git-hooks/pre-commit: Use LC_ALL=C grep -E instead of
	sane_egrep (removed in Git 2.35.0).

	(cherry picked from commit b8a96f055624f86fe965a0d1b7b2495b2db80e63)

2022-02-28  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix :tag for eol in tab-first-completion

	* lisp/indent.el (tab-first-completion): Fix the :tag description
	(bug#54179).

2022-02-28  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.2-22-g33543d

2022-02-27  Dmitry Gutov  <dgutov@yandex.ru>

	Add explicit '--no-heading' for ripgrep

	* lisp/progmodes/xref.el (xref-search-program-alist):
	Add explicit '--no-heading' for ripgrep (bug#54177).

2022-02-26  Michael Albinus  <michael.albinus@gmx.de>

	Follow OpenSSH changes in Tramp

	* lisp/net/tramp-sh.el (tramp-ssh-controlmaster-options):
	Reimplement.  OpenSSH has changed its diagnostics messages.

2022-02-26  Eli Zaretskii  <eliz@gnu.org>

	Document better how to reset attributes of faces for new frames

	* doc/lispref/display.texi (Attribute Functions):
	* lisp/faces.el (set-face-attribute): Explain how to reset an
	attribute's value for future frames.  (Bug#54156)

2022-02-25  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/net/tramp-sh.el (tramp-ssh-controlmaster-options): Adapt test.

2022-02-24  Lars Ingebrigtsen  <larsi@gnus.org>

	Mention flyspell-prog-mode in flyspell-mode doc string

	* lisp/textmodes/flyspell.el (flyspell-mode): Mention
	flyspell-prog-mode (bug#54131).

2022-02-23  Lars Ingebrigtsen  <larsi@gnus.org>

	Reword face-remap-add-relative manual entry

	* doc/lispref/display.texi (Face Remapping): Clarify the
	face-remap-add-relative (bug#54114).

2022-02-22  Philipp Stephani  <phst@google.com>

	Fix indexing of module functions that return enumeration types.

	Return types that consist of more than one word need to be enclosed in
	braces, see Info node `(texinfo) Typed Functions'.  Otherwise they are
	indexed incorrectly.

	* doc/lispref/internals.texi (Module Misc, Module Nonlocal): Enclose
	multi-word return types in braces.

2022-02-22  Eli Zaretskii  <eliz@gnu.org>

	* doc/misc/transient.texi (Other Options): Fix a @ref.  (Bug#54108)

2022-02-22  Glenn Morris  <rgm@gnu.org>

	tramp.texi texinfo 4.13 compatibility

	* doc/misc/tramp.texi (Frequently Asked Questions):
	Restore compatibility with Texinfo < 5.

2022-02-22  Michael Albinus  <michael.albinus@gmx.de>

	Explain "Tramp" spelling in its manual

	* doc/misc/tramp.texi (Frequently Asked Questions):
	Explain "Tramp" spelling.

2022-02-21  Eli Zaretskii  <eliz@gnu.org>

	Fix 'display-line-numbers-mode' in hide-show buffers

	* src/xdisp.c (redisplay_internal): Disable redisplay
	optimizations that consider just the current line, when
	'display-line-numbers-mode' is turned on in the buffer.
	(Bug#54091)

2022-02-21  Martin Rudalics  <rudalics@gmx.at>

	Don't check whether a deleted window is deletable (Bug#54028)

	* lisp/window.el (window-state-put): Make sure window is live
	before calling 'window-deletable-p' on it (Bug#54028).

2022-02-21  Eli Zaretskii  <eliz@gnu.org>

	A friendlier error message from image-mode in an empty buffer

	* lisp/image-mode.el (image-mode): Handle the case where the empty
	buffer doesn't visit a file  (Bug#54084)

2022-02-20  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.2-17-gea6b74

2022-02-18  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of filling and justification commands

	* doc/lispref/text.texi (Filling):
	* lisp/textmodes/fill.el (fill-region-as-paragraph)
	(default-justification, set-justification, justify-current-line):
	Clarify "canonicalization" of spaces and the meaning of
	justification styles.  (Bug#54047)
	(set-justification-left, set-justification-right)
	(set-justification-full): Improve wording of doc strings.

2022-02-18  Eli Zaretskii  <eliz@gnu.org>

	* lisp/progmodes/subword.el (superword-mode): Doc fix.  (Bug#54045)

2022-02-17  Philipp Stephani  <phst@google.com>

	Fix indexing of module functions that return complex types.

	Return types that consist of more than one word need to be enclosed in
	braces, see Info node `(texinfo) Typed Functions'.  Otherwise they are
	indexed incorrectly.

	* doc/lispref/internals.texi (Module Values): Enclose multi-word
	return types in braces.

2022-02-17  Po Lu  <luangruo@yahoo.com>

	Prevent crashes caused by invalid locale coding systems

	* src/xterm.c (handle_one_xevent): Prevent a signal inside
	`setup_coding_system' which crashes recent versions of GLib if
	the locale coding system is invalid.

	Do not merge to master.

2022-02-15  Michael Albinus  <michael.albinus@gmx.de>

	Fix problem with popd for in remote shell buffers

	* lisp/shell.el (shell-prefixed-directory-name):
	Use `file-local-name' for DIR.  (Bug#53927)

2022-02-15  Jonas Bernoulli  <jonas@bernoul.li>

	Import texi source file for transient manual

	* doc/misc/Makefile.in: Add transient to INFO_COMMON.
	* doc/misc/transient.texi: New file.

2022-02-13  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.2-15-gc5ceb6

2022-02-13  Eli Zaretskii  <eliz@gnu.org>

	Fix 'exchange-point-and-mark' in 'transient-mark-mode'

	* lisp/simple.el (exchange-point-and-mark): Don't deactivate mark
	when 'transient-mark-mode' is ON.  (Bug#53150)

	(cherry picked from commit 415ed4b42515ff2e6dd9b94e964b479e50c6392e)

2022-02-13  Eli Zaretskii  <eliz@gnu.org>

	Fix "C-SPC C-SPC" after "C-x C-x"

	* lisp/simple.el (exchange-point-and-mark): Fix what the command
	does when 'transient-mark-mode' is OFF.  (Bug#52896)

	(cherry picked from commit 19c6cad1821eb896b2ddd0f6eab030f0880ea254)

2022-02-13  Eli Zaretskii  <eliz@gnu.org>

	Fix a typo in fontset.el

	* lisp/international/fontset.el (xlfd-regexp-spacing-subnum): Fix
	a typo.  Reported by Greg A. Woods <woods@robohack.ca>.

2022-02-12  Eli Zaretskii  <eliz@gnu.org>

	Note in ELisp manual that too-wide images are truncated

	* doc/lispref/display.texi (Showing Images): Note that images are
	truncated at the window's edge.  (Bug#53952)

2022-02-11  Andrea Corallo  <akrl@sdf.org>

	* lisp/mail/emacsbug.el (report-emacs-bug): Report libgccjit status.

	* lisp/startup.el (normal-top-level): Small code move, improve 202d3be873.

2022-02-10  Andrea Corallo  <akrl@sdf.org>

	* lisp/startup.el (normal-top-level): Disable native-comp if not available

2022-02-09  Andrea Corallo  <akrl@sdf.org>

	Fix integer arithmetic miss-compilation (bug#53451)

	* lisp/emacs-lisp/comp-cstr.el (comp-cstr-set-range-for-arithm):
	When one of the two sources is negated revert to set dst as
	number.
	* test/src/comp-tests.el (comp-tests-type-spec-tests): Add test to
	verify this is effective.

2022-02-08  Robert Pluim  <rpluim@gmail.com>

	Mark flymake as compatible with emacs-26.1

	* lisp/progmodes/flymake.el: Bump package version and set
	emacs version in Package-Requires to 26.1 (Bug#53853).

2022-02-08  Brian Leung  <leungbk@posteo.net>

	flymake: Ensure compatibility with older Emacsen

	* lisp/progmodes/flymake.el (flymake--log-1): Use
	replace-regexp-in-string instead of Emacs 28's
	string-replace (bug#53853).

2022-02-07  Eric Abrahamsen  <eric@ericabrahamsen.net>

	Don't remove dummy.group from gnus-newsrc-alist on Gnus save

	bug#53352

	* lisp/gnus/gnus-start.el (gnus-gnus-to-quick-newsrc-format): This
	function was removing dummy.group from the global value of
	`gnus-newsrc-alist' on save; we only wanted to remove it temporarily.

2022-02-05  Bob Rogers  <rogers@rgrjr.com>

	Fix ietf-drums-get-comment doc string

	* lisp/mail/ietf-drums.el (ietf-drums-get-comment):  We really return
	the last comment (bug#53810).

2022-02-05  Daniel Martín  <mardani29@yahoo.es>

	Fix typo in display.texi

	* doc/lispref/display.texi (Making Buttons): Fix typo.  (Bug#53807)

2022-02-03  Michael Albinus  <michael.albinus@gmx.de>

	Revert an erroneous change in tramp-cache.el

	* lisp/net/tramp-cache.el (tramp-get-hash-table):
	Use `string-match-p' instead of `string-search'.  The latter one
	was introduced by accident.  Reported by Kai Tetzlaff <kai@tetzlaff.eu>.

2022-02-02  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'emacs-version'

	* doc/emacs/trouble.texi (Checklist): Mention the possibility of
	invoking 'emacs-version' with a prefix argument.

	* lisp/version.el (emacs-version): Improve doc string.  (Bug#53720)

2022-02-01  Michael Albinus  <michael.albinus@gmx.de>

	* etc/NEWS: Apply final fixes after proofreading.

2022-01-31  Eli Zaretskii  <eliz@gnu.org>

	Clarify documentation of a "face's font"

	* doc/lispref/display.texi (Attribute Functions)
	(Face Attributes): Clarify that the :font attribute of a face and
	the font returned by 'face-font' are by default for ASCII
	characters.  (Bug#53664)

2022-01-31  Alan Mackenzie  <acm@muc.de>

	Bind Qdebugger to Qdebug in signal_or_quit.

	* src/eval.c (signal_or_quit): Bind the correct variable, Qdebugger (not
	Vdebugger) to Qdebug in the section for errors in batch jobs.
	(syms_of_eval): New DEFSYM for Qdebugger.

2022-01-30  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.2-13-gdd6486

2022-01-30  Eli Zaretskii  <eliz@gnu.org>

	Fix regression in Occur Edit mode

	* lisp/replace.el (occur-after-change-function): Fix the algorithm
	to find the smallest change in some corner cases.  (Bug#53598)

2022-01-29  Eli Zaretskii  <eliz@gnu.org>

	Fix last change of Malayalam composition rules

	* lisp/language/indian.el (malayalam-composable-pattern):
	Reinstate.  Instead of removing it, add any sequence of
	Malayalam characters to the existing patterns, so as not
	to lose the patterns that use ZWJ and ZWNJ.  (Bug#53625)

2022-01-29  Eli Zaretskii  <eliz@gnu.org>

	Fix rendering of Malayalam script

	* lisp/language/indian.el (malayalam-composable-pattern): Remove.
	(script-regexp-alist): Remove 'malayalam-composable-pattern'.
	Instead, pass any sequence of Malayalam codepoints to the shaping
	engine.  (Bug#53625)

2022-01-29  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of Occur mode

	* doc/emacs/search.texi (Other Repeating Search): Improve wording
	and document Occur Edit mode better.

2022-01-29  Alan Third  <alan@idiocy.org>

	Remove debug logging

	* src/nsterm.m ([EmacsView copyRect:to:]): Remove logging as it's no
	longer required.

2022-01-29  Michael Albinus  <michael.albinus@gmx.de>

	Fix error in filelock.c

	* src/filelock.c (lock_file): Move call of file name handler to
	`Flock_file'.  Determine lock_filename only in case
	create_lockfiles is non-nil.  Adapt the rest of the function accordingly.
	(Flock_file): Do not check for create_lockfiles.  Call file name
	handler if appropriate.  (Bug#53207)

2022-01-27  Juri Linkov  <juri@linkov.net>

	* lisp/frame.el (clone-frame): Filter out 'parent-id' (bug#51883).

2022-01-26  Lars Ingebrigtsen  <larsi@gnus.org>

	Partially revert a fill-region-as-paragraph regression

	* lisp/textmodes/fill.el (fill-region-as-paragraph): Revert
	e186af261 (bug#53537), because it leads to regressions.  (But
	leave tests in place.)

2022-01-26  Eli Zaretskii  <eliz@gnu.org>

	Fix 'make_lispy_position' when there's an image at EOB

	* src/xdisp.c (move_it_to): Don't compare IT_CHARPOS with an
	invalid TO_CHARPOS.  (Bug#53546)

2022-01-26  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix copyright-find-copyright when searching from the end

	* lisp/emacs-lisp/copyright.el (copyright-find-copyright): Make
	the double check also work when searching from the end (bug#7179).

	Do not merge to master.

2022-01-26  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix copyright.el comment and add a test

	* lisp/emacs-lisp/copyright.el (copyright-find-copyright): Fix
	comment (bug#7179).

	Do not merge to master.

2022-01-24  Philipp Stephani  <phst@google.com>

	* configure.ac (LIBSECCOMP): Bump minimum version for faccessat2.

2022-01-24  Lars Ingebrigtsen  <larsi@gnus.org>

	Make the `f' command work in image-mode again

	* lisp/image.el (image-show-frame): Protect against not having
	computed the animation data yed (bug#53489).

2022-01-22  Philipp Stephani  <phst@google.com>

	Seccomp: improve support for newer versions of glibc (Bug#51073)

	* lib-src/seccomp-filter.c (main): Allow 'pread64' and 'faccessat2'
	system calls.  Newer versions of glibc use these system call (starting
	with commits 95c1056962a3f2297c94ce47f0eaf0c5b6563231 and
	3d3ab573a5f3071992cbc4f57d50d1d29d55bde2, respectively).

2022-01-21  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	EUDC: Fix a quoting bug in the BBDB backend

	* lisp/net/eudcb-bbdb.el (eudc-bbdb-query-internal): Fix a quoting
	bug introduced during lexical-binding conversion.

2022-01-21  Sergey Vinokurov  <serg.foo@gmail.com>

	Fix memory-report-object-size to initialize memory-report--type-size

	* lisp/emacs-lisp/memory-report.el (memory-report-object-size):
	Allow using function directly (bug#53310).

	Do not merge to master.

2022-01-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	Fix menu-bar mouse clicks in "C-h c" and "C-h k" (bug#53322)

	* lisp/subr.el (event-start, event-end): Handle '(menu-bar)'
	events.
	* lisp/net/browse-url.el (browse-url-interactive-arg): Simplify
	accordingly.

	(cherry picked from commit 9ceb3070e34ad8a54184fd0deda477bf5ff77000)

2022-01-20  Eli Zaretskii  <eliz@gnu.org>  (tiny change)

	Fix UB in ebrowse

	* lib-src/ebrowse.c (matching_regexp): Avoid writing beyond the
	limits of 'matching_regexp_buffer'.  Patch by Jan Stranik
	<jan@stranik.org>.  (Bug#53333)

2022-01-20  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix execute-extended-command-for-buffer in fundamental-mode

	* lisp/simple.el (execute-extended-command-for-buffer): Protect
	against the current local map being nil (bug#52907).

2022-01-20  Martin Rudalics  <rudalics@gmx.at>

	Add workaround to handle a problem with Enlightenment WM (Bug#53298)

	* src/xterm.c (handle_one_xevent): Handle setting of variable
	'x_set_frame_visibility_more_laxly' when receiving an Expose or
	FocusIn event (Bug#53298).
	(Qexpose): Define symbol.
	(x_set_frame_visibility_more_laxly): New Lisp variable.
	* etc/PROBLEMS: Mention frame redraw problem with the
	Enlightenment WM and 'x-set-frame-visibility-more-laxly'
	workaround.

2022-01-17  Po Lu  <luangruo@yahoo.com>

	Fix regression leading to flickering tooltips when the mouse is moved

	* lisp/tooltip.el (tooltip-show-help): Compare string with
	previous tooltip string ignoring properties.

2022-01-17  Andrea Corallo  <akrl@sdf.org>

	* Fix native comp for non trivial function names (bug#52833)

	* lisp/emacs-lisp/comp.el (comp-c-func-name): Fix native compilation
	for functions with function names containing non trivial
	characters (bug#52833).

	This commit is the backport of e7699bf290.

	Do not merge to master

2022-01-15  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.2-9-g7ba24c

2022-01-15  Juri Linkov  <juri@linkov.net>

	* lisp/net/dictionary.el (dictionary-context-menu): Use package prefix.

2022-01-15  Philipp Stephani  <phst@google.com>

	Mark a few more map tests as unstable on Emacs 28 (Bug#46722).

	At least for me, these tests still occasionally fail.

	Do not merge to master.

	* test/lisp/emacs-lisp/map-tests.el (test-map-into-hash-test)
	(test-map-merge, test-map-merge-with, test-map-merge-empty): Mark as
	unstable.

2022-01-15  Philipp Stephani  <phst@google.com>

	* lisp/indent.el (tab-first-completion): Fix incorrect choices.

2022-01-14  Philipp Stephani  <phst@google.com>

	* lisp/simple.el (undo-no-redo): Fix customization group

	* lisp/progmodes/xref.el (xref-file-name-display): Fix docstring.

2022-01-14  Eli Zaretskii  <eliz@gnu.org>

	Avoid another segfault in 'face_at_buffer_position'

	* src/xfaces.c (face_at_buffer_position): Make really sure the
	default face is usable.  (Bug#53254)

2022-01-14  Lars Ingebrigtsen  <larsi@gnus.org>

	Mark test-map-into as unstable

	* test/lisp/emacs-lisp/map-tests.el (test-map-into): Mark as
	unstable (bug#46722).

	Do not merge to master.

2022-01-13  Philipp Stephani  <phst@google.com>

	Fix Edebug specification for inline functions (Bug#53068).

	* lisp/emacs-lisp/inline.el (inline-quote): Fix Edebug specification.

	* test/lisp/emacs-lisp/edebug-tests.el (edebug-tests-inline): New unit
	test.

2022-01-13  N. Jackson  <nljlistbox2@gmail.com>

	Remove mention of removed `gnus-treat-play-sounds' variable from manual

	* info/gnus.info: Remove `gnus-treat-play-sounds' from
	manual. According to lisp/gnus/ChangeLog.3 this variable was
	removed in 2010 (bug#53192).

2022-01-12  Mattias Engdegård  <mattiase@acm.org>

	Revert "Fix closure-conversion of shadowed captured lambda-lifted vars"

	This reverts commit 3ec8c8b3ae2359ceb8135b672e86526969c16b7e.

	It was committed to a stable branch without prior discussion;
	see bug#53071.

2022-01-12  Juri Linkov  <juri@linkov.net>

	* doc/lispref/windows.texi (Textual Scrolling): Remove obsolete text.

	Remove text about scrolling the minibuffer from the buffer,
	obsolete since Emacs 27 (bug#51210).

2022-01-12  Glenn Morris  <rgm@gnu.org>

	* lisp/files.el (lock-file-name-transforms): Doc tweaks.

2022-01-12  Mattias Engdegård  <mattiase@acm.org>

	Fix closure-conversion of shadowed captured lambda-lifted vars

	Lambda-lifted variables (ones passed explicitly to lambda-lifted
	functions) that are also captured in an outer closure and shadowed
	were renamed incorrectly (bug#51982).

	Reported by Paul Pogonyshev.

	* lisp/emacs-lisp/cconv.el (cconv--lifted-arg): New.
	(cconv-convert): Provide correct definiens for the closed-over
	variable.
	* test/lisp/emacs-lisp/bytecomp-tests.el (bytecomp-tests--test-cases):
	* test/lisp/emacs-lisp/cconv-tests.el (cconv-tests--intern-all)
	(cconv-closure-convert-remap-var): Add tests.

	(cherry picked from commit 45252ad8f932c98a373ef0ab7f3363a3e27ccbe4)

2022-01-12  Philipp Stephani  <phst@google.com>

	Fix test lisp/cedet/semantic/bovine/gcc-tests on macOS (Bug#52431)

	* test/lisp/cedet/semantic/bovine/gcc-tests.el
	(semantic-gcc-test-output-parser-this-machine): Also detect Apple
	clang on macOS Monterey.

	(cherry picked from commit 6e52becfbe2a33c025b8c4838b3c8f06ba5a6fb8)

2022-01-12  Mattias Engdegård  <mattiase@acm.org>

	Don't fail flymake-tests if `gcc` actually is Clang

	* test/lisp/progmodes/flymake-tests.el (flymake-tests--gcc-is-clang)
	(different-diagnostic-types, included-c-header-files): Skip tests that
	depend on the `gcc` command really being GCC and not Clang.

	(cherry picked from commit b2167d98432a78442522b7564e22f47d75a98b6f)

2022-01-10  Eli Zaretskii  <eliz@gnu.org>

	Revert "Remove the filename argument from the command line after an ELC+ELN build"

	This reverts commit ffc047c896413b6e00032518fc934f08768671fa.

	Please don't install anything non-trivial on the release branch
	without asking first.

2022-01-10  Alan Mackenzie  <acm@muc.de>

	Remove the filename argument from the command line after an ELC+ELN build

	This fixes bug #53164.  Without this fix, bootstrap-emacs loads the source
	file uselessly into a buffer after completing the compilation.

2022-01-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	(save-some-buffers): Simplify the fix for bug#46374

	* lisp/files.el (save-some-buffers): Only check the
	`save-some-buffers-function` property on functions from
	`save-some-buffers-default-predicate` since callers which provide
	a `pred` argument can arrange to compute `pred` themselves if needed.

	* test/lisp/files-tests.el (files-tests-buffer-offer-save): Don't test
	with `pred` set to `save-some-buffers-root` since it's not an
	appropriate function for that any more.

2022-01-09  Stefan Kangas  <stefankangas@gmail.com>

	Improve docstring of edit-abbrevs

	* lisp/abbrev.el (edit-abbrevs): Doc fix; don't use obsolete name.
	Improve docstring formatting.

2022-01-09  Eli Zaretskii  <eliz@gnu.org>

	Revert "Fix alignment on font size change in tabulated-list-mode"

	This reverts commit 2767c89db729a6106146d0aeff76678c64d4fc53.

	That change caused a regression in a much more important use
	case, see bug#53133.

2022-01-08  Stefan Kangas  <stefankangas@gmail.com>

	Clarify docstring of package-native-compile

	* lisp/emacs-lisp/package.el (package-native-compile): Clarify
	docstring.

2022-01-08  Eli Zaretskii  <eliz@gnu.org>

	Fix Subject "simplification" in Rmail

	* lisp/mail/rmail.el (rmail-simplified-subject): Match against
	"[external]" _after_ decoding the Subject by RFC-2047.

2022-01-08  Stefan Kangas  <stefankangas@gmail.com>

	Bump Emacs version to 28.0.91

	* README:
	* configure.ac:
	* msdos/sed2v2.inp:
	* nt/README.W32: Bump Emacs version to 28.0.91.

2022-01-05  Dmitry Gutov  <dgutov@yandex.ru>

	Fix vc-git with old Git over Tramp and cygwin-mount.el

	* lisp/vc/vc-git.el (vc-git-use-literal-pathspecs): New variable.
	(vc-git-command, vc-git--call): Use it to determine whether to set
	GIT_LITERAL_PATHSPECS=1 (bug#51497).
	(vc-git--literal-pathspec, vc-git--literal-pathspecs): Remove.
	Update all callers.  This reverts the previous solution for bug#39452.

	* lisp/progmodes/project.el (project--vc-list-files):
	Use the new variable.

2022-01-05  Philipp Stephani  <phst@google.com>

	* lisp/emacs-lisp/checkdoc.el (bytecomp): Add missing require

2022-01-02  Eli Zaretskii  <eliz@gnu.org>

	Avoid inflooping when 'tab-bar-format' includes embedded newlines

	* src/xdisp.c (tab_bar_height, redisplay_tab_bar): Support
	'tab-bar-format' with embedded newlines.  (Bug#52947)

2022-01-02  Juri Linkov  <juri@linkov.net>

	* lisp/tab-line.el: Revert part of the fix in a6adfe21e4 (bug#52881)

	(tab-line--get-tab-property, tab-line-auto-hscroll): Use get-pos-property
	instead of get-text-property that fails after previous-single-property-change.

2022-01-02  Eli Zaretskii  <eliz@gnu.org>

	Clarify %g and %G time format specs

	* src/timefns.c (Fformat_time_string):
	* doc/lispref/os.texi (Time Parsing): Clarify %g/%G.  (Bug#52934)

2022-01-02  Stefan Monnier  <monnier@iro.umontreal.ca>

	(define-char-code-property): Workaround for bug#52945

	* lisp/international/mule-cmds.el (define-char-code-property): Ignore
	requests to re-setup lazy loading after the char-table is already loaded.

2022-01-01  Eli Zaretskii  <eliz@gnu.org>

	Update more copyright years

	* etc/tutorials/TUTORIAL.he (זכויות שימוש):
	* config.bat: Update Copyright years.

2022-01-01  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/net/tramp-sh.el: Adapt copyright year

2022-01-01  Zhehao Lin  <zh_lin1@outlook.com>  (tiny change)

	* src/xfaces.c (face_for_font): Make 'hash' be uintptr_t.

2021-12-31  Eli Zaretskii  <eliz@gnu.org>

	Improve doc strings of fringe indicator variables

	* src/buffer.c (syms_of_buffer): Fix doc strings of
	'indicate-empty-lines' and 'indicate-buffer-boundaries'.

2021-12-31  Juri Linkov  <juri@linkov.net>

	* lisp/tab-line.el (tab-line--get-tab-property): New function (bug#52881).

	(tab-line-auto-hscroll): Use ‘tab-line--get-tab-property’ instead of
	‘get-pos-property 1’, and ‘get-text-property’ instead of
	‘get-pos-property’.
	(tab-line-select-tab, tab-line-close-tab): Use tab-line--get-tab-property.

2021-12-30  Eli Zaretskii  <eliz@gnu.org>

	Avoid assertion violations with variable-weight fonts

	* src/font.c (font_score, font_delete_unmatched): Don't assume
	weight, slant, and width properties of the font must be fixnums:
	some variable-weight fonts violate that assumption.  Reported
	by Sean Whitton <spwhitton@spwhitton.name>.  Do not merge to
	master.  (Bug#52888)

2021-12-30  Eli Zaretskii  <eliz@gnu.org>

	Minor improvement in user documentation of completion style

	* doc/emacs/mini.texi (Completion Styles): Add reference to
	"Completion Variables" in the ELisp manual.  (Bug#52901)

2021-12-30  Campbell Barton  <ideasman42@gmail.com>  (tiny change)

	Fix bug where bookmark-jump used (point), not (point-at-bol)

	This matches changes from e852822f3db469c985bf022651f184d6ff2c518a,
	regression in 7fe88446c30279285e3171091189b3d1af697c05.
	* lisp/bookmark.el (bookmark--jump-via): Look at overlays at BOL.
	Otherwise the fringe bookmark indication is not deleted with the
	bookmark.

2021-12-29  Alan Mackenzie  <acm@muc.de>

	CC Mode: c-update-brace-stack: After struct foo *, do not expect a brace.

	This fixes bug #52796.

	* lisp/progmodes/cc-engine.el (c-update-brace-stack): Handle a "*" like a
	semicolon, canceling the expectation of a brace.

	* lisp/progmodes/cc-langs.el (c-brace-stack-thing-key): Add a "*" into the
	sets of significant characters.

2021-12-29  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'M-X' and related features

	* doc/emacs/m-x.texi (M-x): Index 'M-X'.
	* doc/lispref/commands.texi (Interactive Call, Command Modes):
	Mention 'M-X' and 'execute-extended-command-for-buffer'.

	* etc/NEWS: Clarify that the '(declare (completion ...' and
	'(declare (modes ...' forms have no effect by default.  Likewise
	for '(interactive "..." MODE)' specs.  (Bug#52839)

2021-12-28  Sean Whitton  <spwhitton@spwhitton.name>

	Improve rectangle-mark-mode documentation regarding mark activation

	* doc/emacs/killing.texi: Describe how rectangle-mark-mode works when
	Transient Mark mode is off.  Qualify discussion of
	rectangle-exchange-point-and-mark to say that it cycles the four
	corners only when the region is active.
	* lisp/rect.el (rectangle-mark-mode): State that rectangle-mark-mode
	does not activate the mark when Transient Mark mode is off.  Reword
	sentence about how long the mode lasts to account for when Transient
	Mark mode is off.  (Bug#42663)

2021-12-27  Eli Zaretskii  <eliz@gnu.org>

	Fix typos in 'reset-language-environment'

	* lisp/international/mule-cmds.el (reset-language-environment):
	Fix a typo in 'windows-nt'.  (Bug#52816)

2021-12-27  Óscar Fuentes  <ofv@wanadoo.es>

	eshell-complete-parse-arguments: don't use string-match on a list

	When there is more than one candidate for completion, `val' is a list.

	Fixes bug#52794.

	* lisp/eshell/em-cmpl.el (eshell-complete-parse-arguments): protect
	use of string-match with stringp.

2021-12-26  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.2-3-geb9f34

2021-12-26  Stefan Kangas  <stefankangas@gmail.com>

	Improve documentation of read-multiple-choice

	* doc/lispref/commands.texi (Reading One Event): Document optional
	third argument help-string of read-multiple-choice.

2021-12-25  Eli Zaretskii  <eliz@gnu.org>

	Explain why we remove stuff from 'user-full-name'

	* src/editfns.c (Fuser_full_name): Document why we chop everything
	starting from the first comma.  (Bug#52785)

2021-12-24  Dmitry Gutov  <dgutov@yandex.ru>

	Fix the bug with duplicate entries in xref output

	* lisp/progmodes/etags.el (xref-backend-definitions): Make sure to
	save the changed intermediate value of the list (bug#52734).

2021-12-24  Dmitry Gutov  <dgutov@yandex.ru>

	Improve Xref documentation

	* lisp/progmodes/xref.el (xref-item): Add docstring for 'summary'.
	Fix typo in the header Commentary.

2021-12-23  Andreas Schwab  <schwab@linux-m68k.org>

	* lisp/net/shr.el (shr-expand-url): Also strip trailing
	whitespace.

2021-12-22  Lars Ingebrigtsen  <larsi@gnus.org>

	Revert field-related thingatpt changes

	This reverts 7db376e560448e61485ba054def8c82b21f33d6a, which led to
	severe performance regressions when being run in large buffers with no
	fields (bug#52593)

2021-12-21  Juri Linkov  <juri@linkov.net>

	* lisp/window.el (quit-restore-window): Select previously selected window.

	After deleting the dedicated window, such as a window with *Completions*
	buffer, select the previously selected window, like most of other 'cond'
	branches do in this function (bug#52491).

2021-12-21  Robert Pluim  <rpluim@gmail.com>

	Revert "Remove Motif support"

	This reverts commit db237850abc240e2c3e765e9cc7e15ee5681dcaf.

2021-12-19  Martin Rudalics  <rudalics@gmx.at>

	Clarify description of two mouse dragging parameters (Bug#52537)

	* doc/lispref/frames.texi (Child Frames): Clarify description of
	'top-visible' and 'bottom-visible' parameters (Bug#52537).

2021-12-18  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.1-31-ga18849

2021-12-15  Martin Rudalics  <rudalics@gmx.at>

	Fix control buffer window height in 'ediff-setup-control-buffer' (Bug#49277)

	* lisp/vc/ediff-util.el (ediff-setup-control-buffer): Emulate
	original 'shrink-window-if-larger-than-buffer' call by calling
	'fit-window-to-buffer' with an appropriate maximum height
	argument (Bug#49277).

2021-12-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	Fix crash when dumping charset_table with portable dumper (Bug#52461)

	* src/charset.h:
	* src/charset.c (charset_table_used): Now extern.
	* src/pdumper.c (dump_charset): Don't dump code_space_mask for unused
	slots of charset_table.

2021-12-14  Philipp Stephani  <phst@google.com>

	Remove maintainer comment from Emacs 28 module snippet.

	This is the same as 44c13eefe8d30841000a96d82f467fb8d222e365 on
	master.  We should also remove this comment on the release branch,
	otherwise it ends up in the emacs-module.h shipped to users.

	* src/module-env-28.h: Remove maintainer comment.

2021-12-14  Stefan Kangas  <stefankangas@gmail.com>

	Set calc-make-windows-dedicated to nil by default

	* lisp/calc/calc.el (calc-make-windows-dedicated):
	Default to nil.  (Bug#52016)

2021-12-14  Stefan Kangas  <stefankangas@gmail.com>

	* make-dist: Don't run "make --question info".  (Bug#52322)

2021-12-13  Eli Zaretskii  <eliz@gnu.org>

	Fix regression in help-mode prompt

	* lisp/help-macro.el (make-help-screen): Restore SPC and DEL in
	prompt.  Reported by Colin Baxter <m43cap@yandex.com>.

2021-12-13  Kévin Le Gouguec  <kevin.legouguec@gmail.com>

	Make `M-x run-python' select the window again

	Interactively, we want M-x run-python to focus the interpreter buffer.
	The previous code failed in two ways:

	- the call to 'display-buffer' was not reached if an interpreter
	  was already running,

	- set-buffer is ineffectual if the interpreter's window is not
	  selected: once Emacs returns to the command loop, the current buffer
	  will revert back to what the selected window contains.

	* lisp/progmodes/python.el (python-shell-make-comint): Handle the SHOW
	argument regardless of whether an interpreter buffer exists, and use
	pop-to-buffer to select the window.
	(run-python): Delegate buffer management to
	'python-shell-make-comint'.

	* test/lisp/progmodes/python-tests.el
	(python-tests--run-python-selects-window): Rename from
	'python-tests--bug31398', and adjust assertions (bug#52380).

2021-12-12  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el (tab-bar-switch-to-last-tab): Add 'abs' for precautions.

	https://lists.gnu.org/archive/html/emacs-devel/2021-11/msg01149.html

2021-12-12  Eli Zaretskii  <eliz@gnu.org>

	* make-dist (manifest): Filter out msdos/autogen/* files.

2021-12-12  Richard Stallman  <rms@gnu.org>

	Rewrite the "Quitting Windows" section of Emacs Lisp Reference

	* doc/lispref/windows.texi (Quitting Windows): Rewrite for
	clarity.  (Bug#52328)

2021-12-12  Po Lu  <luangruo@yahoo.com>

	Fix eshell for systems that do not have subprocesses

	* lisp/eshell/esh-cmd.el (eshell-eval-command): Use
	`eshell-processp' instead of `processp'.

2021-12-11  Philipp Stephani  <phst@google.com>

	Avoid undefined behavior in 'send-process-region' (Bug#52369).

	* src/process.c (send_process): Signal an error if the file descriptor
	has already been closed.

2021-12-11  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.1-25-g9ca3bc

2021-12-11  Po Lu  <luangruo@yahoo.com>

	Fix the DJGPP port

	* config.bat:
	* msdos/sed1v2.inp:
	* msdos/sed2v2.inp:
	* msdos/sed3v2.inp:
	* msdos/sedlibmk.inp: Update for Emacs 28.
	* msdos/langinfo.h: New file.

	* lisp/loadup.el: Use correct path to temacs when dumping on
	MS-DOS.
	* src/callproc.c (environ) [MSDOS]: New declaration.
	(child_setup, emacs_spawn): Update MS-DOS parts for Emacs 28.
	* src/fileio.c (Fcopy_file): Don't use copy_file_range on
	MS-DOS.
	* src/msdos.c (initialize_msdos_display): Add
	`defined_color_hook'.
	(openat, fchmodat, futimens, utimensat): New functions.

	* src/msdos.h (FRAME_X_DISPLAY): New macro.
	* src/process.c: Make some more things conditional on
	subprocess support.
	(PIPECONN_P, PIPECONN1_P) [!subprocesses]: New placeholder
	macros.
	(Fnum_processors): Return 1 on MSDOS.
	(open_channel_for_module): Avoid subprocess specific code
	on MSDOS.

2021-12-10  Lars Ingebrigtsen  <larsi@gnus.org>

	Revert "Make `M-x run-python' select the window again"

	This reverts commit aa2872a12770282ede3548ed3fcab00c5a5b9f18.

	This led to a test failure.

2021-12-10  Kévin Le Gouguec  <kevin.legouguec@gmail.com>

	Make `M-x run-python' select the window again

	* lisp/progmodes/python.el (python-shell-make-comint): Make `M-x
	run-python' select the window again like in 27.2 (bug#52380).

2021-12-10  Lars Ingebrigtsen  <larsi@gnus.org>

	Don't bug out on certain empty elements with ids

	* lisp/net/shr.el (shr-descend): Fix empty-element #id targeting
	(bug#52391).

2021-12-09  Paul Eggert  <eggert@cs.ucla.edu>

	emacsclient takes more care about XDG_RUNTIME_DIR

	* lib-src/emacsclient.c (set_local_socket): Revert to the Emacs 27
	behavior of not trying TMPDIR if XDG_RUNTIME_DIR is set.
	This is one of the suggestions made by Jim Porter and
	independently by Ulrich Müller in Bug#51327.

2021-12-09  Cameron Desautels  <camdez@gmail.com>

	Add missing K key documentation for Cangjie input methods

	* lisp/international/titdic-cnv.el (tsang-quick-converter): Add the
	missing K key in input method documentation. (Bug#52264)

2021-12-09  Martin Rudalics  <rudalics@gmx.at>

	Fix manual entry of 'quit-restore-window' (Bug#52328)

	* doc/lispref/windows.texi (Quitting Windows): Fix bug in
	description of 'quit-restore-window' (Bug#52328).

2021-12-09  Eli Zaretskii  <eliz@gnu.org>

	Clarify a comment in xdisp.c

	* src/xdisp.c (compute_window_start_on_continuation_line): Clarify
	a comment.  (Bug#52378)

2021-12-08  Óscar Fuentes  <ofv@wanadoo.es>

	Revert "Grep alias `all' shall not match parent directory"

	This reverts commit 856cd948d1a5a016ad36721246a049d33451902f.

	Emacs got better at quoting shell arguments and the original value
	works correctly for vc-git-grep. At the same time, the value
	introduced on that commit caused a regression on lgrep.

	* lisp/progmodes/grep.el (grep-files-aliases): Use previous value for
	`all'. Fixes bug#52367

2021-12-08  Eli Zaretskii  <eliz@gnu.org>

	Fix mode-line display in Calendar mode

	* lisp/help.el (substitute-command-keys): New optional argument
	NO-FACE, to avoid putting the 'help-key-binding' face on the key
	bindings.
	* lisp/calendar/calendar.el (calendar-mode-line-entry): Call
	'substitute-command-keys' with the new optional argument non-nil.
	(Bug#52366)

	* doc/lispref/help.texi (Keys in Documentation): Document the new
	optional argument of 'substitute-command-keys'.

	* etc/NEWS: Announce the addition of a new argument to
	'substitute-command-keys'.

2021-12-08  Lele Gaifax  <lele@metapensiero.it>

	* etc/tutorials/TUTORIAL.it (CONCLUSIONI): Reword paragraph.

	Don't merge to master.

2021-12-08  Michael Albinus  <michael.albinus@gmx.de>

	Backport: Make a more robust check in Tramp using scripts

	* lisp/net/tramp-sh.el (tramp-find-inline-encoding):
	Check, whether scripts in `tramp-remote-coding-commands' are
	expandable.

	(cherry picked from commit 1d0a60113fd155c77ef5ea4ea44fcba3504adcbf)

2021-12-07  Robert Pluim  <rpluim@gmail.com>

	Document native-comp-async-report-warning-errors more

	The docstring has a description of how fix problems in lisp code
	detected by native compilation, but not the Emacs Lisp manual, so
	document it there as well.

	* doc/lispref/compile.texi (Native-Compilation Functions): Refer to
	'native-comp-async-report-warning-errors'
	(Native-Compilation Variables): Explain potential cause of warnings
	from native compilation.

2021-12-07  Stefan Kangas  <stefankangas@gmail.com>

	Doc fix; Epiphany has been renamed to GNOME Web

	* lisp/net/browse-url.el: Doc fix; Epiphany is called GNOME Web
	since GNOME 3.4, released in 2012.
	Ref: https://help.gnome.org/misc/release-notes/3.4/

2021-12-07  Eli Zaretskii  <eliz@gnu.org>

	* lisp/dired-aux.el (dired-check-process): Doc fix.  (Bug#52337)

2021-12-07  Stefan Kangas  <stefankangas@gmail.com>

	Remove dead link from newsticker

	* lisp/net/newst-backend.el (newsticker--parse-rss-0.91):
	* lisp/net/newsticker.el: Remove dead link.

2021-12-06  Juri Linkov  <juri@linkov.net>

	Select the right buffer for event in context-menu functions (bug#9923)

	* lisp/mouse.el (context-menu-region):
	* lisp/progmodes/prog-mode.el (prog-context-menu):
	Switch to the buffer displayed by the window of the event
	before using syntax-ppss, char-after.

2021-12-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	lisp/minibuffer.el: Fix for bug#52169 regression

	* lisp/minibuffer.el (completion-table-subvert): Make sure we return
	a boundary that's not outside of the limit of the string.

2021-12-05  Christer Enfors  <christer.enfors@gmail.com>

	Fix typos and improve consistency in ERC manual

	* doc/misc/erc.texi (Sample Session, Special Features, History): Fix
	typos and improve consistency.  (Bug52318)

2021-12-05  Glenn Morris  <rgm@gnu.org>

	* test/Makefile.in (check-declare): Add missing --batch.

2021-12-05  Eli Zaretskii  <eliz@gnu.org>

	Document the subtleties of the 'cursor' text property

	* doc/lispref/text.texi (Special Properties): Update the
	documentation of the 'cursor' property per bug#8627.

2021-12-05  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.1-15-gdb4805

2021-12-04  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/emacs-lisp/edebug.el (edebug-eval-defun): Minor doc fix.

2021-12-04  Eli Zaretskii  <eliz@gnu.org>

	Fix the enumeration values returned by 'try_scrolling'

	* src/xdisp.c (try_scrolling): Make the enum values match the
	commentary.  Reported by Po Lu <luangruo@yahoo.com>.

2021-12-04  Stefan Kangas  <stefankangas@gmail.com>

	* src/dosfns.c (Fint86): Doc fix; don't use obsolete names.

2021-12-03  Stefan Kangas  <stefankangas@gmail.com>

	* doc/misc/erc.texi (Keystroke Summary): Fix doc for TAB.

2021-12-03  Stefan Kangas  <stefankangas@gmail.com>

	Remove reference to variable obsolete since 24.1

	* doc/emacs/custom.texi (Minibuffer Maps, Minibuffer Maps): Remove
	reference to variable 'minibuffer-local-filename-must-match-map',
	obsolete since 24.1.

2021-12-03  Stefan Kangas  <stefankangas@gmail.com>

	* doc/misc/efaq.texi (New in Emacs 28): New node.

2021-12-03  Michael Albinus  <michael.albinus@gmx.de>

	Add Tramp version integrated in Emacs 28.1

	* lisp/net/trampver.el (customize-package-emacs-version-alist):
	Add Tramp version integrated in Emacs 28.1.

2021-12-03  Michael Albinus  <michael.albinus@gmx.de>

	Update Tramp version (don't merge with master)

	* doc/misc/trampver.texi:
	* lisp/net/trampver.el: Change version to "2.5.2.28.1".

2021-12-03  Philipp Stephani  <phst@google.com>

	Unbreak build after 9c222b9c1a7f91497a37567b4d7de3a511fff069.

	* src/pdumper.c (dump_subr): Fix Lisp_Subr hash value.

2021-12-03  Paul Eggert  <eggert@cs.ucla.edu>

	Port to C compilers that lack size-0 arrays

	The C standard does not allow size-zero arrays, so redo struct
	Lisp_Subr to not use size-zero arrays when native compilation is
	not being used.  Formerly, the code was using size-zero arrays (a
	GNU C extension) to avoid using memory unnecessarily when
	HAVE_NATIVE_COMP is not defined.  Replace this hack with the
	more-traditional hack of putting the relevant members inside
	‘#ifdef HAVE_NATIVE_COMP’.
	* src/alloc.c (cleanup_vector, mark_object):
	* src/comp.c (make_subr):
	* src/data.c (Fsubr_native_lambda_list, Fsubr_native_comp_unit):
	* src/eval.c (init_eval_once, funcall_lambda):
	* src/lisp.h (SUBR_NATIVE_COMPILEDP, SUBR_NATIVE_COMPILED_DYNP)
	(SUBR_TYPE):
	* src/lread.c (Fload):
	Conditionally compile with ‘#ifdef HAVE_NATIVE_COMP’ instead of
	with ‘if (NATIVE_COMP_FLAG)’.  Redo members like native_comp_u[0]
	to be plain native_comp_u.  Put all uses of these members inside
	‘#ifdef HAVE_NATIVE_COMP’.
	* src/lisp.h (struct Lisp_Subr): Members native_comp_u,
	native_c_name, lambda_list, type are now all ifdeffed out if
	HAVE_NATIVE_COMP is not defined, instead of being size-zero
	arrays.  All uses changed.
	* src/pdumper.c (dump_subr, dump_cold_native_subr)
	(dump_do_dump_relocation):
	* src/comp.h (NATIVE_COMP_FLAG): Remove; no longer needed.

2021-12-03  Paul Eggert  <eggert@cs.ucla.edu>

	Port emacsclient to Solaris 10

	Without this patch, the build fails on Solaris 10 with the diagnostic
	“Undefined symbol acl_trivial first referenced in file
	../lib/libgnu.a(file-has-acl.o)”.
	* lib-src/Makefile.in (LIB_HAS_ACL): New macro.
	(emacsclient${EXEEXT}): Link with $(LIB_HAS_ACL).

2021-12-03  Karl Fogel  <kfogel@red-bean.com>

	* CONTRIBUTE: Improve commit message instructions

2021-12-03  Paul Eggert  <eggert@cs.ucla.edu>

	Work around IBM XL C compiler bug

	* src/fileio.c (Fcopy_file): Work around a compiler bug in IBM XL
	C for AIX, V12.1 (5765-J02, 5725-C72).  Without this patch, the
	compiler incorrectly complains “Initialization between types "int"
	and "struct timespec" is not allowed” and “Initialization between
	types "long" and "struct timespec" is not allowed”.

2021-12-03  Stefan Kangas  <stefankangas@gmail.com>

	* admin/make-tarball.txt: Various clarifications.

2021-12-02  Stefan Kangas  <stefankangas@gmail.com>

	* admin/diff-tar-files: Don't assume .tar.gz.

2021-12-02  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el (tab-bar-close-other-tabs): Fix regression.

	* test/lisp/tab-bar-tests.el: New file.
	(tab-bar-tests-close-other-tabs-with-arg): Test for regression
	that closed the selected tab after selecting it.

2021-12-01  Juri Linkov  <juri@linkov.net>

	* lisp/repeat.el: Use same logic for repeat-check-key and repeat-exit-timeout.

	* lisp/repeat.el (repeat-check-key): Use for repeat-check-key the same logic
	as is used for repeat-exit-timeout in repeat-post-hook (bug#51390).
	(repeat-post-hook): Check for repeat-exit-timeout symbol property.

2021-12-01  Juri Linkov  <juri@linkov.net>

	* lisp/help.el (help--analyze-key): Prefer posn-set-point over mouse-set-point

	* lisp/help.el (help--analyze-key): Use posn-set-point instead of
	mouse-set-point that runs the hook mouse-leave-buffer-hook via
	mouse-minibuffer-check.  Using posn-set-point also unnecessitates
	extra conditions added in bug#51421.

	* lisp/isearch.el (isearch-describe-key, isearch-describe-mode):
	Add precautions to not call isearch-update when the executed
	command exited isearch-mode (bug#51173).

2021-12-01  Stefan Kangas  <stefankangas@gmail.com>

	Bump Emacs version to 28.0.90

	* README:
	* configure.ac:
	* msdos/sed2v2.inp:
	* nt/README.W32: Bump Emacs version to 28.0.90.

2021-12-01  Alan Mackenzie  <acm@muc.de>

	CC Mode: Recognize "struct foo {" as introducing a type declaration

	This fixes bug #52157.

	* lisp/progmodes/cc-engine.el (c-forward-decl-or-cast-1): If such a construct
	is parsed, set the flag at-type-decl which is part of the function's return
	value.

2021-12-01  Stefan Kangas  <stefankangas@gmail.com>

	Update authors.el for Emacs 28

	* admin/authors.el (authors-aliases, authors-ignored-files)
	(authors-renamed-files-alist): Update for Emacs 28.

2021-11-30  Juri Linkov  <juri@linkov.net>

	* lisp/repeat.el: Fix long-standing problem when a random key activates map

	* lisp/repeat.el (repeat-check-key): New defcustom (bug#51390).
	(repeat--command-property): New internal function.
	(repeat-check-key): New function.
	(repeat-post-hook): Use repeat--command-property and repeat-check-key.

	* test/lisp/repeat-tests.el (repeat-tests-check-key): New test.

2021-11-30  Juri Linkov  <juri@linkov.net>

	* lisp/repeat.el (repeat-keep-prefix): Change default to nil.

	'repeat-keep-prefix' doesn't yet have sufficient support
	that covers all cases in bug#51281, so it's disabled now.

2021-11-30  Juri Linkov  <juri@linkov.net>

	* test/lisp/repeat-tests.el (repeat-tests-call-b): Test for commit 588caf0b27.

	This tests for 'repeat-map' as a variable instead of a symbol.

2021-11-30  Juri Linkov  <juri@linkov.net>

	* src/callint.c (Fcall_interactively): Fix inhibit_mouse_event_check.

	Don't search for the next mouse event with parameters
	when inhibit-mouse-event-check is non-nil (bug#50067).

2021-11-30  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix regression in gdb-frame-handler

	* lisp/progmodes/gdb-mi.el (gdb-frame-handler): Protect against
	nil fullnames (bug#52196).

2021-11-30  Yuga Ego  <yet@ego.team>  (tiny change)

	Format and index concept 'predicate' in ELisp Intro

	* doc/lispintro/emacs-lisp-intro.texi (Wrong Type of Argument):
	Add index and format definition (bug#52197).

2021-11-29  Protesilaos Stavrou  <info@protesilaos.com>

	Remove problematic characters from modus-themes.org (bug#52126)

	* doc/misc/modus-themes.org
	(Enable and load, Font configurations for Org and others)
	(Note on highlight-parentheses.el, Note on god-mode.el): Update links to
	headings so that they no longer include the removed portions of text.

	(Option for color-coding success state, Option for line highlighting)
	(Option for line numbers, Option for parenthesis matching)
	(Advanced customization, Per-theme customization settings)
	(Case-by-case face specs using the themes' palette)
	(Face specs at scale using the themes' palette)
	(Remap face with local value, Cycle through arbitrary colors)
	(Override colors, Override color saturation)
	(Font configurations for Org and others, Configure bold and italic faces)
	(Custom Org user faces, Update Org block delimiter fontification)
	(Measure color contrast, Load theme depending on time of day)
	(Backdrop for pdf-tools)
	(A theme-agnostic hook for theme loading, Note on EWW and Elfeed fonts)
	(Frequently Asked Questions): Remove parentheses from headings as they
	can cause problems in the .texi version of the file.

2021-11-29  Andreas Schwab  <schwab@linux-m68k.org>

	Avoid undefined behavior when copying part of structure

	* src/dispnew.c (copy_row_except_pointers): Don't use address of
	subobject as starting point.

	(cherry picked from commit 6943786b5c1fe76ea05a3a810512bd6777883710)

2021-11-29  Stefan Kangas  <stefankangas@gmail.com>

	* Makefile.in (PREFERRED_BRANCH): Now emacs-28.

2021-11-28  Eli Zaretskii  <eliz@gnu.org>

	* src/coding.c (Fdecode_coding_region, Fencode_coding_region): Doc fix.

2021-11-27  Mike Kupfer  <mkupfer@alum.berkeley.edu>

	Fix Subject when forwarding message with 2-line From

	* lisp/mh-e/mh-comp.el (mh-forwarded-letter-subject): Collapse
	two-line From headers into a single line (SF#266).  Based on a
	suggestion from Lester Buck (many thanks!).

2021-11-27  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5.1-11-g96d91b

2021-11-27  Eli Zaretskii  <eliz@gnu.org>

	* doc/lispref/commands.texi (Click Events): Fix wording (bug#52142).

2021-11-25  Robert Pluim  <rpluim@gmail.com>

	Fix pdf generation with Texinfo 6.7

	* doc/lispref/display.texi (Size of Displayed Text): Put @group inside
	@example (bug#52102).

2021-11-25  Eli Zaretskii  <eliz@gnu.org>

	Fix 'posn-at-point' near some overlays

	* src/xdisp.c (pos_visible_p): Fix 'posn-at-point' for positions
	just after a display property that draws a fringe bitmap.
	(Bug#52097)

2021-11-25  Narendra Joshi  <narendraj9@gmail.com>  (tiny change)

	* lisp/repeat.el (repeat-post-hook): Add check symbolp rep-map.

2021-11-24  Eli Zaretskii  <eliz@gnu.org>

	Revert "Use @pxref when necessary"

	This reverts commit b4f47d2ee2203a9f22bebeb3d09e0fb3fce2f65e.
	Cleanups should not be done on the release branch: that's
	unnecessary risk.

2021-11-24  Robert Pluim  <rpluim@gmail.com>

	Use @pxref when necessary

	* doc/lispref/customize.texi (Composite Types):
	* doc/lispref/edebug.texi (Specification List):
	* doc/lispref/variables.texi (Local Variables):
	* doc/misc/efaq.texi (Basic keys):
	(Informational files for Emacs):
	* doc/misc/flymake.texi (Locating a master file):
	* doc/misc/gnus.texi (Don't Panic):
	(Oort Gnus):
	* doc/misc/htmlfontify.texi (Non-interactive):
	* doc/misc/mh-e.texi (More About MH-E):
	* doc/misc/pcl-cvs.texi (Entering PCL-CVS):
	* doc/misc/tramp.texi (Remote processes):
	* doc/misc/vhdl-mode.texi (Indentation Calculation):
	(Custom Indentation Functions): Use @pxref when inside parens.

2021-11-24  Michael Albinus  <michael.albinus@gmx.de>

	Backport Tramp fixes, don't merge

	* lisp/net/tramp-sshfs.el (tramp-sshfs-file-name-handler-alist):
	Use `tramp-handle-file-readable-p'.

	* test/lisp/net/tramp-archive-tests.el
	(tramp-archive-test02-file-name-dissect): Use `make-tramp-file-name'.

2021-11-23  Takesi Ayanokoji  <ayanokoji.takesi@gmail.com>  (tiny change)

	Fix typos in documentation

	* doc/lispref/anti.texi:
	* doc/misc/efaq.texi: Fix typos.

2021-11-22  Eli Zaretskii  <eliz@gnu.org>

	Fix '(space :relative-width N)' display spec w/non-ASCII chars

	* src/xdisp.c (produce_stretch_glyph): Use the correct face for
	non-ASCII characters.  Support :relative-width display spec on
	Lisp strings, not just on buffer text.

2021-11-22  Juri Linkov  <juri@linkov.net>

	* lisp/proced.el (proced-sort-header): Fix event positions (bug#1779).

	The logic was copied from 'tabulated-list-col-sort'.

2021-11-20  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5-72-gc5d6656

2021-11-20  Eli Zaretskii  <eliz@gnu.org>

	Fix mouse handling with several TTY frames on MS-Windows

	* src/w32inevt.c (do_mouse_event): Reset the 'mouse_moved' flag of
	the selected frame.  Without that, this flag might remain set on a
	TTY frame that is not displayed.

2021-11-20  Eli Zaretskii  <eliz@gnu.org>

	Fix temacs invocation from outside of the 'src' directory

	* src/emacs.c (main) [HAVE_NATIVE_COMP]: Recompute the value of
	native-comp-eln-load-path if about to load loadup in uninitialized
	Emacs.  (Bug#51999)

2021-11-20  martin rudalics  <rudalics@gmx.at>

	Fix mouse events on tab bar or tool bar when 'track-mouse' is t

	* lisp/mouse.el (mouse-drag-track):
	* lisp/mouse-drag.el (mouse-drag-drag): Set 'track-mouse' to some
	value neither t nor nil.
	* src/keyboard.c (make_lispy_position): If track_mouse is Qt,
	report event on tool or tab bar (Bug#51794).

2021-11-20  Po Lu  <luangruo@yahoo.com>

	Fix `browse-url-interactive-arg' for certain kinds of events

	* lisp/net/browse-url.el (browse-url-interactive-arg): Don't
	call `mouse-set-point' unless event is actually a mouse event.

2021-11-19  Michael Albinus  <michael.albinus@gmx.de>

	* test/lisp/net/tramp-tests.el (tramp-get-remote-gid): Remove declaration.

2021-11-19  Michael Albinus  <michael.albinus@gmx.de>

	Add upward compatibility entry in Tramp (don't merge)

	* lisp/net/tramp.el (tramp-file-name-for-operation):
	Add `abbreviate-file-name'.

2021-11-18  Juri Linkov  <juri@linkov.net>

	Fix sorting of menus in `context-menu-local' (bug#50067).

	* lisp/menu-bar.el (menu-bar-keymap): Don't use `lookup-key'
	on the `keymap' arg.

	* lisp/mouse.el (context-menu-global): Use `lookup-key global-map'
	for the `keymap' arg of `menu-bar-keymap'.
	(context-menu-local): Use `menu-bar-keymap' to sort `keymap'.

2021-11-18  Juri Linkov  <juri@linkov.net>

	Fix flyspell-correct-word selected from context menu opened with the keyboard

	* lisp/mouse.el (context-menu-open): Call interactively a command
	returned by `context-menu-map' such as `flyspell-correct-word' (bug#50067).

	* lisp/textmodes/flyspell.el (flyspell-correct-word): Handle the
	case when it's called by a key bound to `context-menu-open'.
	Then it should work the same way as `C-c $' typed on misspelled word
	where the arg `event' of `flyspell-correct-word-before-point' is nil.

2021-11-18  Robert Pluim  <rpluim@gmail.com>

	* lisp/repeat.el (describe-repeat-maps): Print all bound keys (bug#49265).

2021-11-18  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el: Use 'mouse-1' for history buttons like for 'add-tab' button

	* lisp/tab-bar.el (tab-bar-mouse-down-1, tab-bar-mouse-1):
	Handle clicks for 'history-back' and 'history-forward' the same way
	as 'add-tab' clicks.

2021-11-18  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of window hooks

	* doc/lispref/windows.texi (Window Hooks): Clarify "buffer-local
	functions".  (Bug#51930)

2021-11-18  Eli Zaretskii  <eliz@gnu.org>

	Improve doc string of 'highlight-nonselected-windows'

	* src/xdisp.c (syms_of_xdisp) <highlight-nonselected-windows>:
	Clarify the doc string.  (Bug#51927)

2021-11-17  Stefan Kangas  <stefankangas@gmail.com>

	* admin/authors.el (authors-ignored-files): Ignore some NEWS files.

2021-11-16  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el (tab-bar-select-tab): Add check for wc-frame (bug#51883).

2021-11-16  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el: Doc fixes for commands bound to modifier keys.

	(tab-bar-select-tab-modifiers)
	(tab-bar-select-tab, tab-bar-switch-to-last-tab): Doc fixes.

2021-11-15  Eli Zaretskii  <eliz@gnu.org>

	Fix removal of fringe marks of deleted bookmarks

	* lisp/bookmark.el (bookmark--remove-fringe-mark): The fringe
	overlay is at BOL, not at POS.  (Bug#51233)

2021-11-15  Juri Linkov  <juri@linkov.net>

	* lisp/repeat.el (repeat-echo-message): Bind message-log-max to nil.

	Don't insert messages about repeatable keys in the *Messages* buffer.

2021-11-15  Robert Pluim  <rpluim@gmail.com>

	* lisp/repeat.el (describe-repeat-maps): Use help-fns--analyze-function.

	Print keys bound to commands in every keymap (bug#49265)

2021-11-15  Juri Linkov  <juri@linkov.net>

	* lisp/repeat.el: Detect changes in the minibuffer state (bug#47566)

	(repeat--prev-mb): New internal variable.
	(repeat-post-hook): Check the property 'repeat-map' on the symbol
	from 'this-command' in addition to 'real-this-command'.  Don't allow
	repeatable maps in the activated minibuffer or in the minibuffer
	from another command.  Set 'repeat--prev-mb' at the end.

2021-11-15  Eli Zaretskii  <eliz@gnu.org>

	Avoid segfaults due to freed face cache

	* src/xfaces.c (face_at_buffer_position): Make sure DEFAULT_FACE
	is usable.  (Bug#51864)

2021-11-15  Stefan Kangas  <stefankangas@gmail.com>

	Doc fix; change recommended file name of custom-file

	* lisp/cus-edit.el (custom-file): Change file name recommendation to
	match Info node '(emacs) Saving Customizations'.

2021-11-14  Philip Kaludercic  <philipk@posteo.net>

	* lisp/net/rcirc.el (rcirc-define-command): Fix interactive-spec generation

	(rcirc-define-command):  Wrap interactive spec in a list call.

2021-11-14  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix `C-h k' in gnus-article-mode (don't merge)

	* lisp/gnus/gnus-art.el (gnus-article-describe-key):
	(gnus-article-describe-key-briefly): Fix `describe-key' calling
	convention (bug#51796).

2021-11-14  Daniel Martín  <mardani29@yahoo.es>

	Fix semantic-symref-perform-search doc string

	* lisp/cedet/semantic/symref/cscope.el (semantic-symref-perform-search):
	Fix the docstring to refer to the correct tool (bug#51846).

2021-11-14  Eli Zaretskii  <eliz@gnu.org>

	Add more files to be natively-compiled AOT

	* src/Makefile.in (elnlisp): Add emacs-lisp/gv.eln and other
	missing dependencies of comp.el.

2021-11-14  Lars Ingebrigtsen  <larsi@gnus.org>

	gnus-summary-line-format doc string clarification

	* lisp/gnus/gnus.el (gnus-summary-line-format): Clarify the Date
	part of the doc string (bug#51823).

2021-11-13  Alan Mackenzie  <acm@muc.de>

	Fix follow-scroll-down in a small buffer which starts slightly scrolled

	This fixes bug #51814.

	* lisp/follow.el (follow-scroll-down): Do away with the optimization of doing
	vertical-motion over only one window.  Instead move over all windows, to
	check for being close to point-min, and setting point accordingly.

2021-11-13  Eli Zaretskii  <eliz@gnu.org>

	Fix compilation on MS-Windows

	* src/callproc.c (emacs_spawn) <fork_done>: Define the label only
	if USABLE_POSIX_SPAWN is defined, to avoid a compiler warning.

	(cherry picked from commit a8fc08085110de00ebcbd67b5273a755a5cb8ea1)

2021-11-13  Philipp Stephani  <phst@google.com>

	Use posix_spawn if possible.

	posix_spawn is less error-prone than vfork + execve, and can make
	better use of system-specific enhancements like 'clone' on Linux.  Use
	it if we don't need to configure a pseudoterminal.

	Backported from commit a60053f8368e058229721f1bf1567c2b1676b239.
	Unlike that commit, only define USABLE_POSIX_SPAWN on macOS, because
	there posix_spawn is much faster than vfork.

	Don't merge to master.

	* configure.ac (HAVE_SPAWN_H, HAVE_POSIX_SPAWN)
	(HAVE_POSIX_SPAWN_FILE_ACTIONS_ADDCHDIR)
	(HAVE_POSIX_SPAWN_FILE_ACTIONS_ADDCHDIR_NP)
	(HAVE_POSIX_SPAWNATTR_SETFLAGS, HAVE_DECL_POSIX_SPAWN_SETSID): New
	configuration variables.
	* src/callproc.c (USABLE_POSIX_SPAWN): New configuration macro.
	(emacs_posix_spawn_init_actions)
	(emacs_posix_spawn_init_attributes, emacs_posix_spawn_init): New
	helper functions.
	(emacs_spawn): Use posix_spawn if possible.

	(cherry picked from commit a60053f8368e058229721f1bf1567c2b1676b239)

2021-11-13  Eli Zaretskii  <eliz@gnu.org>

	Improve style and comments in font-related sources

	* src/w32font.c (fill_in_logfont): Stylistic changes.
	* src/font.h (font_property_index, font_select_entity):
	Add/improve comments.

2021-11-12  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'decode-coding-region'

	* src/coding.c (Fdecode_coding_region): Doc fix.

	* doc/lispref/nonascii.texi (Coding System Basics)
	(Explicit Encoding): Explain the significance of using 'undecided'
	in 'decode-coding-*' functions.

2021-11-12  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix problem with temp buffer killing in package-install-file

	* lisp/emacs-lisp/package.el (package-install-file): Allow killing
	the temporary buffer without querying (bug#51769).

2021-11-12  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix Lisp Intro markup error

	* doc/lispintro/emacs-lisp-intro.texi (Insert let): Fix @code
	markup error (bug#51777).

2021-11-11  Eli Zaretskii  <eliz@gnu.org>

	Fix ACL errors with WebDAV volumes on MS-Windows

	* src/w32.c (acl_get_file): Handle ERROR_INVALID_FUNCTION from
	WebDAV.  Patch from Ioannis Kappas <ioannis.kappas@gmail.com>.
	(Bug#51773)

2021-11-11  Aleksandr Vityazev  <avityazev@posteo.org>

	Fix tramp-compat-file-name-concat (Bug#51754)

	* lisp/net/tramp-compat.el: Make `tramp-compat-file-name-concat'
	work like file-name-concat.  (Bug#51754)

2021-11-10  Juri Linkov  <juri@linkov.net>

	* lisp/vc/vc-git.el (vc-git-mergebase): More meaningful error message.

	Display a readable error message instead of signaling an error on nil value.

2021-11-10  Stephen Gildea  <stepheng+emacs@gildea.com>

	time-stamp: %F is "file name" not "pathname" + other doc

	* lisp/time-stamp.el (time-stamp-format): doc 'file' instead of 'path'.
	* test/lisp/time-stamp-tests.el (formatz, format-time-offset):
	Clarify the difference and similarity between these two test helpers.

2021-11-09  Juri Linkov  <juri@linkov.net>

	* doc/misc/eww.texi (Advanced): Fix missed variable name eww-retrieve-command.

2021-11-09  Juri Linkov  <juri@linkov.net>

	* doc/emacs/windows.texi (Window Convenience): Use @code for windmove.

	This refers to both a command and a user option.

	* etc/NEWS: Add some ---.

2021-11-09  Juri Linkov  <juri@linkov.net>

	* doc/emacs/maintaining.texi (Basic VC Editing): Mention Dired buffer.

	* doc/emacs/text.texi (Outline Mode): Replace S-TAB with S-<TAB>.

	* etc/NEWS: Add some missing +++/--- and move some related items closer.

2021-11-09  Juri Linkov  <juri@linkov.net>

	* lisp/progmodes/prog-mode.el (prog-context-menu): Use "Go Back" (bug#38797)

2021-11-09  Stefan Kangas  <stefankangas@gmail.com>

	Revert "Fix localized display of date and time in the NS port"

	This reverts commit 5e05be566b0e13ce0b4e75da663fb051039f0751.

	This was discussed in
	https://debbugs.gnu.org/cgi/bugreport.cgi?bug=51321#93

2021-11-08  Juri Linkov  <juri@linkov.net>

	* lisp/mouse.el (mouse-buffer-menu-mode-groups): Tighten "Version Control".

	Use word boundaries in the "Version Control" regexp to match mode names
	"Log-Edit", "Log-View", "Git-Log-View", "Change Log", "VC dir",
	but not "Verilog", "Prolog", "Rlogin" (bug#51337).

2021-11-08  Juri Linkov  <juri@linkov.net>

	* doc/emacs/search.texi (Isearch Yank): Add isearch-forward-thing-at-point.

2021-11-07  Alan Mackenzie  <acm@muc.de>

	Amend Follow Mode to handle header lines and tab lines correctly

	This fixes bug #51590.

	list/follow.el (follow-scroll-down): Incorporate the height of the tab line
	into the calculation of the window height.
	(follow-calc-win-end): Incorporate the pixel heights of the header line and
	the tab line the calculation of the buffer position of the bottom screen line.

2021-11-07  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/files.el (user-emacs-directory-warning): Clarify docstring.

2021-11-07  Juri Linkov  <juri@linkov.net>

	* doc/emacs/frames.texi (Tab Bars): Add text about mouse and tab-bar-format

	Briefly describe mouse commands on the tab bar and tab-bar-format (bug#51444)

2021-11-07  Juri Linkov  <juri@linkov.net>

	* doc/emacs/frames.texi (Tab Bars): Describe tab-last.

	'C-9' and 'M-9' already had kindex, so describe them in the text as well
	(bug#51444).

2021-11-07  Jim Porter  <jporterbugs@gmail.com>

	Add some unit tests for 'abbreviate-file-name'

	* test/lisp/files-tests.el (files-tests-abbreviate-file-name-homedir)
	(files-tests-abbreviate-file-name-directory-abbrev-alist): New tests.

2021-11-07  Eli Zaretskii  <eliz@gnu.org>

	Fix compilation MinGW warnings

	* src/w32.h (prepare_standard_handles, reset_standard_handles):
	Fix prototypes.  Reported by Andy Moreton
	<andrewjmoreton@gmail.com> in
	https://lists.gnu.org/archive/html/emacs-devel/2021-11/msg00597.html.

2021-11-06  Stefan Kangas  <stefankangas@gmail.com>

	Escape '%' in filenames to fix flymake warnings

	* lisp/progmodes/flymake.el (flymake--log-1): Escape '%' in filenames
	for 'warning-type-format' so they are not interpreted as a %-sequence
	by 'format' later.  (Bug#51549)

2021-11-06  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix search string generation in nnimap-make-thread-query

	* lisp/gnus/nnimap.el (nnimap-make-thread-query): Remove text
	properties before constructing the search string (bug#49926).

2021-11-06  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5-68-g77e2ec

2021-11-06  Michael Albinus  <michael.albinus@gmx.de>

	Fix dbus-test04-register-method on CentOS (Bug#51369)

	* test/lisp/net/dbus-tests.el (dbus-test04-register-method):
	Fix problem on CentOS.  (Bug#51369)

2021-11-06  Jonas Bernoulli  <jonas@bernoul.li>

	* lisp/transient.el: Update to package version v0.3.7-11-g7f5520b3.

2021-11-06  Eli Zaretskii  <eliz@gnu.org>

	Clarify "text area of a window" in the documentation

	* src/keyboard.c (Fposn_at_x_y): Clarify that the Y coordinate
	includes the header-line and the tab-line.  (Bug#51590)

	* doc/lispref/windows.texi (Window Sizes, Splitting Windows)
	(Textual Scrolling, Coordinates and Windows): Fix/remove improper
	or confusing uses of "text area" of a window.

2021-11-06  Stefan Kangas  <stefankangas@gmail.com>

	Improve docstring of kmacro-set-format

	* lisp/kmacro.el (kmacro-set-format): Improve docstring.
	(kmacro-insert-counter, kmacro-display-counter)
	(kmacro-set-counter, kmacro-add-counter): Add cross-references
	to the info manual.

2021-11-05  Stefan Kangas  <stefankangas@gmail.com>

	Revert "* lisp/wid-edit.el (widget-field): Add subtle border to face."

	This reverts commit 8b024a6ff10f7907445ea60c4db8355638616ed1.

	This lead to some alignment issues.  (Bug#51550)
	Don't merge to master, where we will continue investigating.

2021-11-05  Stefan Kangas  <stefankangas@gmail.com>

	* etc/PROBLEMS: Mention X forwarding slowdowns.  (Bug#7092)

2021-11-04  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/custom.el (defgroup): Document the :prefix keyword.

2021-11-04  Thibault Polge  <thibault@thb.lt>

	Document ibuffer-auto-mode in ibuffer-mode doc string

	* lisp/ibuffer.el (ibuffer-mode): Mention ibuffer-auto-mode in the
	ibuffer-mode doc string (bug#51584).

2021-11-04  Juri Linkov  <juri@linkov.net>

	* doc/emacs/frames.texi (Tab Bars): Reorder toggle-frame-tab-bar.

2021-11-04  Stefan Kangas  <stefankangas@gmail.com>

	Use current face foreground for SVG icons in customize

	It turns out these few icons were missed when the color and size
	information was removed from the SVG icons that replaced XPM icons for
	Customize buffer.
	* etc/images/down.svg:
	* etc/images/left.svg:
	* etc/images/right.svg:
	* etc/images/up.svg: Don't define foreground; this means they will use
	the foreground of the currently defined face instead.  (Bug#51556)

	(cherry picked from commit 11702a6dd7cb8286f28b7cb986057d2d2c66a914)

2021-11-03  Juri Linkov  <juri@linkov.net>

	* doc/emacs/building.texi (Compilation Mode): Add next-error-message-highlight

	The variable 'next-error-message-highlight' already has vindex,
	so describe it in the text as well (bug#51444).

2021-11-03  Daniel Martín  <mardani29@yahoo.es>

	Document a macOS error message when opening Emacs

	* etc/PROBLEMS: Document a potential error message when opening Emacs
	on macOS for the first time.

2021-11-03  Eli Zaretskii  <eliz@gnu.org>

	Fix header-line and tab-line when mode-line-compact is set

	* src/xdisp.c (display_mode_line): Make 'mode-line-compact' apply
	only to mode lines.  (Bug#51558)

2021-11-03  Mattias Engdegård  <mattiase@acm.org>

	Add manual section about how to avoid regexp problems

	Help users affected by our NFA engine's stack overflows and occasional
	poor performance, replacing old text that was more limited in scope.

	* doc/lispref/elisp.texi (Top):
	* doc/lispref/searching.texi (Regular Expressions): Add menu entries.
	(Regexp Problems): New node.
	(Regexp Special):
	* etc/PROBLEMS: Remove superseded text.

2021-11-03  Phillip Lord  <phillip.lord@russet.org.uk>

	Clarify build environment

	* admin/nt/dist-build/README-scripts:

2021-11-03  Phillip Lord  <phillip.lord@russet.org.uk>

	Clarify build directory structure

	* admin/nt/dist-build/README-scripts: Clarify build directory structure

2021-11-02  Andrea Corallo  <akrl@sdf.org>

	* src/pdumper.c (dump_do_dump_relocation): Add sanity check.

2021-11-01  Juri Linkov  <juri@linkov.net>

	* lisp/progmodes/prog-mode.el (prog-context-menu): Use text-mode-context-menu.

2021-11-01  Michael Albinus  <michael.albinus@gmx.de>

	Fix bug#51369

	* test/lisp/net/dbus-tests.el (dbus-test04-register-method): Skip on hydra.

2021-11-01  Michael Albinus  <michael.albinus@gmx.de>

	Adapt arguments of `tramp-make-tramp-file-name'

	* lisp/net/tramp-gvfs.el (tramp-gvfs-handler-mounted-unmounted):
	* lisp/url/url-tramp.el (url-tramp-convert-url-to-tramp):
	Use `make-tramp-file-name'.

	* lisp/obsolete/rcompile.el (remote-compile): Pacify byte-compiler.

2021-11-01  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix typo in describe-map-tree doc string

	* lisp/help.el (describe-map-tree): Fix typo in doc string.

2021-11-01  Ken Brown  <kbrown@cornell.edu>

	Drop support for native compilation on 32-bit Cygwin

	* configure.ac (cygwin32-native-compilation): New option.
	[i686-pc-cygwin]: Don't allow native compilation unless that
	option is specified.  (Bug#50666)

2021-10-31  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix rendering of title-less <abbr> tags in shr

	* lisp/net/shr.el (shr-tag-abbr): Render <abbr> tags that have no
	title (bug#51525).

2021-10-31  Eli Zaretskii  <eliz@gnu.org>

	Avoid signaling errors in lookup-key

	* src/keymap.c (Flookup_key): Handle KEY vectors where not all
	components are symbols.  (Bug#51527)  Do not merge to master.

2021-10-31  Daniel Martín  <mardani29@yahoo.es>

	Fix localized display of date and time in the NS port

	* src/nsterm.m (ns_init_locale): If not already set, set LC_ALL to the
	current locale ID so that dates, currencies, etc. use the settings
	configured in the operating system.  (Bug#51321)

2021-10-31  Eli Zaretskii  <eliz@gnu.org>

	Fix display glitches with side-by-side windows on TTY frames

	* src/dispnew.c (adjust_glyph_matrix, prepare_desired_row): Leave
	room for the border glyph only if the window does actually have
	the right margin.  (Bug#51521)

2021-10-30  Carlos Pita  <carlosjosepita@gmail.com>

	Avoid replacing common prefix with ellipsis

	* lisp/progmodes/python.el
	(python-shell-completion-native-setup): Configure readline not to
	suppress common prefixes.  (Bug#51218)

2021-10-30  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of string truncation APIs

	* doc/lispref/display.texi (Size of Displayed Text):
	* lisp/international/mule-util.el (truncate-string-to-width):
	Document caveats of using 'truncate-string-to-width' when
	character composition is involved.

	* lisp/emacs-lisp/subr-x.el (string-limit):
	* doc/lispref/strings.texi (Creating Strings): Improve the
	documentation of 'string-limit'.

2021-10-29  Imran Khan  <contact@imrankhan.live>  (tiny change)

	* lisp/textmodes/css-mode.el: Fix typo.  (Bug#51488)

2021-10-29  Lars Ingebrigtsen  <larsi@gnus.org>

	Make message/rfc822 on buttons work again in Gnus

	* lisp/gnus/gnus-art.el (gnus-article-mode): Set
	mm-inline-message-prepare-function buffer-locally so that it works
	both when inlining rfc822 and hitting the MIME button (bug#51388).
	(gnus-mime--inline-message): Factor out into own function.
	(gnus-mime-display-single): From here.

2021-10-29  Glenn Morris  <rgm@gnu.org>

	* lisp/loadup.el: Unbreak build.

2021-10-29  Lars Ingebrigtsen  <larsi@gnus.org>

	Move lisp/shorthands.el to lisp/emacs-lisp/shorthands.el

2021-10-29  Michael Albinus  <michael.albinus@gmx.de>

	Some Tramp changes, mainly in tramp-tests.el

	* doc/misc/tramp.texi (External packages): Don't use Tramp internals.

	* lisp/net/tramp-gvfs.el (tramp-gvfs-handler-mounted-unmounted):
	Protect `tramp-make-tramp-file-name' call.

	* lisp/net/tramp.el (tramp-make-tramp-file-name): Set advertised
	calling conventions.

	* test/lisp/net/tramp-tests.el (tramp-test18-file-attributes):
	Adapt test.
	(tramp--test-supports-processes-p): New defun.
	(tramp-test28-process-file, tramp-test29-start-file-process)
	(tramp-test30-make-process, tramp-test32-shell-command)
	(tramp-test32-shell-command-dont-erase-buffer)
	(tramp-test34-explicit-shell-file-name, tramp-test35-exec-path)
	(tramp-test44-asynchronous-requests): Use it.

2021-10-29  Gregory Heytings  <gregory@heytings.org>

	Make hieroglyphs display correctly with existing fonts

	* etc/HELLO: Remove hieroglyph format control characters.

	* lisp/language/misc-lang.el: Add a rule to compose Egyptian
	hieroglyphs even without Unicode format control characters.

2021-10-29  Eli Zaretskii  <eliz@gnu.org>

	Clarify "default face attributes" in the ELisp manual

	* doc/lispref/display.texi (Defining Faces): Add index entries for
	face symbol properties.
	(Attribute Functions): Clarify "default face attribute values" wrt
	'face-all-attributes' and 'face-attribute'.  (Bug#51465)

2021-10-28  Lars Ingebrigtsen  <larsi@gnus.org>

	Make `C-u RET' work again

	* lisp/simple.el (newline): Fix regression introduced by
	d1aacceae9 (bug#51459).

2021-10-28  Jan Synacek  <jan.synacek@gmail.com>  (tiny change)

	Fix typos in the manual and in a comment

	* lisp/minibuffer.el (completion-pcm--hilit-commonality):
	* doc/lispintro/emacs-lisp-intro.texi (Mode Line): Fix typos
	(bug#51434).

2021-10-28  Eli Zaretskii  <eliz@gnu.org>

	Avoid assertion violations in 'lookup-key'

	* src/keymap.c (Flookup_key): Don't call ASIZE unless KEY is a
	vector.  This avoids assertion violations when KEY is a string.

2021-10-28  Stefan Kangas  <stefankangas@gmail.com>

	image-dired: Unreverse accidentally reversed menus

	* lisp/image-dired.el (image-dired-thumbnail-mode-map)
	(image-dired-display-image-mode-map, image-dired-minor-mode-map):
	In Emacs 26.1 (commits b905454680c7 and bed0373855ea), the menus were
	converted to use 'easy-menu-define', but they were reversed in the
	process.  Unreverse the menus.  (Bug#51446)

2021-10-28  Stefan Kangas  <stefankangas@gmail.com>

	Be more allowing when looking for menu-bar items

	Don't merge to master.  This is a safe-for-release fix for Bug#50752.

	* src/keymap.c (lookup_key_1): Factor out function from
	Flookup_key.
	(Flookup_key): Be case insensitive when looking for Qmenu_bar
	items.  (Bug#50752)

	* test/src/keymap-tests.el
	(keymap-lookup-key/mixed-case)
	(keymap-lookup-key/mixed-case-multibyte): New tests.

2021-10-27  Juri Linkov  <juri@linkov.net>

	* lisp/textmodes/text-mode.el (text-mode-context-menu): Rename recently added.

2021-10-27  Robert Pluim  <rpluim@gmail.com>

	Allow automatic use of color fonts for emoji on macOS

	* src/macfont.m (macfont_list): Don't exclude color fonts when the
	fontspec has an 'emoji' script specification.

2021-10-27  Eli Zaretskii  <eliz@gnu.org>

	Fix help commands for menu-bar menus

	* lisp/help.el (help--analyze-key): Fix "C-h c" and "C-h k" on
	menu-bar menu items.  (Bug#51421)

2021-10-26  Stefan Kangas  <stefankangas@gmail.com>

	Improve function documentation with text from XDG BDS spec

	* lisp/xdg.el (xdg-config-home, xdg-cache-home, xdg-data-home)
	(xdg-runtime-dir, xdg-config-dirs, xdg-data-dirs): Copy in the
	text from the XDG Base Directory Specification to better explain
	what these functions return.

2021-10-25  Jonas Bernoulli  <jonas@bernoul.li>

	* lisp/transient.el: Update to package version 0.3.7.

2021-10-25  Eli Zaretskii  <eliz@gnu.org>

	Revert "Fix a typo in emacs-lisp-intro.texi"

	This reverts commit 98eb6d783a482cd7ebca7ec656b0775b82c68e57.
	I've consulted with Richard Stallman about this, and he says
	that the original wording, "kinds of atom", is both correct
	and more elegant writing.  So I'm restoring the original text.
	* doc/lispintro/emacs-lisp-intro.texi (Lisp Atoms): Undo the
	fix of a "typo" that wasn't a typo.  (Bug#51271)

2021-10-25  Robert Pluim  <rpluim@gmail.com>

	* doc/lispref/functions.texi (Mapping Functions): Use #' when mapping.

2021-10-25  Miha Rihtaršič  <miha@kamnitnik.top>

	Fix issue with interpreting ANSI codes in eshell

	* lisp/eshell/esh-mode.el (eshell-mode): Make window point advance on
	insertion.
	(eshell-output-filter): Don't use insert-before-markers (bug#45380).

2021-10-25  Stefan Kangas  <stefankangas@gmail.com>

	image-dired: Doc fix to better explain thumbnail generation

	* doc/emacs/dired.texi (Image-Dired): Improve description by
	explaining that the generation of thumbnails is asynchronous.

2021-10-25  Stefan Kangas  <stefankangas@gmail.com>

	Clarify two image-dired docstrings

	* lisp/image-dired.el (image-dired-dir): Doc fix; clarify that
	thumbnails will be saved in "$XDG_CACHE_HOME/thumbnails", as per the
	Thumbnail Managing Standard.
	(image-dired-thumb-size): Doc fix; clarify that this option will be
	ignored when using the Thumbnail Managing Standard.

2021-10-25  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix flymake example backend conditions in the manual

	* doc/misc/flymake.texi (An annotated example backend): Also react
	to `signal' process statuses (bug#51380).

2021-10-24  Stefan Kangas  <stefankangas@gmail.com>

	* etc/PROBLEMS: Mention problems with regexp matcher.  (Bug#18577)

2021-10-24  Juri Linkov  <juri@linkov.net>

	* test/lisp/repeat-tests.el: New file.

2021-10-24  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el (tab-bar-move-repeat-map): Fix alias binding of tab-move.

	(tab-bar-move-tab-backward): Put 'repeat-map' symbol property.

2021-10-24  Stefan Kangas  <stefankangas@gmail.com>

	Use restrictive umask when creating image-dired data

	* lisp/image-dired.el (image-dired-dir)
	(image-dired-sane-db-file): Create thumbnail directory and
	.image-dired_db with umask 077.  This avoids creating world readable
	copies of private data, and is in fact mandated by the Thumbnail
	Managing Standard that we aim to support.

2021-10-24  Eli Zaretskii  <eliz@gnu.org>

	Fix compilation errors with MinGW64 GCC 11

	* lib-src/ntlib.c (_GL_ATTRIBUTE_MALLOC)
	(_GL_ATTRIBUTE_DEALLOC_FREE): Define to avoid compilation errors
	with MinGW64 GCC 11.  Suggested by Andy Moreton
	<andrewjmoreton@gmail.com>.  Do not merge to master.

2021-10-24  Ihor Radchenko  <yantar92@gmail.com>

	Doc fix for concat

	* src/fns.c (Fconcat): Note that composition values may not remain eq
	in return value of concat.  (Bug#48740)

2021-10-24  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/image-dired.el (image-dired-external-viewer): Support feh.

2021-10-24  Stefan Kangas  <stefankangas@gmail.com>

	Update publicsuffix.txt from upstream

	* etc/publicsuffix.txt: Update from
	https://publicsuffix.org/list/public_suffix_list.dat
	dated 2021-10-16 16:33:47 GMT.

2021-10-24  Stefan Kangas  <stefankangas@gmail.com>

	Refer to the info node on keymaps in map-keymap docstring

	* src/keymap.c (Fmap_keymap): Doc fix; add a reference to the Info
	node '(elisp) Keymaps'.  (Bug#30958)

2021-10-23  Stefan Kangas  <stefankangas@gmail.com>

	Clarify abnormal hook documentation

	* doc/lispref/hooks.texi (Standard Hooks):
	* doc/lispref/modes.texi (Hooks): Clarify wording of "abnormal
	hook" documentation.  (Bug#34588)

2021-10-23  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5-59-g52e6f1

2021-10-23  Stefan Kangas  <stefankangas@gmail.com>

	Improve documentation of cl-reduce

	* doc/misc/cl.texi (Mapping over Sequences): Change the
	explanation of 'cl-reduce' so you don't need to have a major in
	mathematics to understand it.  (Bug#24014)

2021-10-23  Stefan Kangas  <stefankangas@gmail.com>

	Improve documentation of apply-partially

	* doc/lispref/functions.texi (Calling Functions): Improve
	documentation of 'apply-partially' to be slightly more clear with
	regards to function arity.  (Bug#17623)

2021-10-23  Michael Albinus  <michael.albinus@gmx.de>

	Fix typos

	* doc/emacs/cmdargs.texi:
	* etc/DEBUG:
	* etc/NEWS: Fix typos.

2021-10-23  Michael Albinus  <michael.albinus@gmx.de>

	Revert commit 225ca617b7, and apply another fix

	* lisp/minibuffer.el (read-file-name-default): Revert commit
	225ca617b7.  (Bug#50976).

	* lisp/shell.el (shell): Remove volume letter for remote shell
	file name.  (Bug#49229)

2021-10-23  Stefan Kangas  <stefankangas@gmail.com>

	Fix documentation of posn-at-x-y

	* doc/lispref/commands.texi (Accessing Mouse): Fix documentation of
	'posn-at-x-y' to match docstring.  (Bug#15783)

2021-10-22  Robert Pluim  <rpluim@gmail.com>

	Improve some NEWS entries

	* etc/NEWS: Improve some NEWS entries.

2021-10-22  Robert Pluim  <rpluim@gmail.com>

	Improve documentation of syntax-ppss-context slightly

	* doc/lispref/syntax.texi (Parser State): Document all possible return
	values from 'syntax-ppss-context'.

2021-10-22  Robert Pluim  <rpluim@gmail.com>

	Move some xwidget entries

	* etc/NEWS: Move xwidget entries to correct location.

2021-10-22  Stephen Gildea  <stepheng+emacs@gildea.com>

	time-stamp-tests: improvements to test macros

	test/lisp/time-stamp-tests.el: Update macro declarations.
	(formatz-generate-tests): Don't nconc onto a constant list.
	Tests now run 12% faster in batch mode.

2021-10-22  Itai Y. Efrat  <itai3397@gmail.com>

	Fix rfc6068-parse-mailto-url autoload

	* lisp/net/browse-url.el (rfc6068-parse-mailto-url): Fix autoload
	cookie (bug#51333).

2021-10-22  Lars Ingebrigtsen  <larsi@gnus.org>

	Regexp-quote github domains in bug-reference

	* lisp/progmodes/bug-reference.el
	(bug-reference--build-forge-setup-entry): Regexp-quote the domain
	(bug#51316).

2021-10-22  Lars Ingebrigtsen  <larsi@gnus.org>

	Ensure valid end/beginning lines in message-mark-inserted-region

	* lisp/gnus/message.el (message-mark-inserted-region): Ensure
	there's a newline before inserting the end line (bug#51324).

2021-10-22  Robert Pluim  <rpluim@gmail.com>

	* etc/NEWS: Improve 'repeat-mode' entry.

	* lisp/repeat.el (repeat-keep-prefix): Expand description.

	* lisp/net/eww.el (eww-retrieve-command): Add :tag.

2021-10-22  Stefan Kangas  <stefankangas@gmail.com>

	Add description of cards to etc/refcards/README

	* etc/refcards/README: List all the generated reference cards,
	including their translations.  (Bug#8932)

2021-10-22  Martin Rudalics  <rudalics@gmx.at>

	Fix 'calculate-lisp-indent' when "[" starts containing sexp (Bug#51312)

	* lisp/emacs-lisp/lisp-mode.el (calculate-lisp-indent): Handle
	arbitrary paren syntax after skipping whitespace backwards within
	containing sexp (Bug#51312).

2021-10-22  Stefan Kangas  <stefankangas@gmail.com>

	Fix typo in doc/emacs/anti.texi

	* doc/emacs/anti.texi (Antinews): Fix typo.  (Bug#51325)
	Reported by Po Lu <luangruo@yahoo.com>.

2021-10-22  Stephen Gildea  <stepheng+emacs@gildea.com>

	Update doc of Edebug specification for macros

	doc/lispref/edebug.texi:  Update documentation of Edebug specification:
	- Do not document "0" as a recommended shortcut for non-instrumented
	arguments; nobody knows about nor uses this, so don't encourage it.
	- Add an example equivalent to (declare (debug (&rest sexp))).

2021-10-21  Eli Zaretskii  <eliz@gnu.org>

	Fix non-interactive behavior of 'kill-region'

	* lisp/simple.el (kill-region): Actually ignore BEG and END when
	REGION is non-nil.  Doc fix.  (Bug#51320)

2021-10-21  Juri Linkov  <juri@linkov.net>

	* test/lisp/dabbrev-tests.el: Use 'kbd' for readable keys.

	(dabbrev-expand-test, dabbrev-completion-test)
	(dabbrev-completion-test-with-argument):
	Use 'kbd' to format keys for 'execute-kbd-macro'.
	(dabbrev-expand-test): Fix docstring.

2021-10-21  Juri Linkov  <juri@linkov.net>

	* lisp/menu-bar.el (menu-bar-keymap): Add optional arg KEYMAP (bug#50067).

	* lisp/mouse.el (context-menu-global): Use 'menu-bar-keymap' with
	its arg KEYMAP set to 'global-map'.

2021-10-21  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix todo-mode AOT test failures (bug#51308)

	Fix hi-lock AOT test failures (bug#51308)

2021-10-21  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix socks test

	* test/lisp/net/socks-tests.el (socks-tests-v4-basic): Fix failure
	under native-comp (bug#51308).

2021-10-20  Juri Linkov  <juri@linkov.net>

	* lisp/help.el (help--analyze-key): Add new arg BUFFER (bug#51173).

	* lisp/help.el (describe-key): Use BUFFER as arg for help--analyze-key.
	(describe-key-briefly): Change arg UNTRANSLATED deprecated in 27.1
	to BUFFER.

	* lisp/gnus/gnus-art.el (gnus-article-describe-key)
	(gnus-article-describe-key-briefly): Call describe-key and
	describe-key-briefly with first arg as a cons with raw keys,
	and the BUFFER arg set to the current buffer.

2021-10-20  Juri Linkov  <juri@linkov.net>

	Improve docstrings and NEWS item of 'repeat-mode'

	* lisp/repeat.el (repeat-exit-timeout, repeat-echo-function)
	(repeat-in-progress, repeat-map): Update docstrings.

2021-10-20  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el (tab-bar-menu-bar): New command (bug#51247).

	(tab-bar-format): Rename option 'tab-bar-format-menu-global' to
	'tab-bar-format-menu-bar'.
	(tab-bar-format-menu-bar): Rename from 'tab-bar-format-menu-global'.

2021-10-20  Po Lu  <luangruo@yahoo.com>

	Display a tab bar item as sunken when appropriate

	When the mouse pointer is pressed on the tab bar, moved out of the tab
	bar, and moved back in, it would be more appropriate to behave like
	other programs by displaying the item as sunken.

	* src/xdisp.c (note_tab_bar_highlight): Display item as sunken if the
	mouse pointer returns to the tab bar down.

2021-10-20  Po Lu  <luangruo@yahoo.com>

	Fix tab bar item highlight when a mouse click is dropped

	* src/xdisp.c (note_mouse_highlight): Clear last_tab_bar_item if the
	movement wasn't made on top of the tab bar.

2021-10-20  Stefan Kangas  <stefankangas@gmail.com>

	Refer to mouse-highlight from make-pointer-invisible docstring

	* src/frame.c (syms_of_frame) <Vmake_pointer_invisible>: Doc fix;
	add reference to 'mouse-highlight'.  (Bug#42889)

2021-10-20  Robert Pluim  <rpluim@gmail.com>

	* etc/PROBLEMS: Add hex codepoint for NO-BREAK SPACE

2021-10-20  Robert Pluim  <rpluim@gmail.com>

	Describe how to debug fontconfig issues

	* etc/PROBLEMS: Add FC_DEBUG usage pointers.

2021-10-20  Michael Albinus  <michael.albinus@gmx.de>

	Adapt Tramp tests

	* test/lisp/net/tramp-archive-tests.el (tramp-archive-test45-auto-load):
	Adapt code snippet.

	* test/lisp/net/tramp-tests.el (tramp-test29-start-file-process)
	(tramp-test30-make-process): Adapt tests.
	(tramp--test-supports-set-file-modes-p): Renamed from
	`tramp--test-supports-file-modes-p'.  Adapt all callees.
	(tramp-test35-exec-path): Use it.

2021-10-20  Jim Porter  <jporterbugs@gmail.com>

	Convert ANSI color definitions in themes to use faces (e.g. 'ansi-color-red')

	* etc/themes/dichromacy-theme.el:
	* etc/themes/leuven-theme.el:
	* etc/themes/misterioso-theme.el:
	* etc/themes/tango-theme.el:
	* etc/themes/tango-dark-theme.el:
	* etc/themes/wombat-theme.el: Convert ANSI color definitions to
	use faces.

2021-10-20  Lars Ingebrigtsen  <larsi@gnus.org>

	Revert "Revert back to using ESC as viper-ESC-key again"

	This reverts commit 5d522b430bd5ecfb8f082906cd634883dbb68f3e.

	The change led to M-x not working in non-gui Emacsen (bug#51253).

2021-10-19  Alan Third  <alan@idiocy.org>

	Fix inset rectangle corners when sides aren't drawn (bug#51251)

	* src/nsterm.m (ns_draw_relief): Make the inner rectangle line up with
	the outer rectangle's edges where the edges aren't drawn.

2021-10-19  Jan Synacek  <jan.synacek@gmail.com>  (tiny change)

	Don't use color escape sequences in vc-git-expanded-log-entry

	* lisp/vc/vc-git.el (vc-git-expanded-log-entry): Use '--no-color' flag
	in git invocation.  (Bug#51262)

2021-10-19  Michael Albinus  <michael.albinus@gmx.de>

	Code cleanup in tramp-tests.el

	* test/lisp/net/tramp-tests.el (tramp-test29-start-file-process)
	(tramp-test30-make-process): Extend tests.
	(tramp--test-out-of-band-p): New defun.
	(tramp--test-windows-nt-and-out-of-band-p)
	(tramp-test42-utf8-with-stat, tramp-test42-utf8-with-perl)
	(tramp-test42-utf8-with-ls): Use it.
	(tramp--test-windows-nt-or-smb-p): Use `tramp--test-windows-nt-p'.

2021-10-19  Robert Pluim  <rpluim@gmail.com>

	* admin/notes/unicode: Refer to Unicode's emoji-style.txt

2021-10-19  Robert Pluim  <rpluim@gmail.com>

	Handle VS-16 correctly for non-emoji codepoints

	* admin/unidata/blocks.awk: Remove emoji overrides for codepoints with
	Emoji_Presentation = No, they're no longer necessary.
	* lisp/composite.el: Remove #xFE0F (VS-16) from the range handled by
	`compose-gstring-for-variation-glyph' so it can be handled by
	`font_range'.
	* src/composite.c (syms_of_composite): New variable
	`auto-composition-emoji-eligible-codepoints'.
	* admin/unidata/emoji-zwj.awk: Generate value for
	`auto-composition-emoji-eligible-codepoints'.  Add
	`composition-function-table' entries for 'codepoint + U+FE0F' for
	them.
	* src/font.c (codepoint_is_emoji_eligible): New function to check if
	we should try to use the emoji font for a codepoint.
	(font_range): Use it.

2021-10-19  Tassilo Horn  <tsdh@gnu.org>

	Adjust bug-reference-bug-regexp default values to match only at beg of word

	Previously, the "bug 1" in "(debug 1)" has also been highlighted.

	* lisp/progmodes/bug-reference.el (bug-reference-bug-regexp)
	(bug-reference--setup-from-vc-alist,bug-reference-setup-from-mail-alist)
	(bug-reference-setup-from-irc-alist): Adjust bug-reference-bug-regexp
	default values to match only at the beginning of a word.

2021-10-19  Stefan Kangas  <stefankangas@gmail.com>

	Fix a typo in emacs-lisp-intro.texi

	* doc/lispintro/emacs-lisp-intro.texi (Lisp Atoms): Fix typo.
	Reported by Mor Zahavi <morzahavi@me.com>.  (Bug#51271)

2021-10-18  Michael Albinus  <michael.albinus@gmx.de>

	Fix some Tramp problems

	* lisp/net/tramp-adb.el (tramp-adb-file-name-handler-alist):
	Use `tramp-adb-handle-file-executable-p' and
	`tramp-adb-handle-file-readable-p'.
	(tramp-adb-handle-file-executable-p)
	(tramp-adb-handle-file-readable-p): New defuns.
	(tramp-adb-handle-file-writable-p): Simplify.
	(tramp-adb-handle-make-process): Handle :filter being t.
	(tramp-adb-find-test-command): Remove.

	* lisp/net/tramp-sh.el (tramp-sh-handle-file-readable-p):
	* lisp/net/tramp-sudoedit.el (tramp-sudoedit-handle-file-readable-p):
	* lisp/net/tramp-gvfs.el (tramp-gvfs-file-name-handler-alist):
	Use `tramp-handle-file-readable-p'.
	(tramp-gvfs-handle-file-executable-p): Do not check whether file
	exists, this is done in `tramp-check-cached-permissions'.
	(tramp-gvfs-handle-file-readable-p): Remove.

	* lisp/net/tramp.el (tramp-error): Move binding of `inhibit-message' ...
	(tramp-signal-hook-function): ... here.
	(tramp-handle-access-file): Rewrite.
	(tramp-handle-file-readable-p): New defun.
	(tramp-handle-make-process): Setting :filter to t works since
	Emacs 29.1 only.

	* test/lisp/net/tramp-tests.el (tramp-test17-insert-directory)
	(tramp-test18-file-attributes): Extend tests.

2021-10-18  Michael Albinus  <michael.albinus@gmx.de>

	Adapt Tramp manual

	* doc/misc/tramp.texi: Use @uref instead of @url.
	(Frequently Asked Questions): Adapt ELPA references.

2021-10-18  Martin Rudalics  <rudalics@gmx.at>

	Further fixes to Elisp manual

	* doc/lispref/frames.texi (Frame Layout): Index "tab bar" instead
	of "internal tab bar".
	(Implied Frame Resizing): Remove irritating hyphens.
	* doc/lispref/windows.texi (Windows and Frames): Remove paragraph
	relating 'minibuffer-window' to 'window-list'.

2021-10-18  Alan Mackenzie  <acm@muc.de>

	* lisp/progmodes/cc-engine.el (c-forward-decl-or-cast-1): check type-start

	Check type-start is non-nil at L659 of the function.

2021-10-18  Juri Linkov  <juri@linkov.net>

	Rename tab-bar-drag-maybe to tab-bar--dragging-in-progress

	* lisp/tab-bar.el (tab-bar--event-to-item, tab-bar-mouse-down-1)
	(tab-bar-mouse-move-tab): Rename tab-bar-drag-maybe to
	tab-bar--dragging-in-progress.

	* src/xdisp.c (note_mouse_highlight): Rename tab_bar_drag_maybe to
	tab_bar__dragging_in_progress.

2021-10-18  Mattias Engdegård  <mattiase@acm.org>

	Fix xref elisp identifier namespace mistake

	Pressing `M-.` on ALPHA in

	  (let ((ALPHA BETA)) ...)

	would incorrectly search for ALPHA as a function rather than a variable.

	* lisp/progmodes/elisp-mode.el (elisp--xref-infer-namespace): Fix logic.
	* test/lisp/progmodes/elisp-mode-tests.el
	(elisp-mode-infer-namespace): Add test case.

2021-10-18  Eli Zaretskii  <eliz@gnu.org>

	Minor fixes for recent changes in ELisp manual

	* doc/lispref/windows.texi (Basic Windows, Windows and Frames)
	(Selecting Windows):
	* doc/lispref/objects.texi (Window Type):
	* doc/lispref/frames.texi (Input Focus, Frame Layout): Fix
	wording, punctuation, and indexing.

2021-10-18  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix example in calc manual

	* doc/misc/calc.texi (Arithmetic Tutorial): Fix sign in the
	example (bug#51265).

2021-10-18  Martin Rudalics  <rudalics@gmx.at>

	Rewrites of Elisp manual including tab-bar and tab-line changes

	* doc/lispref/buffers.texi (Current Buffer, Buffer List): Update
	references to 'selected-window'.
	* doc/lispref/elisp.texi (Top): Move up Selecting Windows section
	in front of Window Sizes section.
	* doc/lispref/frames.texi (Creating Frames): Say window system
	instead of windowing system.
	(Frame Layout): Add Tab Bar to layout.
	(Layout Parameters): Add 'tab-bar-lines'.
	(Input Focus): Say window system window instead of window
	manager window.  Fix reference to 'selected-window'.
	* doc/lispref/objects.texi (Window Type): Minor rewrite.
	* doc/lispref/windows.texi (Basic Windows): Rewrite.  Settle on
	term 'window system window' for disambiguation with our windows.
	Move 'selected-window' description to Selecting Windows section.
	Move schematic of window structure here.  Use 'decorations' for
	objects outside the window body.  Say that the areas reserved
	for continuation and truncation glyphs, vertical dividers and
	line numbers are part of the window body.
	(Windows and Frames): Minor rewrite, adding and fixing some
	cross references.  Move live window schematic to 'Basic Windows'
	section.
	(Selecting Windows): Move section in front of Window Sizes
	section.  Move description of 'selected-window' here.  Move up
	description of 'frame-selected-window' and
	'set-frame-selected-window'.  Update and move description of
	'window-bump-use-time' here.
	(Window Sizes): Throughout use the term 'decorations' instead of
	enumerating them individually.  Add 'window-tab-line-height'
	description.
	(Resizing Windows): Again use the term 'decorations' instead of
	enumerating them individually.
	(Splitting Windows): Minor fix.
	(Cyclic Window Ordering): Improve descriptions of 'get-lru-window'
	and 'get-mru-window'.  Move 'window-bump-use-time' to Selecting
	Windows section.
	(Coordinates and Windows, Window Configurations): Once more use
	the term 'decorations' instead of enumerating them individually.
	* src/window.c (Fwindow_bump_use_time): Move after
	'window-use-time'.  Make it work for live windows only.  Make
	WINDOW argument optional.  Update doc-string.

2021-10-17  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el: Improve docstrings (bug#51247)

	* lisp/tab-bar.el (tab-bar--key-to-number)
	(tab-bar--event-to-item, tab-bar--format-tab-group)
	(tab-bar--current-tab-make): Improve docstrings.
	(switch-to-buffer-other-tab): Obsolete the arg NORECORD.

2021-10-17  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el (tab-bar-mouse-move-tab): Don't drag tab to itself.

2021-10-17  Martin Rudalics  <rudalics@gmx.at>

	Add tab-bar-drag-maybe for indication of tab dragging (bug#50993)

	* lisp/tab-bar.el (tab-bar--event-to-item)
	(tab-bar-mouse-move-tab): Set tab-bar-drag-maybe to nil.
	(tab-bar-mouse-down-1): Set tab-bar-drag-maybe to t.

	* src/xdisp.c (note_mouse_highlight): Set cursor to 'hand_cursor'
	when tab_bar_drag_maybe is true.
	(syms_of_xdisp): New variable tab-bar-drag-maybe.

2021-10-17  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el: Add a new tab on [mouse-1] instead of [down-mouse-1]

	* lisp/tab-bar.el (tab-bar-mouse-down-1): Rename from
	tab-bar-mouse-select-tab.  Ignore 'add-tab'.
	(tab-bar-mouse-1): Rename from tab-bar-mouse-close-tab-from-button.
	Use binding of 'add-tab'.
	(tab-bar-map): Rebind [down-mouse-1] from tab-bar-mouse-select-tab to
	tab-bar-mouse-down-1, and [mouse-1] from tab-bar-mouse-close-tab-from-button
	to tab-bar-mouse-1 (bug#51246).

2021-10-17  Juri Linkov  <juri@linkov.net>

	Add new and fix existing docstrings in tab-bar.el and tab-line.el (bug#51247)

	* lisp/tab-bar.el (tab-bar--key-to-number)
	(tab-bar--event-to-item, tab-bar--format-tab)
	(tab-bar--format-tab-group, tab-bar--tab, tab-bar--current-tab)
	(tab-bar--current-tab-make): Add/fix docstrings.

2021-10-17  Po Lu  <luangruo@yahoo.com>

	Add tab bar support to the nextstep port

	* src/nsfns.m (ns_change_tab_bar_height): New function.
	(ns_set_tab_bar_lines): Check tab bar height and set tab bar
	accordingly.
	* src/nsterm.m (ns_clear_under_internal_border): Clear internal border
	correctly when there is a tab bar.
	(ns_create_terminal): Add ns_change_tab_bar_height.
	(mouseDown): Handle tab bar mouse click events.

2021-10-17  Alan Third  <alan@idiocy.org>

	Fix potential buffer overflow (bug#50767)

	* src/image.c (svg_load_image): Check how many bytes were actually
	written to the buffer.  Don't check xmalloc return value as xmalloc
	doesn't return if it fails.

2021-10-17  Eli Zaretskii  <eliz@gnu.org>

	Improve doc strings in tab-line.el

	* lisp/tab-line.el (tab-line-tab-name-function)
	(tab-line-tab-name-truncated-buffer, tab-line-tabs-mode-buffers)
	(tab-line-tabs-buffer-group-function)
	(tab-line-tabs-buffer-group-sort-function)
	(tab-line-tabs-buffer-groups, tab-line-tab-name-format-function)
	(tab-line-tab-name-format-default, tab-line-format-template)
	(tab-line-tab-face-inactive-alternating)
	(tab-line-tab-face-special, tab-line-tab-face-modified)
	(tab-line-format, tab-line-auto-hscroll, tab-line-hscroll-right)
	(tab-line-hscroll-left, tab-line-new-tab, tab-line-select-tab)
	(tab-line-switch-to-prev-tab, tab-line-switch-to-next-tab)
	(tab-line-close-tab-function, tab-line-close-tab)
	(tab-line-tab-context-menu, tab-line-context-menu)
	(tab-line-mode, tab-line-exclude-modes, tab-line-mode--turn-on):
	Add or fix doc strings.

2021-10-17  Eli Zaretskii  <eliz@gnu.org>

	More documentation fixes in tab-bar.el

	* lisp/tab-bar.el (tab-bar-detach-tab, tab-bar-move-window-to-tab)
	(tab-bar-new-tab-to, tab-bar-new-tab, tab-bar-close-tab-select)
	(tab-bar-close-last-tab-choice, tab-bar-tab-pre-close-functions)
	(tab-bar-close-tab, tab-bar-close-tab-by-name)
	(tab-bar-close-other-tabs, tab-bar-rename-tab)
	(tab-bar-rename-tab-by-name, tab-bar-move-tab-to-group)
	(tab-bar-change-tab-group, tab-bar-close-group-tabs)
	(tab-switcher-next-line, tab-switcher-prev-line)
	(tab-switcher-unmark, tab-switcher-delete, tab-switcher-select)
	(tab-bar-get-buffer-tab, display-buffer-in-tab)
	(display-buffer-in-new-tab, switch-to-buffer-other-tab)
	(find-file-other-tab, find-file-read-only-other-tab): Doc fixes.

2021-10-17  Eli Zaretskii  <eliz@gnu.org>

	Improve doc strings of tab-bar commands

	* lisp/tab-bar.el (tab-bar-mouse-select-tab)
	(tab-bar-mouse-move-tab, tab-bar-mouse-close-tab-from-button)
	(tab-bar-mouse-close-tab, tab-bar-mouse-context-menu)
	(tab-bar-switch-to-next-tab, tab-bar-switch-to-prev-tab)
	(tab-bar-switch-to-last-tab, tab-bar-switch-to-recent-tab)
	(tab-bar-move-tab-backward, tab-bar-move-tab)
	(tab-bar-move-tab-to-frame): Add/fix doc strings.

2021-10-17  Stefan Kangas  <stefankangas@gmail.com>

	Fix a semantic test on some macOS machines

	* test/lisp/cedet/semantic/bovine/gcc-tests.el
	(semantic-gcc-test-output-parser-this-machine): Fix test on some macOS
	machines where running "gcc" runs "llvm" instead.

2021-10-16  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5-57-g9bc3a2

2021-10-16  Stefan Kangas  <stefankangas@gmail.com>

	Recommend against using uce.el

	* lisp/mail/uce.el: Recommend against its use.  (Bug#46472)
	Do not merge to master.

2021-10-16  Eli Zaretskii  <eliz@gnu.org>

	Avoid aborts when a thread is signaled while "waiting for input".

	* src/process.c (kbd_is_ours): New function.
	(wait_reading_process_output): Set 'waiting_for_input' only if the
	current thread is monitoring the keyboard descriptor.  See also
	https://lists.gnu.org/archive/html/emacs-devel/2021-10/msg01180.html.
	(Bug#51229)

2021-10-16  Philipp Stephani  <phst@google.com>

	Improve documentation string for 'compilation-error-regexp-alist'.

	* lisp/progmodes/compile.el (compilation-error-regexp-alist): Clarify
	behavior when TYPE is a cons cell.

2021-10-16  Andrea Corallo  <akrl@sdf.org>

	* lisp/emacs-lisp/comp.el (comp-trampoline-compile): Fix target dir.

2021-10-16  Eli Zaretskii  <eliz@gnu.org>

	Fix removal of fringe indication of bookmarks

	* lisp/bookmark.el (bookmark--remove-fringe-mark): Fix off-by-one
	error in looking for bookmark-related overlays.  (Bug#51233)

2021-10-15  Stefan Kangas  <stefankangas@gmail.com>

	Prefer "graphical displays" to "X terminals" in documentation

	* doc/lispref/objects.texi (Ctl-Char Syntax): Fix incorrect remark;
	some text terminals can generate ASCII control characters.
	(Other Char Bits):
	* lisp/bindings.el:
	* lisp/gnus/gnus-undo.el (gnus-undo-mode-map): Say "graphical display"
	and "GUI display" instead of "X terminal"; the latter term is
	archaic.  (Bug#51217)

2021-10-15  Michael Albinus  <michael.albinus@gmx.de>

	Precise documentation of file-notify-add-watch

	* doc/lispref/os.texi (File Notifications):
	* lisp/filenotify.el (file-notify-add-watch): Precise, that
	watching a directory includes reports on file changes for some
	backends.  (Bug#51146)

2021-10-15  Martin Rudalics  <rudalics@gmx.at>

	Fixes to account for windows' tab lines

	* doc/lispref/display.texi (Size of Displayed Text): Fix entry
	on 'window-text-pixel-size'.
	* lisp/window.el (window--dump-window): Dump tab-line-height and
	scroll-bar-height too.
	(window--min-size-1): Take 'window-tab-line-height' into account.
	* src/xdisp.c (Fwindow_text_pixel_size): Fix doc-string of
	'window-text-pixel-size'.  Rename last argument to 'MODE-LINES'.

2021-10-15  Andrea Corallo  <akrl@sdf.org>

	Fix `native-compile-target-directory' effectiveness on trampolines

	* lisp/emacs-lisp/comp.el (comp-trampoline-compile): Fix
	`native-compile-target-directory' effectiveness on trampoline
	compilation.

2021-10-15  Jan Synacek  <jan.synacek@gmail.com>

	Add missing single quotes in the Emacs manual

	* lisp/mwheel.el (mouse-wheel-scroll-amount): Add missing single
	quotes.  (Bug#51223)

2021-10-15  Juri Linkov  <juri@linkov.net>

	* lisp/menu-bar.el (yank-menu-length): Fix docstring (bug#51138).

2021-10-14  Michael Albinus  <michael.albinus@gmx.de>

	Accept process-filter t in Tramp

	* lisp/net/tramp.el (tramp-handle-make-process):
	* lisp/net/tramp-adb.el (tramp-adb-handle-make-process):
	* lisp/net/tramp-sh.el (tramp-sh-handle-make-process): Filter can be t.

	* test/lisp/net/tramp-tests.el (tramp-test29-start-file-process)
	(tramp-test30-make-process): Test filter equal t.

2021-10-14  Lars Ingebrigtsen  <larsi@gnus.org>

	Document the t value for set-process-filter in the manual

	* doc/lispref/processes.texi (Filter Functions): Mention what t
	means (bug#51177).

2021-10-14  Michael Albinus  <michael.albinus@gmx.de>

	* doc/misc/tramp.texi (Frequently Asked Questions): Add reference

	to ELPA Installation node.

2021-10-14  Eli Zaretskii  <eliz@gnu.org>

	Fix Help functions for clicks on tool bar and tab bar

	* lisp/mouse.el (mouse-minibuffer-check): Don't assume posn-window
	returns a window.  (Bug#5199)

2021-10-14  Martin Rudalics  <rudalics@gmx.at>

	In make_lispy_position fix Bug#50993 in rudimentary fashion

	* src/keyboard.c (make_lispy_position): Do not set posn to
	tool- or tab-bar when track_mouse is enabled (Bug#50993).

2021-10-14  Dmitry Gutov  <dgutov@yandex.ru>

	Mark vc-switch-backend as obsolete

	* etc/NEWS: Mention the change.

	* lisp/vc/vc.el (vc-switch-backend): Mark as obsolete (bug#50344).
	(vc-transfer-file): Wrap the calls in 'with-suppressed-warnings'.

2021-10-14  Yan  <yan@metatem.net>  (tiny change)

	Add missing parentheses in the Emacs manual

	* doc/emacs/maintaining.texi (Xref Commands): Add missing
	parentheses (bug#51195).

2021-10-14  Stefan Kangas  <stefankangas@gmail.com>

	Improve tooltip of mode-line-position again

	* lisp/bindings.el (mode-line-position): Improve tooltip again.
	This change was discussed in
	https://lists.gnu.org/r/emacs-devel/2021-10/msg00952.html

2021-10-13  Philip Kaludercic  <philipk@posteo.net>

	Use browse-url-button-regexp for rcirc-url-regexp

	* lisp/net/rcirc.el (rcirc-url-regexp): Copy improved regexp from
	browse-url

2021-10-13  Juri Linkov  <juri@linkov.net>

	* lisp/help.el (help--analyze-key): Avoid mouse-set-point for non-mouse events

	(bug#51173)

2021-10-13  Michael Albinus  <michael.albinus@gmx.de>

	Tramp doc cleanup

	* doc/misc/tramp.texi (Overview, Bug Reports)
	(Frequently Asked Questions): Stylistic changes.
	(Bug Reports): Mention tramp buffers appended to bug report.

2021-10-13  Lars Ingebrigtsen  <larsi@gnus.org>

	Make emacs-lisp-byte-compile-and-load load the .elc file again

	* lisp/progmodes/elisp-mode.el (emacs-lisp-byte-compile-and-load):
	Load the compiled file instead of the source (bug#51180).

2021-10-13  Peter Münster  <pm@a16n.net>

	Fix point movement in image-dired

	* lisp/image-dired.el (image-dired-thumb-file-marked-p): Don't
	move point in associated dired buffer.
	(image-dired-delete-marked): Revert "Fix deletion of associated image"
	because it was wrong and introduced another problem (bug#51152).

2021-10-13  Stefan Kangas  <stefankangas@gmail.com>

	Improve shortdoc for vector

	* lisp/emacs-lisp/shortdoc.el (vector): Improve shortdoc with titles.
	Add mapc.  Fix typo where 'seq-reduce' is incorrectly written as
	'reduce'.

2021-10-13  Paul Eggert  <eggert@cs.ucla.edu>

	Fix test bug when calloc returns null

	* test/src/emacs-module-resources/mod-test.c (Fmod_test_userptr_make):
	Don’t dump core if calloc returns null and signal_errno returns.

2021-10-12  Paul Eggert  <eggert@cs.ucla.edu>

	Pacify GCC 11 -fanalyzer on x86-64

	* src/buffer.c (fix_overlays_before):
	Redo slightly to work around GCC bug 102692
	<https://gcc.gnu.org/bugzilla//show_bug.cgi?id=102692>.

2021-10-12  Gregory Heytings  <gregory@heytings.org>

	Improve handling of non-character events in input methods

	* lisp/international/quail.el (quail-add-unread-command-events):
	Handle non-vector event arguments.  Fixes bug#51118.

2021-10-12  Martin Rudalics  <rudalics@gmx.at>

	In Fdelete_other_windows_internal fix new total window sizes (Bug#51007)

	* src/window.c (Fdelete_other_windows_internal): Assign the
	new total sizes of windows _after_ the new window configuration
	is in place (Bug#51007).

2021-10-12  Stephen Gildea  <stepheng+emacs@gildea.com>

	* lisp/mh-e/mh-show.el (mh-junk-whitelist): Custom obsolescence message.

2021-10-11  João Távora  <joaotavora@gmail.com>

	Don't apply shorthands to punctuation-only symbols (bug#51089)

	This includes symbols used for arithmetic functions such as -, /=,
	etc.  Using "-" or "/=" is still possible but doing so won't shadow
	those functions.

	* doc/lispref/symbols.texi (Shorthand, Exceptions): New
	subsubsection.

	* src/lread.c (read1): Exempt punctionation-only symbols from
	oblookup_considering_shorthand.

	* test/lisp/progmodes/elisp-mode-tests.el
	(elisp-dont-shadow-punctuation-only-symbols): Tweak test.

2021-10-11  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/progmodes/python.el: Bump package version to 0.28.

2021-10-11  Stefan Kangas  <stefankangas@gmail.com>

	Fontify "print" and "exec" as functions in python-mode

	This change was first made on master, but on closer consideration it
	is better to fix this bug already in Emacs 28.1.

	* lisp/progmodes/python.el (python-font-lock-keywords-level-2):
	Fontify "print" and "exec" as functions, which is the case in
	Python 3.  (Bug#43298)  Do not merge to master.

2021-10-11  Juri Linkov  <juri@linkov.net>

	Copy parent face attributes to tab-line-tab-current instead of inheriting face

	* lisp/tab-line.el (tab-line-tab-current): Don't inherit face from
	'tab-line-tab' to not inherit the face attribute :height from 'tab-line',
	because :height of mouse-face is added to the base face.
	Copy here most of the parent face attributes (bug#50798).

2021-10-11  Martin Rudalics  <rudalics@gmx.at>

	Another fix for 'ibuffer-shrink-to-fit' (Bug#7218, Bug#51029)

	* lisp/ibuffer.el (ibuffer-shrink-to-fit): Fit window only if its
	buffer is in 'ibuffer-mode' (Bug#7218, Bug#51029).

2021-10-11  Michael Albinus  <michael.albinus@gmx.de>

	Backport: * doc/misc/tramp.texi (Bug Reports): Describe, how to activate ELPA Tramp.

	(cherry picked from commit 978e5339e0d4ef98575096bcf3ec2061ad530f27)

2021-10-11  Paul Eggert  <eggert@cs.ucla.edu>

	Work around GCC bug 102671

	This is for --enable-gcc-warnings on GCC 11.2.1.
	* src/window.c, src/timefns.c: Disable -Wanalyzer-null-dereference.

2021-10-11  Amin Bandali  <bandali@gnu.org>

	Release ERC 5.4

	* lisp/erc/erc.el (Version, erc-version): Bump to 5.4.
	(customize-package-emacs-version-alist): Add entry for 5.4.

2021-10-11  Amin Bandali  <bandali@gnu.org>

	* etc/ERC-NEWS: Announce ERC's addition to GNU ELPA.

	* etc/ERC-NEWS: Fix outline level for the recent additions.

2021-10-11  Amin Bandali  <bandali@gnu.org>

	Add ERC entries for 'customize-package-emacs-version-alist'

	* lisp/erc/erc.el (customize-package-emacs-version-alist): Add entries
	for existing ERC versions.

2021-10-11  Dmitry Gutov  <dgutov@yandex.ru>

	Expand the full file name

	* lisp/vc/vc-git.el (vc-git--literal-pathspec):
	Expand the full file name, not just the local part (bug#51112).

2021-10-11  Stefan Kangas  <stefankangas@gmail.com>

	Obsolete XEmacs compat convention in 'erc-button-press-button'

	* lisp/erc/erc-button.el (erc-button-press-button): Advertise new
	calling convention without XEmacs compatibility.

2021-10-11  F. Jason Park  <jp@neverwas.me>

	Backport: Add ERC version to protocol log

	* lisp/erc/erc.el (erc-toggle-debug-irc-protocol): Include the erc
	version in the debug logs (bug#51107).

	(cherry picked from commit 13411346202f86e950bee076a5d528e98695fbb4)

2021-10-11  Eli Zaretskii  <eliz@gnu.org>

	Adapt the recent 'num_processors' change to MS-Windows

	* nt/gnulib-cfg.mk (OMIT_GNULIB_MODULE_nproc): Omit nproc.

	* src/w32.c (num_processors): New function.
	* src/w32proc.c (Fw32_get_nproc): Remove.

2021-10-11  Stefan Kangas  <stefankangas@gmail.com>

	Minor fix to clarify a sentence in emacs-lisp-intro

	* doc/lispintro/emacs-lisp-intro.texi (Simple Extension): Add the word
	"that" for clarity.  (Bug#43965)

2021-10-11  Lars Ingebrigtsen  <larsi@gnus.org>

	Make tty-run-terminal-initialization load the .elc file (if any)

	* lisp/faces.el (tty-run-terminal-initialization):
	`locate-library' may have found the .el.gz file (bug#51116).

2021-10-11  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix ert errors when there's a test that binds `debug-on-error'

	* lisp/emacs-lisp/ert.el (ert--run-test-internal): Don't infloop
	on errors when signaling errors (bug#51131).

2021-10-10  Paul Eggert  <eggert@cs.ucla.edu>

	New function num-processors

	This addresses a FIXME comment in lisp/emacs-lisp/comp.el,
	relating to the number of subsidiary processes used by
	comp-run-async-workers in native compilation.
	* admin/merge-gnulib (GNULIB_MODULES): Add nproc.
	* doc/lispref/processes.texi (Process Information), etc/NEWS:
	Document num-processors.
	* lib/gnulib.mk.in, m4/gnulib-comp.m4: Regenerate.
	* lib/nproc.c, lib/nproc.h, m4/nproc.m4:
	New files, copied from Gnulib by admin/merge-gnulib.
	* lisp/emacs-lisp/comp.el (w32-get-nproc): Remove decl.
	(comp-effective-async-max-jobs): Use num-processors.
	* src/process.c: Include nproc.h.
	(Fnum_processors): New function.
	(syms_of_process): Define ‘all’, ‘current’, ‘num-processors’.
	* src/w32proc.c (Fw32_get_nproc): Add FIXME comment.
	* test/src/process-tests.el (process-num-processors): New test.

2021-10-10  Juri Linkov  <juri@linkov.net>

	Add symbol property 'save-some-buffers-function' (bug#46374)

	* lisp/files.el (save-some-buffers-root): Put non-nil
	symbol property 'save-some-buffers-function'.
	(save-some-buffers): Check pred for the
	symbol property 'save-some-buffers-function'.
	(save-some-buffers-default-predicate): Mention
	symbol property 'save-some-buffers-function'.

2021-10-10  Juri Linkov  <juri@linkov.net>

	Keep reading when typed RET in read-char-from-minibuffer and y-or-n-p

	* lisp/subr.el (read-char-from-minibuffer-map):
	Remap exit-minibuffer to read-char-from-minibuffer-insert-other.
	(y-or-n-p-map): Remap 'exit' to y-or-n-p-insert-other.
	(y-or-n-p): Don't mention RET in docstring.  (Bug#51101)

2021-10-10  David M. Koppelman  <koppel@ece.lsu.edu>

	* lisp/userlock.el (ask-user-about-supersession-threat): Accept 'y' strictly.

	(Bug#51101)

2021-10-10  Eli Zaretskii  <eliz@gnu.org>

	Fix point positioning on mouse clicks with non-zero line-height

	* src/xdisp.c (move_it_to): After passing a newline, reset
	it->override_ascent, like 'display_line' does (in
	'append_space_for_newline').  (Bug#51111)

2021-10-10  João Távora  <joaotavora@gmail.com>

	Complete shorthands to longhands for symbol-completing tables

	Shorthands aren't symbols, they're text forms that 'read' into
	symbols.  As such, shorthands aren't candidates in these tables of
	symbols.  But in some situations, if no other candidates match the
	pattern, we can e.g. complete "x-foo" to "xavier-foo" if the shorthand

	  (("x-" . "xavier-"))

	is set up in the buffer of origin.

	bug#50959

	* lisp/help-fns.el (help--symbol-completion-table): Report
	`symbol-help' category.

	* lisp/minibuffer.el (completion-styles-alist): New 'shorthand'
	style.
	(completion-category-defaults): Link 'symbol-help' category with
	'shorthand' style.
	(minibuffer--original-buffer): New variable.
	(completing-read-default): Setup minibuffer--original-buffer.
	(completion-shorthand-try-completion)
	(completion-shorthand-all-completions): New helpers.

2021-10-10  João Távora  <joaotavora@gmail.com>

	Add new failing test for bug#51089

	* test/lisp/progmodes/elisp-mode-tests.el
	(elisp-dont-shadow-punctuation-only-symbols): Add new failing test.

2021-10-10  Dmitry Gutov  <dgutov@yandex.ru>

	Avoid mapping file names through 'substring'

	* lisp/progmodes/project.el (project--files-in-directory):
	Avoid mapping file names through 'substring'.  Reducing the amount
	of garbage generated.  Better perf by up to 20%.
	Bump the package version.

2021-10-09  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5-46-gb71474

2021-10-09  Stephen Gildea  <stepheng+emacs@gildea.com>

	Expanded testing of MH-E with multiple MH variants

	* test/lisp/mh-e/mh-utils-tests.el: Environment variable TEST_MH_PATH
	controls which installed MH variant to test with.  Moved the commentary
	about testing with different MH variants from above 'with-mh-test-env'
	definition to "Commentary" section at the top of the file.
	* test/lisp/mh-e/test-all-mh-variants.sh: New script to test all
	installed MH variants.

2021-10-09  Philipp Stephani  <phst@google.com>

	Fix Seccomp filter for newer GNU/Linux systems (Bug#51073).

	On some systems, process startup calls prctl(PR_CAPBSET_READ) via
	'cap_get_bound'.  We can just return EINVAL.

	* lib-src/seccomp-filter.c (main): Add a rule for
	prctl(PR_CAPBSET_READ, ...).

2021-10-09  Michael Albinus  <michael.albinus@gmx.de>

	Tramp code cleanup

	* lisp/net/tramp.el (tramp-remote-path): Adapt docstring.
	(tramp-action-login, tramp-action-password, tramp-action-yesno)
	(tramp-action-yn, tramp-process-actions): Move let-binding of
	`enable-recursive-minibuffers' up.
	(tramp-handle-make-process, tramp-handle-write-region):
	* lisp/net/tramp-adb.el (tramp-adb-handle-write-region)
	(tramp-adb-handle-make-process):
	* lisp/net/tramp-sh.el (tramp-sh-handle-make-process)
	(tramp-sh-handle-write-region):
	* lisp/net/tramp-smb.el (tramp-smb-handle-write-region):
	* lisp/net/tramp-sshfs.el (tramp-sshfs-handle-write-region):
	Use `string-or-null-p'.

2021-10-09  Michael Albinus  <michael.albinus@gmx.de>

	Fix thinko in ls-lisp--insert-directory

	* lisp/ls-lisp.el (ls-lisp--insert-directory): Ensure that
	SWITCHES is a string.

2021-10-09  Lars Ingebrigtsen  <larsi@gnus.org>

	Mention that RET means "yes" in y-or-n-p

	* lisp/subr.el (y-or-n-p): Mention that RET also means yes (bug#51101).

2021-10-09  Eli Zaretskii  <eliz@gnu.org>

	Rewrite Antinews for Emacs 28

	* doc/lispref/anti.texi (Antinews):
	* doc/emacs/anti.texi (Antinews): Rewrite for Emacs 28.
	* doc/lispref/elisp.texi (Top):
	* doc/emacs/emacs.texi (Top): Update menu accordingly.

2021-10-09  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/bindings.el (mode-line-position): Improve tooltip.

2021-10-09  Dmitry Gutov  <dgutov@yandex.ru>

	* lisp/progmodes/xref.el: Bump the version.

2021-10-09  Dmitry Gutov  <dgutov@yandex.ru>

	Slight simplification

	* lisp/progmodes/xref.el (xref--insert-xrefs):
	Compute log only once.  Use 'dolist'.

2021-10-08  Eli Zaretskii  <eliz@gnu.org>

	Fix doc strings of 2 categories

	* lisp/international/characters.el (?R, ?L): Make the first line
	of the categories' doc string shorter, to fit into 15 columns.

2021-10-08  Dmitry Gutov  <dgutov@yandex.ru>

	(xref--collect-matches-1): Remove some intermediate allocations

	* lisp/progmodes/xref.el: (xref--collect-matches-1):
	Rewrite to remove some intermediate allocations.
	Modest performance improvement.

2021-10-08  Arash Esbati  <arash@gnu.org>

	Use the correct label in the warning

	* lisp/textmodes/reftex-toc.el (reftex-toc-rename-label): Add
	missing space in the prompt.  Use the new user defined label in
	the warning (bug#36235).

2021-10-08  Dmitry Gutov  <dgutov@yandex.ru>

	Add Emacs 27 compatibility hack

	* lisp/progmodes/xref.el: Add Emacs 27 compatibility hack, for the
	standalone version of this package.

2021-10-07  Paul Eggert  <eggert@cs.ucla.edu>

	Pacify GCC 10.3 -Wmaybe-uninitialized

	Problem reported by Basil L. Contovounesios (Bug#51075).
	* src/term.c (encode_terminal_code):
	Add an UNINIT to pacify GCC 10 bug.

2021-10-07  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el (tab-detach, tab-window-detach): New aliases.

	(tab-bar-mouse-context-menu, tab-bar-duplicate-tab):
	Use word "clone" in help/doc string.

2021-10-07  Eli Zaretskii  <eliz@gnu.org>

	Include the refcards in the release tarball

	* make-dist (possibly_non_vc_files): Include *.pdf files, to
	include the produced refcards in the tarball.  This was lost when
	'make-dist' was rewritten for Emacs 27.

2021-10-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	Backport: * lisp/net/tramp-archive.el (tramp-archive-autoload-file-name-handler): Scope

	Fix the scoping of `tramp-archive-enabled`.

	(cherry picked from commit 8d53c23f90aab6e527c61137ae43274c7a36eca7)

2021-10-07  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation and customization of 'blink-matching-paren'

	* lisp/simple.el (blink-matching-paren): Fix the wording of the
	doc string and the descriptions in the value menu.  (Bug#51032)

2021-10-07  Amin Bandali  <bandali@gnu.org>

	* lisp/erc/erc.el: Don't error if 'erc-loaddefs' does not exist.

	That autoload file is created as part of the Emacs compilation
	process, however we would like ERC to be usable if used outside
	emacs.git (e.g. if installed from GNU ELPA).

2021-10-07  Amin Bandali  <bandali@gnu.org>

	Add 'erc-bug' command for reporting ERC bugs

	* etc/ERC-NEWS: Announce the new command, and mention it at the top of
	the file along with 'report-emacs-bug'.
	* lisp/erc/erc.el (erc-bug): New command for reporting ERC bugs.  It
	prompts for a subject, and passes it on to 'report-emacs-bug' along
	with the current ERC version, with the ERC mailing list in Cc.

2021-10-07  Amin Bandali  <bandali@gnu.org>

	Add 'erc-version' and use it to display ERC version consistently

	* lisp/erc/erc.el (erc-version): New constant holding the current ERC
	version, now used in the function with the same name to produce a
	version string for use across ERC for consistency.  Also, add another
	optional argument, 'bold-erc', which when non-nil, marks the "ERC"
	portion of the string with the control character for bold display.
	(erc-quit/part-reason-default): Use the 'erc-version' function for a
	consistent version string.
	(erc-cmd-SV): Mention the ERC version number from the 'erc-version'
	constant.
	(erc-ctcp-query-VERSION): Use the 'erc-version' function for a
	consistent version string.

2021-10-07  Amin Bandali  <bandali@gnu.org>

	Small tweaks and improvements to etc/ERC-NEWS

	* etc/ERC-NEWS: Small tweaks inspired by etc/NEWS, namely to add a
	descriptive blurb at the top of the file to explain what it is about
	and how to report ERC bugs, add a form feed before the section for
	every release, and set the same Local Variables that etc/NEWS does.

2021-10-07  Amin Bandali  <bandali@gnu.org>

	Add NEWS items for changes to ERC since 5.3 to etc/ERC-NEWS

	* etc/ERC-NEWS: copy ERC NEWS items from etc/NEWS, etc/NEWS.27,
	etc/NEWS.26, etc/NEWS.25, and etc/NEWS.24 to here.  Future ERC NEWS
	are also to be added here.  This is in motivated by preparation for
	addition of ERC to GNU ELPA, along with the ERC manual and NEWS.
	* etc/NEWS: remove ERC-related entries, and refer the reader to
	ERC-NEWS instead.

2021-10-06  Juri Linkov  <juri@linkov.net>

	Clone the frame window configuration in 'clone-frame'

	* doc/emacs/frames.texi (Creating Frames): Mention the cloned
	window configuration for clone-frame.

	* lisp/frame.el (clone-frame): Change second arg to 'no-windows'
	and clone window configuration when it's nil.

	* lisp/tab-bar.el (tab-bar-mouse-context-menu)
	(tab-bar-detach-tab): Replace "Detach" with "Move" in help/doc strings.

	https://lists.gnu.org/archive/html/emacs-devel/2021-10/msg00408.html

2021-10-06  Eli Zaretskii  <eliz@gnu.org>

	* lisp/tool-bar.el (tool-bar-position): Doc fix.

2021-10-06  Philip Kaludercic  <philipk@posteo.net>

	* NEWS: Mention rcirc connects to #emacs by default

2021-10-06  Stephen Gildea  <stepheng+emacs@gildea.com>

	Refactor mh-utils-tests macro 'with-mh-test-env'

	* test/lisp/mh-e/mh-utils-tests.el (with-mh-test-env): Refactor to
	reduce the size of the expanded macro.
	(mh-test-utils-setup): New helper function.
	(mh-ensure-native-trampolines): Absorbed by mh-test-utils-setup.

2021-10-05  Stefan Kangas  <stefankangas@gmail.com>

	Avoid using variable before it has been initialized

	* lisp/ibuffer.el (ibuffer-shrink-to-fit): Don't try to use
	ibuffer-auto-mode variable before ibuf-ext.el has been loaded.
	(Bug#51029)

2021-10-05  Stefan Kangas  <stefankangas@gmail.com>

	Clarify docstring of blink-matching-paren

	* lisp/simple.el (blink-matching-paren): Clarify
	docstring.  (Bug#51032)

2021-10-05  Stefan Kangas  <stefankangas@gmail.com>

	* doc/misc/gnus.texi (Loose Threads): Use regexp-opt in example.

2021-10-05  Dmitry Gutov  <dgutov@yandex.ru>

	Bump project.el version

	* lisp/progmodes/project.el: Bump the version.

2021-10-05  Dmitry Gutov  <dgutov@yandex.ru>

	Retain compatibility with older project.el projects

	* lisp/progmodes/xref.el (xref--analyze):
	Retain compatibility with older project.el and its compatible
	project definitions (for standalone Xref from ELPA).

2021-10-05  Stephen Gildea  <stepheng+emacs@gildea.com>

	native-comp-available-p is the definitive test

	* doc/lispref/compile.texi (Native Compilation): Document
	native-comp-available-p as the way to test for native compilation.
	* lisp/emacs-lisp/package.el (package--native-compile-async):
	* test/lisp/mh-e/mh-utils-tests.el (mh-ensure-native-trampolines):
	Test for native compilation with native-comp-available-p.

	Thank you to Andrea Corallo for reviewing this patch.

2021-10-05  Eli Zaretskii  <eliz@gnu.org>

	Minor fix of a recently installed documentation change

	* doc/emacs/search.texi (Lax Search): Don't use ".." inside @samp,
	it looks confusing, especially in print.  (Bug#51020)

2021-10-05  Paul Eggert  <eggert@cs.ucla.edu>

	Fix md5 issue in recent Gnulib merge

	When configured --with-native-compilation, Emacs needs md5_stream.
	Problem reported by Andy Moreton (Bug#50985#23).
	* admin/merge-gnulib (GNULIB_MODULES): Add crypto/md5,
	needed for --with-native-compilation.
	(AVOIDED_MODULES): Avoid crypto/af_alg, since Emacs doesn’t
	need to bother with kernel-supported cryptography algorithms.
	* lib/gnulib.mk.in, m4/gnulib-comp.m4:
	Regenerate by running admin/merge-gnulib.
	* lib/md5-stream.c: New file, copied from Gnulib.

2021-10-05  Paul Eggert  <eggert@cs.ucla.edu>

	Tweak recent 'configure' fix

	* configure.ac (gt_TYPE_WINT_T): Omit obsolete and
	now-overridden definition.

2021-10-05  Stefan Kangas  <stefankangas@gmail.com>

	Document minibuffer-default-prompt-format in manual

	* doc/emacs/mini.texi (Basic Minibuffer): Mention
	minibuffer-default-prompt-format.  (Bug#50935)

2021-10-05  Eli Zaretskii  <eliz@gnu.org>

	Backward compatibility option for 'nobreak-char-display'

	* src/xdisp.c (syms_of_xdisp) <nobreak-char-ascii-display>: New
	variable.
	(get_next_display_element): If 'nobreak-char-ascii-display' is
	non-nil, display non-ASCII space and hyphen characters as their
	ASCII equivalents.  (Bug#50983)

	* etc/NEWS:
	* etc/PROBLEMS: Mention 'nobreak-char-ascii-display'.

2021-10-05  Eli Zaretskii  <eliz@gnu.org>

	Unbreak the build after Gnulib update

	* lib/gnulib.mk.in (GNULIBHEADERS_OVERRIDE_WINT_T): Rename from
	GNULIB_OVERRIDES_WINT_T.
	* configure.ac (GNULIBHEADERS_OVERRIDE_WINT_T): Define.
	(Bug#50985)

2021-10-05  Michael Albinus  <michael.albinus@gmx.de>

	Check, whether an FUSE mount has been broken in Tramp

	* lisp/net/tramp-fuse.el (tramp-fuse-mount-timeout): New defconst.
	(tramp-fuse-mounted-p): Use it.  Check for a file property instead
	of a connection property.
	(tramp-fuse-unmount): Ditto.

	* lisp/net/tramp-sshfs.el (tramp-sshfs-maybe-open-connection):
	Do not trust existence of a process, whether the volume is mounted.

2021-10-05  Augusto Stoffel  <arstoffel@gmail.com>

	Disable 'nobreak-char-display' in Eldoc buffers

	* lisp/emacs-lisp/eldoc.el (eldoc--format-doc-buffer): Set
	'nobreak-char-display' to nil in Eldoc buffers (bug#50989).

2021-10-05  Miha Rihtaršič  <miha@kamnitnik.top>

	Fix small error in comint-send-input

	* lisp/comint.el (comint-send-input): Run
	comint-output-filter-functions with comint-last-output-start set
	correctly (bug#51009).

2021-10-05  Daniel Martín  <mardani29@yahoo.es>

	Update documentation of search-whitespace-regexp

	* doc/emacs/search.texi (Lax Search): Update the documentation about
	the default value of search-whitespace-regexp, as it is now
	independent of the major mode's syntax table (bug#51020).

2021-10-05  Po Lu via  <emacs-devel@gnu.org>

	Fix cc-compat.el syntax error

	* lisp/obsolete/cc-compat.el (offsets): Fix syntax error in BOCM
	style setup.

2021-10-05  Tak Kunihiro  <tkk@misasa.okayama-u.ac.jp>

	Mention `seq-uniq' in `delete-dups' documentation

	* doc/lispref/lists.texi (Sets And Lists): Mention `seq-uniq'
	(bug#50928).

	* lisp/subr.el (delete-dups): Link to `seq-uniq' in doc string.

2021-10-05  Paul Eggert  <eggert@cs.ucla.edu>

	Port recent Gnulib changes to MS-Windows

	* nt/gnulib-cfg.mk (OMIT_GNULIB_MODULE_free-posix)
	(OMIT_GNULIB_MODULE_malloc-posix)
	(OMIT_GNULIB_MODULE_realloc-gnu)
	(OMIT_GNULIB_MODULE_realloc-posix):
	New macros, since we don’t want these modules on MS-Windows.
	* src/w32heap.c (heap_alloc, heap_realloc): New functions.
	(malloc_after_dump, realloc_after_dump, realloc_before_dump):
	Use them.

2021-10-05  Paul Eggert  <eggert@cs.ucla.edu>

	Update from Gnulib

	Make the following changes by hand, and run 'admin/merge-gnulib'.
	* .gitignore: Add lib/malloc/*.gl.h.
	* admin/merge-gnulib: Copy lib/af_alg.h and lib/save-cwd.h
	directly from Gnulib, without worrying about Gnulib modules,
	as these files are special cases.
	(AVOIDED_MODULES): Remove malloc-posix.
	* lib/malloc.c, lib/realloc.c, m4/malloc.m4, m4/realloc.m4:
	* m4/year2038.m4: New files, copied from Gnulib.
	* lib/malloca.c, lib/malloca.h:
	* m4/close-stream.m4, m4/glibc21.m4, m4/malloca.m4:
	Remove.  These are either no longer present in Gnulib, or are no
	longer needed by modules that Emacs uses.
	* oldXMenu/AddPane.c, oldXMenu/AddSel.c: Include XmenuInt.h first;
	needed for new Gnulib.
	* src/xmenu.c: Call emacs_abort, not abort.

2021-10-04  Andrea Corallo  <akrl@sdf.org>

	Fix mh tests for native comp builds (bug#50975)

	* test/lisp/mh-e/mh-utils-tests.el (mh-ensure-native-trampolines):
	New function.
	(mh-test-utils-setup-with-mocks)
	(mh-test-utils-setup-with-variant): Use it.

2021-10-04  Andrea Corallo  <akrl@sdf.org>

	Fix `batch-native-compile' not to spawn a subprocess

	* lisp/emacs-lisp/comp.el (comp-running-batch-compilation): New var.
	(comp-final): Use it.
	(batch-native-compile): Bind `comp-running-batch-compilation' it.

2021-10-04  Ken Brown  <kbrown@cornell.edu>

	Fix native-compilation build from tarball on Cygwin

	* src/Makefile.in (../native-lisp) [CYGWIN]: Rebase the *.eln
	files after they are all created, to avoid fork problems later in
	the build.  (Bug#50666)

2021-10-04  Robert Pluim  <rpluim@gmail.com>

	Remove U+FE0F from script-representative-chars

	* lisp/international/fontset.el (script-representative-chars): Remove
	U+FE0F / VS-16 from the 'emoji' entry.  It could cause us to skip
	fonts that don't have a glyph for it, even though we don't actually
	need one.

2021-10-04  Robert Pluim  <rpluim@gmail.com>

	Fix problem with 'vertical-motion' and emoji

	* src/font.c (font_range): Pass correct position to
	font_for_char (Bug#51012).

2021-10-04  Michael Albinus  <michael.albinus@gmx.de>

	* test/README: Mention :nativecomp tag.

2021-10-04  Gregory Heytings  <gregory@heytings.org>

	Avoid exiting when outputting error messages during loadup

	* src/print.c (print_error_message): Don't call
	'substitute-command-keys' when it isn't fboundp.

2021-10-04  Robert Pluim  <rpluim@gmail.com>

	Remove implemented emoji items

	* etc/TODO: Remove implemented emoji items.

2021-10-04  Lars Ingebrigtsen  <larsi@gnus.org>

	project.el NEWS tagging

	thing-at-mouse NEWS tagging

2021-10-04  Lars Ingebrigtsen  <larsi@gnus.org>

	Mention ffap-file-name-with-spaces in the ffap doc string

	* lisp/ffap.el (find-file-at-point): Mention
	ffap-file-name-with-spaces in the doc string.

2021-10-04  Lars Ingebrigtsen  <larsi@gnus.org>

	Revert "Make info-look search harder for the Python info file"

	This reverts commit 711eb40b9b9e2aabd0e23ec264e8e8f913329d33.

	This leads to loading info-look being excessively slow if the info path is long.  It'll be reimplemented in Emacs 29.

2021-10-04  Paul Eggert  <eggert@cs.ucla.edu>

	Add safety check in x_menu_show

	* src/xmenu.c (x_menu_show): Explicitly check whether save_wv can
	be null here.  Looks like it can be but I am not 100% sure, so
	play it safe and add a FIXME comment.

2021-10-04  Paul Eggert  <eggert@cs.ucla.edu>

	Tweak x_connection_closed when I/O error

	* src/xterm.c (x_connection_closed): Don’t dereference dpyinfo
	in the unlikely case where it is null and ioerror is true.
	This pacifies gcc 11.2.1 -Wanalyzer-null-dereference.

2021-10-04  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/erc/erc.el (erc-user-mode): Set "+i" by default.

2021-10-04  Paul Eggert  <eggert@cs.ucla.edu>

	Port unused decls to C2x

	* src/conf_post.h (ATTRIBUTE_UNUSED): Remove.  All uses replaced
	by MAYBE_UNUSED, and moved to start as needed for C2x.

2021-10-04  Stefan Kangas  <stefankangas@gmail.com>

	Improve structure of TODO

	* etc/TODO: Various improvements to the document structure according
	to discussion with the maintainers.

2021-10-04  Stefan Kangas  <stefankangas@gmail.com>

	Don't use some obsolete names in documentation

	* admin/notes/bugtracker: Use non-obsolete name
	'mail-dont-reply-to-names'.
	* admin/notes/multi-tty: Mention new variable name
	'x-selection-value'.
	* doc/lispintro/emacs-lisp-intro.texi (Point and mark)
	(Point and mark, Design @value{COUNT-WORDS}): Avoid using obsolete
	name 'count-lines-region'.
	* doc/lispref/hooks.texi (Standard Hooks): Remove reference to
	obsolete abnormal hook 'completion-annotate-function'.
	* doc/misc/efaq.texi (SPC no longer completes file names): Remove
	reference to obsolete 'minibuffer-local-filename-must-match-map';
	setting it has no effect.
	* doc/misc/gnus.texi (NNTP): Remove reference to obsolete variable
	'nntp-authinfo-file'.
	* doc/misc/reftex.texi (Table of Contents, Creating Citations)
	(Options - Table of Contents, Options - Referencing Labels)
	(Options - Creating Citations, Options - Index Support)
	(Options - Index Support, Changes): Don't use obsolete names.
	* doc/misc/speedbar.texi (Minor Display Modes)
	(Major Display Modes): Make variable name suggestions more in line
	with existing non-obsolete variable.
	* lisp/textmodes/reftex-cite.el (reftex-select-bib-mode-map):
	* lisp/textmodes/reftex-ref.el (reftex-offer-label-menu): Don't use
	obsolete variable names.
	* lisp/progmodes/which-func.el (which-func-mode): Doc fix.

2021-10-04  Paul Eggert  <eggert@cs.ucla.edu>

	Tweak x_hide_tip for consistency

	* src/xfns.c (x_hide_tip, Fx_show_tip): Be consistent about using
	!NILP (tip_frame) instead of FRAMEP (tip_frame).  The two
	expressions are logically equivalent since tip_frame is either a
	frame or nil, !NILP is a bit faster, and making things consistent
	pacifies gcc 11.2.1 -Wanalyzer-null-dereference.

2021-10-04  Paul Eggert  <eggert@cs.ucla.edu>

	Remove encode_terminal_code UNINITs

	* src/term.c (encode_terminal_code): Clarify by removing a couple
	of UNINITs and testing the local variable ‘cmp’ instead of
	retesting src->u.cmp.automatic.  This pacifies gcc 11.2.1
	-Wanalyzer-null-dereference.

2021-10-04  Paul Eggert  <eggert@cs.ucla.edu>

	Port pdumper.c maybe_unused to C2x

	Port pdumper.c to C2x, and pacify gcc 11.2.1 -Wattributes -Wunused.
	* src/pdumper.c (dump_tailq_prepend):
	Omit ATTRIBUTE_UNUSED, since it’s always used.
	(dump_tailq_append): Remove; unused.

2021-10-04  Paul Eggert  <eggert@cs.ucla.edu>

	Port systhreads.h to C2x

	* src/systhread.h: Put NODISCARD at the start of extern
	declarations, not at the end.  This is needed by C2x.
	This patch also pacifies gcc 11.2.1 -Wattributes.

2021-10-04  Paul Eggert  <eggert@cs.ucla.edu>

	Pacify -Wanalyzer-null-argument in lisp_malloc

	* src/alloc.c (lisp_malloc): Document that NBYTES must be
	positive, and omit a needless runtime check.  This pacifies a
	false alarm with gcc 11.2.1 -Wanalyzer-possible-null-dereference.

2021-10-04  Paul Eggert  <eggert@cs.ucla.edu>

	Pacify gcc 11.2.1 -Wanalyzer-null-argument

	* src/gtkutil.c (xg_item_label_same_p): Clarify boolean expression
	to pacify -Wanalyzer-null-argument with GCC 11.2.1 20210728
	(Red Hat 11.2.1-1).

2021-10-04  João Távora  <joaotavora@gmail.com>

	Simplify hack-read-symbol-shorthands again (bug#50946)

	* lisp/loadup.el (load-source-file-function): Don't set twice.

	* lisp/shorthands.el (hack-read-symbol-shorthands): Simplify.
	(load-with-shorthands-and-code-conversion): Remove.

	* lisp/international/mule.el (load-with-code-conversion): Call
	hack-read-symbol-shorthands-function.  Set up shorthands.
	(hack-read-symbol-shorthands-function): New variable.

2021-10-03  Eli Zaretskii  <eliz@gnu.org>

	Fix recipe for 'native-lisp' directory

	* src/Makefile.in (../native-lisp): If the directory native-lisp
	exists, do nothing.

2021-10-03  Paul Eggert  <eggert@cs.ucla.edu>

	Simplify socket symlink-attack checking

	This is a minor bugfix cleanup (Bug#33847#161).
	* lib-src/emacsclient.c: Move "#include <acl.h>" to inside
	"#ifdef SOCKETS_IN_FILE_SYSTEM", which is more accurate
	and simpler than having a separate "#ifndef WINDOWSNT".
	(O_PATH): Likewise.

2021-10-03  Alan Mackenzie  <acm@muc.de>

	Clarify (elisp) insert-file-contents with BEG or END not on character boundary

	* doc/lispref/files.texi (Reading from files): When the argument BEG or END to
	insert-file-contents are at a byte position not at a character boundary,
	clarify that raw bytes get inserted, and how to handle this awkwardness in
	Lisp.  Also clarify that insert-file-contents-literally is intended to insert
	raw bytes into the buffer.  Fix the outdated example that states it inserts
	500 characters, when it actually inserts 500 bytes.

2021-10-03  Andreas Schwab  <schwab@linux-m68k.org>

	* src/Makefile.in: Simplify conditionals.

2021-10-03  Juri Linkov  <juri@linkov.net>

	Move context-menu selection items Defun/List/Symbol to prog-mode (bug#9054)

	* lisp/mouse.el (context-menu-functions):
	Add context-menu-middle-separator to choices.
	(context-menu-region): Move Defun/List/Symbol selection items
	to prog-context-menu.

	* lisp/progmodes/prog-mode.el (prog-context-menu):
	Move Defun/List/Symbol selection items from context-menu-region.
	Include text-mode select menu only in strings and comments.

	* lisp/textmodes/text-mode.el (text-mode-menu): New function.
	(text-mode): Add text-mode-menu to context-menu-functions.

2021-10-03  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el (tab-bar-detach-tab): Handle frame selected by make-frame.

	(tab-bar-move-window-to-tab): New command.
	(tab-bar-new-tab-to): Handle the value 'window' of tab-bar-new-tab-choice.
	https://lists.gnu.org/archive/html/emacs-devel/2021-09/msg02197.html

2021-10-03  Juri Linkov  <juri@linkov.net>

	* lisp/tab-line.el (tab-line-format): Add face-modified to the cache key.

	When tab-line-tab-face-functions contains tab-line-tab-face-modified,
	add 'buffer-modified-p' status to the cache-key, so the cache will expire
	when the buffer modification status will change.
	https://lists.gnu.org/archive/html/emacs-devel/2021-10/msg00129.html

2021-10-03  Michael Albinus  <michael.albinus@gmx.de>

	Fix unmounting in Tramp

	* doc/misc/tramp.texi (FUSE setup): Add tramp-fuse-unmount-on-cleanup.

	* lisp/net/tramp.el (tramp-file-name-unify): New defun.
	(tramp-file-name-equal-p):
	* lisp/net/tramp-cache.el (tramp-get-connection-property)
	(tramp-set-connection-property, tramp-flush-connection-property)
	(tramp-flush-connection-properties): Use it.

	* lisp/net/tramp-fuse.el (tramp-fuse-get-fusermount): New defun.
	(tramp-fuse-mount-points): New defvar.
	(tramp-fuse-unmount): Use it.  Delete VEC from
	`tramp-fuse-mount-points'.  Delete mount point.
	(tramp-fuse-unmount-on-cleanup): New user option.
	(tramp-fuse-cleanup, tramp-fuse-cleanup-all): New defuns.
	(top): Adapt `tramp-fuse-unload-hook',
	`tramp-cleanup-connection-hook',
	`tramp-cleanup-all-connections-hook' and `kill-emacs-hook'.

	* lisp/net/tramp-rclone.el (tramp-rclone-maybe-open-connection):
	* lisp/net/tramp-sshfs.el (tramp-sshfs-maybe-open-connection):
	Add VEC to `tramp-fuse-mount-points'.

	* test/lisp/net/tramp-tests.el (tramp-fuse-unmount-on-cleanup): Declare.
	(tramp-test39-make-lock-file-name): Use it.

2021-10-03  Stefan Kangas  <stefankangas@gmail.com>

	* etc/themes/light-blue-theme.el: Add "Maintainer: emacs-devel".

2021-10-03  Eli Zaretskii  <eliz@gnu.org>

	Define HAVE_NATIVE_COMP in src/Makefile.in

	* src/Makefile.in (HAVE_NATIVE_COMP): Define.  Reported by Ken
	Brown <kbrown@cornell.edu>.

2021-10-03  João Távora  <joaotavora@gmail.com>

	Rename elisp-shorthands to read-symbol-shorthands

	The new name fits better in the family of variables that affect
	the Lisp reader.

	Suggested-by: Po Lu <luangruo@yahoo.com>

	* doc/lispref/symbols.texi (Shorthands): Mention read-symbol-shorthands

	* lisp/shorthands.el (hack-read-symbol-shorthands)
	(hack-read-symbol-shorthands)
	(shorthands-font-lock-shorthands): Use read-symbol-shorthands

	* lisp/progmodes/elisp-mode.el (elisp--completion-local-symbols)
	(elisp--completion-local-symbols)
	(elisp-shorthands): Use read-symbol-shorthands

	* src/lread.c:
	(syms_of_lread): Define Vread_symbol_shorthands
	(oblookup_considering_shorthand): Use Vread_symbol_shorthands.

	* test/lisp/progmodes/elisp-mode-tests.el (elisp-shorthand-read-buffer):
	(elisp-shorthand-read-from-string): Use read-symbol-shorthands

	* test/lisp/progmodes/elisp-mode-resources/simple-shorthand-test.el
	Use new symbol name read-symbol-shorthands.

2021-10-03  João Távora  <joaotavora@gmail.com>

	Font-lock shorthands in elisp-mode for quick visual recognition (bug#50959)

	Only the shorthanded prefix is font-locked.  This allows the remainder
	of the font-lock logic to subsist (e.g. for macro-defining symbols).

	* lisp/shorthands.el (cl-lib): Require it when compiling.
	(elisp-shorthand-font-lock-face): New face.
	(shorthands--mismatch-from-end): New helper.
	(shorthands-font-lock-shorthands): New helper.

	* test/lisp/progmodes/elisp-mode-resources/simple-shorthand-test.el:
	Add some dummy test code.

2021-10-03  Michael Albinus  <michael.albinus@gmx.de>

	Suppress superfluous error messages in Tramp

	* lisp/net/tramp-sshfs.el (tramp-sshfs-handle-insert-file-contents):
	* lisp/net/tramp.el (tramp-handle-insert-file-contents)
	(tramp-handle-lock-file): Suppress superfluous error message.

2021-10-03  Eli Zaretskii  <eliz@gnu.org>

	Fix reading the tail of a file in shorthands.el

	* lisp/shorthands.el (hack-elisp-shorthands): Fix reading past
	3000-character limit from EOF.  (Bug#50946)

2021-10-03  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix substitution of pretty quotes in code in easy-mmode

	* lisp/emacs-lisp/easy-mmode.el (easy-mmode--arg-docstring): Adjust.
	(easy-mmode--mode-docstring): Avoid making quotes into pretty
	quotes in code (bug#50968).

2021-10-03  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix agent directory deletion

	* lisp/gnus/gnus-agent.el (gnus-agent-expire-unagentized-dirs):
	Delete directories in a simpler way that actually works (bug#50986).

2021-10-03  Stefan Kangas  <stefankangas@gmail.com>

	Clarify the purpose of internal--format-docstring-line

	* test/lisp/subr-tests.el (subr-test-internal--format-docstring-line):
	* lisp/subr.el (internal--format-docstring-line): Make it more clear
	that this function is not intended for the first line of a docstring.
	* lisp/emacs-lisp/cl-macs.el (cl-defstruct): Add comment explaining
	why we use 'internal--format-docstring-line'.
	Problem pointed out by Stefan Monnier <monnier@iro.umontreal.ca>.

2021-10-02  Juri Linkov  <juri@linkov.net>

	* lisp/net/dictionary.el (context-menu-dictionary): Move menu item down.

	Place the dictionary menu item after middle-separator (bug#50552).

2021-10-02  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.5-30-g10dc9d

	The plan is to cut the Org 9.5.1 release and include it in Emacs 28.1,
	but in the meantime regularly sync changes from Org's bugfix branch to
	emacs-28.

	This sync includes files from Org 9.5's new etc/csl/ directory that
	should have been synced in bf9ec3d91a (Update to Org 9.5, 2021-09-29).

2021-10-02  Glenn Morris  <rgm@gnu.org>

	Remove bogus ":safe t" custom properties

	* lisp/org/oc.el (org-cite-global-bibliography)
	(org-cite-note-rules, org-cite-punctuation-marks):
	* lisp/org/oc-csl.el (org-cite-csl-locales-dir)
	(org-cite-csl-styles-dir, org-cite-csl-no-citelinks-backends):
	* lisp/org/oc-natbib.el (org-cite-natbib-options):
	* lisp/org/org-keys.el (org-mouse-1-follows-link):
	Remove bogus ":safe t" properties that would largely need to be
	replaced by custom predicates.

2021-10-02  Eli Zaretskii  <eliz@gnu.org>

	Fix 'apropos-compact-layout'

	* lisp/textmodes/fill.el (fill-region-as-paragraph): Fix filling
	paragraphs that end at EOB without a newline.  (Bug#50974)

2021-10-02  Glenn Morris  <rgm@gnu.org>

	Remove bogus ":safe nil" custom properties

	* lisp/org/oc.el (org-cite-activate-processor)
	(org-cite-export-processors, org-cite-follow-processor)
	(org-cite-insert-processor):
	* lisp/org/ol.el (org-link-parameters, org-link-frame-setup)
	(org-link-shell-confirm-function)
	(org-link-shell-skip-confirm-regexp)
	(org-link-elisp-confirm-function)
	(org-link-elisp-skip-confirm-regexp):
	* lisp/org/org-num.el (org-num-format-function):
	Remove bogus ":safe nil" that do nothing but propagate a
	misunderstanding of the safe-local-variable property.

2021-10-02  Glenn Morris  <rgm@gnu.org>

	The safe-local-variable property is a function (bug#50944)

	* lisp/org/oc-basic.el (org-cite-basic-sorting-field)
	(org-cite-basic-author-year-separator)
	(org-cite-basic-max-key-distance)
	(org-cite-basic-author-column-end)
	(org-cite-basic-column-separator)
	(org-cite-basic-mouse-over-key-face):
	* lisp/org/oc-biblatex.el (org-cite-biblatex-options):
	* lisp/org/oc-csl.el (org-cite-csl-link-cites)
	(org-cite-csl-html-hanging-indent)
	(org-cite-csl-html-label-width-per-char)
	(org-cite-csl-latex-hanging-indent):
	* lisp/org/oc.el (org-cite-adjust-note-numbers):
	* lisp/org/org-keys.el (org-return-follows-link):
	* lisp/org/org.el (org-fontify-todo-headline):
	* lisp/org/ox-html.el (org-html-equation-reference-format)
	(org-html-wrap-src-lines):
	* lisp/org/ox-latex.el (org-latex-reference-command)
	(org-latex-default-quote-environment):
	* lisp/textmodes/tildify.el (tildify-pattern)
	(tildify-space-string): Fix :safe property.

2021-10-02  Stefan Kangas  <stefankangas@gmail.com>

	Revert "; * etc/TODO: Move elpa.gnu.org items to the end."

	This reverts commit d73f0e96a7026808c01861f7525a2909279fc00d.

	These items are a priority for the project and should be before other,
	less prioritized items, according to a private discussion with project
	co-maintainer Eli Zaretskii <eliz@gnu.org>.

2021-10-02  Stefan Kangas  <stefankangas@gmail.com>

	Revert "* etc/TODO: Rearrange to start with "Simple tasks"."

	This reverts commit 879ef5b19ab1dd90284aef829ef306d56b4e5adb.

	Some of these items are a priority for the project and should be
	before other, less prioritized items, according to a private
	discussion with project co-maintainer Eli Zaretskii <eliz@gnu.org>.

2021-10-02  Eli Zaretskii  <eliz@gnu.org>

	Fix selection of fonts for Arabic on Posix platforms

	* lisp/international/fontset.el (script-representative-chars): Add
	U+06C1 to representative-characters for Arabic.  (Bug#50951)

2021-10-02  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix ox-koma-letter compilation warnings

	* lisp/org/ox-koma-letter.el (org-koma-letter-export-block)
	(org-koma-letter-export-snippet): Fix warning about two unused
	parameter.

2021-10-02  Eli Zaretskii  <eliz@gnu.org>

	Preload paren.el

	* lisp/Makefile.in (COMPILE_FIRST): Add the dependencies of
	comp.el, so that they are natively-compiled in advance.
	* lisp/loadup.el ("paren"): Preload paren.el.	(Bug#50934)

2021-10-02  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'shift-select-mode'

	* doc/emacs/mark.texi (Shift Selection): Document the 'permanent'
	value of 'shift-select-mode'.  Add index entry for that variable.
	(Bug#50954)

	* etc/NEWS: Update the entry for 'shift-select-mode'.

2021-10-02  João Távora  <joaotavora@gmail.com>

	Simplify shorthand injection (bug#50946)

	* lisp/loadup.el: Load "shorthands" relatively late. Set
	load-source-file-function to load-with-shorthands-and-code-conversion

	* lisp/international/mule.el (hack-elisp-shorthands)
	(load-with-shorthands-and-code-conversion): Move to
	lisp/shorthands.el

	* lisp/shorthands.el: New file.

2021-10-01  Glenn Morris  <rgm@gnu.org>

	* doc/lispref/control.texi (pcase Macro): Fix cross-reference.

2021-10-01  Glenn Morris  <rgm@gnu.org>

	Fix some custom types

	* lisp/mpc.el (mpc-cover-image-re):
	* lisp/org/oc-csl.el (org-cite-csl-locales-dir)
	(org-cite-csl-styles-dir):
	* lisp/org/org-plot.el (org-plot/preset-plot-types): Fix :type.

2021-10-01  Stefan Kangas  <stefankangas@gmail.com>

	* etc/TODO: Add interactive mode tagging.

	* etc/TODO: Rearrange to start with "Simple tasks".

	* etc/TODO: Remove outdated item.  (Bug#50904)

2021-10-01  Stefan Kangas  <stefankangas@gmail.com>

	Rename arguments of ERC's '/whois' and simplify doc string

	* lisp/erc/erc.el (erc-cmd-WHOIS): Rename arguments and reword the doc
	string to further clarify and simplify.

2021-09-30  Dmitry Gutov  <dgutov@yandex.ru>

	Migrate Xref off EIEIO

	To improve performance and flexibility (bug#50777).

	* lisp/progmodes/xref.el (xref-location): Remove.
	(xref-file-location): Change to cl-struct.
	(xref-buffer-location, xref-bogus-location): Ditto.
	(xref-item, xref-match-item): Same.
	And update all method definitions accordingly.
	(xref--insert-xrefs): Don't use 'oref', use 'xref-item-location'.
	(xref--insert-xrefs, xref-show-definitions-completing-read):
	Instead of 'with-slots', use 'xref-item-summary' and
	'xref-item-location'.

	* lisp/progmodes/etags.el (xref-etags-location):
	Change from EIEIO class into a cl-struct.
	(xref-etags-apropos-location): Ditto.
	Update all method definitions.

	* test/lisp/progmodes/elisp-mode-tests.el (xref-elisp-test-run):
	Avoid using 'oref'.

2021-09-30  Eli Zaretskii  <eliz@gnu.org>

	* admin/release-branch.txt: New file.

	* lisp/dired.el (dired-omit-mode): Declare, to avoid compiler warning.

2021-09-30  Eli Zaretskii  <eliz@gnu.org>

	Cut the emacs-28 release branch

	* README:
	* configure.ac:
	* nt/README.W32:
	* msdos/sed2v2.inp: Bump Emacs version to 28.0.60.

	* lisp/cus-edit.el (customize-changed-options-previous-release):
	Update the last released version of Emacs.

2021-09-30  Nikolay Kudryavtsev  <nikolay.kudryavtsev@gmail.com>

	Make checkdoc's docstring substitution consistent with other docs

	* lisp/emacs-lisp/checkdoc.el (checkdoc-this-string-valid-engine):
	In error text, say "mapvar" instead of "keymap", and "command"
	instead of "function", to be consistent with the ELisp manual.
	(Bug#50903)

2021-09-30  Mattias Engdegård  <mattiase@acm.org>

	Fix regexp snags in org

	* lisp/org/org-element.el (org-element-citation-key-re):
	* lisp/org/ox-org.el (org-org-identity):
	Remove repeated chars in alternatives.
	* lisp/org/ob-java.el (org-babel-execute:java):
	Remove superfluous backslash.
	* lisp/org/ob-java.el (org-babel-java--main-re)
	(org-babel-java--any-method-re): Remove (0+ space) expressions
	subsumed by adjacent expressions.

2021-09-30  Mattias Engdegård  <mattiase@acm.org>

	org-element: use correct function

	* lisp/org/org-element.el (org-element-headline-parser):
	Pretty sure this one should be `skip-chars-backward`, not
	`skip-syntax-backward`, since \t isn't a valid syntax code.

2021-09-30  Mattias Engdegård  <mattiase@acm.org>

	Revert "Indent bodies of local function definitions properly in elisp-mode"

	This reverts commit 38037e04cb05cb1f2b604f0b1602d36b0bcf6985.

2021-09-30  Mattias Engdegård  <mattiase@acm.org>

	Revert "Fix regressions in cl-flet indentation"

	This reverts commit c42af5aee74f310bdcd63aac96b1c02ec07a1c50.

2021-09-30  Philip Kaludercic  <philipk@posteo.net>

	Add rcirc-omit-unless-requested option

	* doc/misc/rcirc.texi (Notices): Update documentation
	* lisp/net/rcirc.el (rcirc-pending-requests): Add local variable
	(rcirc-omit-unless-requested): Add user option
	(rcirc-print): Respect rcirc-omit-unless-requested
	(rcirc-define-command): Update rcirc-pending-requests

2021-09-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/org/ob-julia.el: Use lexical-binding

	(ess-eval-visibly-p): Declare.
	(org-babel-julia-assign-elisp): Remove unused vars `header` and
	`row-names` and correspondingly remove now unused args `colnames-p` and
	`rownames-p`.
	(org-babel-variable-assignments:julia): Adjust call to
	`org-babel-julia-assign-elisp` accordingly.
	(org-babel-julia-initiate-session): Use `bound-and-true-p`.
	(org-babel-julia-evaluate-external-process)
	(org-babel-julia-evaluate-session, org-babel-julia-evaluate):
	Remove unused arg `row-names-p`.
	(org-babel-execute:julia): Adjust call to
	`org-babel-julia-evaluate` accordingly.

2021-09-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/org/ox-koma-letter.el: Use lexical-binding

	And remove redundant `:group` args.

2021-09-30  Eli Zaretskii  <eliz@gnu.org>

	Fix a recent change of 'undo-redo' binding

	* lisp/bindings.el (global-map): Fix the binding of 'undo-redo'.
	(Bug#50911)

2021-09-30  Eli Zaretskii  <eliz@gnu.org>

	Merge Org 9.5 from branch 'origin/scratch/org-sync'.

2021-09-30  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix previous `newline' patch

	* lisp/simple.el (newline): Signal an error earlier to avoid
	peculiar behavior after getting a backtrace (bug#50900).

2021-09-30  Lars Ingebrigtsen  <larsi@gnus.org>

	Make `newline' check the argument earlier

	* lisp/simple.el (newline): Signal an error earlier to avoid
	peculiar behavior after getting a backtrace (bug#50900).

2021-09-30  akater  <nuclearspace@gmail.com>

	Fix regressions in cl-flet indentation

	* lisp/emacs-lisp/lisp-mode.el (lisp--local-defform-body-p):
	Rename (from -p-less form) and fix indentation regression
	introduced by 38037e04cb05cb1f2b604f0b1602d36b0bcf6985
	(bug#9622).  Also add cl-macrolet cl-flet* cl-symbol-macrolet.

2021-09-30  dickmao  <none>

	Fix bootstrap after recent undo-redo change

	* lisp/bindings.el (global-map): Don't use `kbd' here -- it breaks
	bootstrap (bug#50911).

2021-09-30  Kyle Meyer  <kyle@kyleam.com>

	* etc/NEWS: Announce Org update.

	Update to Org 9.5

2021-09-30  Amin Bandali  <bandali@gnu.org>

	Add new '/wii' convenience ERC command

	* etc/NEWS: Announce the addition of the command.
	* lisp/erc/erc.el (erc-cmd-WII): Add '/wii' convenience command which
	calls the '/whois' command with the given nick as both arguments,
	which is useful for displaying the whois information for the nick
	along with idle time, even if the nick is on a different server than
	the one we are currently connected to.

2021-09-30  Amin Bandali  <bandali@gnu.org>

	Restore the previous order of ERC's '/whois' arguments

	* etc/NEWS: Remove unneeded entry.
	* lisp/erc/erc.el (erc-cmd-WHOIS): Restore the previous order of
	arguments sent to the server, so that there's no change in the
	function's behavior.  Instead, rename the arguments to be more
	accurate, and expand upon them in the doc string.

2021-09-30  Stefan Kangas  <stefankangas@gmail.com>

	New command mpc-goto-playing-song

	* lisp/mpc.el (mpc-goto-playing-song): New command to go to the
	currently playing song.
	(mpc-mode-map): Bind it to "o".

2021-09-29  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/linum.el: Recommend `display-line-numbers-mode'.

2021-09-29  Dmitry Gutov  <dgutov@yandex.ru>

	Add bindings for 'undo-redo'

	* etc/NEWS: Describe the change.

	* lisp/bindings.el (global-map): Add bindings for 'undo-redo'.

	* lisp/simple.el (undo-no-redo): Turn into a user option.

2021-09-29  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el (tab-bar-move-tab-to-frame): Delete frame with last tab.

2021-09-29  Adam Porter  <adam@alphapapa.net>

	* lisp/tab-bar.el: (tab-bar-detach-tab) New command

	(tab-bar-detach-tab): New command.
	(tab-bar-mouse-context-menu): Add menu entry.

	With thanks to Matt Beshara <m@mfa.pw> for his feedback.
	https://lists.gnu.org/archive/html/emacs-devel/2021-09/msg02141.html

2021-09-29  Lars Ingebrigtsen  <larsi@gnus.org>

	Tweak previous message-newline-and-reformat change

	* lisp/gnus/message.el (message-newline-and-reformat): Only search
	for previous/next cited lines that have space, because it's the
	space we're trying to find.

2021-09-29  Lars Ingebrigtsen  <larsi@gnus.org>

	Cross reference `dired-do-revert-buffer'

	* lisp/dired-aux.el (dired-do-copy):
	(dired-do-symlink):
	(dired-do-hardlink):
	(dired-do-rename): Mention `dired-do-revert-buffer'.

2021-09-29  Lars Ingebrigtsen  <larsi@gnus.org>

	Do some NEWS taggin

2021-09-29  Stefan Kangas  <stefankangas@gmail.com>

	* etc/TODO: Delete ImageMagick items.  (Bug#50891)

2021-09-29  Lars Ingebrigtsen  <larsi@gnus.org>

	Make `M-q' in message-mode work better

	* lisp/gnus/message.el (message-newline-and-reformat): Fix
	bug#43299 differently.
	(message-newline-and-reformat): Revert change for bug#43299.  This
	fixes bug#50842.

2021-09-29  Stefan Kangas  <stefankangas@gmail.com>

	Force volume to an integer divisible by mpc-volume-step

	* lisp/mpc.el (mpc-volume-mouse-set): Force volume to an integer
	divisible by 'mpc-volume-step'.
	(mpc-volume-step): Add docstring.

2021-09-29  Lars Ingebrigtsen  <larsi@gnus.org>

	Signal an error in `search-forward-help-for-help'

	* lisp/help.el (search-forward-help-for-help): Error out instead
	of showing an empty buffer (bug#50881).

2021-09-29  Lars Ingebrigtsen  <larsi@gnus.org>

	Add a comment about bug#50877 for gnus-set-difference

2021-09-29  Lars Ingebrigtsen  <larsi@gnus.org>

	Revert "Obsolete local set difference functions in favor of seq-difference"

	This reverts commit 20f7fa691b7c2859b96550d9ccb326bf394e160d.

	gnus-set-difference is orders of magnitude faster than seq-difference
	(on these sets), and using seq-difference makes nnimap too
	slow.

2021-09-29  Michael Albinus  <michael.albinus@gmx.de>

	* test/Makefile.in (WRITE_LOG): Add emacs-module-tests as problematic.

2021-09-29  Protesilaos Stavrou  <info@protesilaos.com>

	Update modus-themes to version 1.6.0

	* doc/misc/modus-themes.org (Customization Options): Document new user
	options in code sample.
	(Option for inhibiting theme reload): Remove trailing space.
	(Option for mode line presentation): Include new possible value.
	(Option for Org agenda constructs): Include new symbols for the
	'modus-themes-org-agenda' alist.
	(Control the scale of headings): Document 'modus-themes-scale-small'.
	(Override color saturation (DIY)): Fix markup for proper texi output.
	(Custom Org user faces (DIY)): Update code samples.
	(Full support for packages or face groups): Note names of newly
	supported packages or face groups.
	(Indirectly covered packages): Document indirectly supported packages.
	(Note on highlight-parentheses.el): Provide detailed instructions on
	how to use 'highlight-parentheses' with the Modus themes.
	(Note on prism.el): Refine code samples.
	(What is the best setup for legibility?): Minor rewording.
	(Sources of the themes): Mention only Emacs28 without explaining that
	it is the development target---in preparation of the emacs-28 branch
	cut.
	(Acknowledgements): Name new contributors to code/ideas.  Stephen
	Gildea's patch was a couple lines long.  The others have assigned
	copyright to the FSF.
	(Meta): Include another link to the development notes of the themes
	about 'modus-themes-org-agenda'.

	* etc/themes/modus-operandi-theme.el,
	  etc/themes/modus-vivendi-theme.el: Bump file version.

	* etc/themes/modus-themes.el (modus-themes-operandi-colors)
	(modus-themes-vivendi-colors): Recalibrate some color values and add
	a few new ones.
	(modus-themes-slanted-constructs): Remove obsolete user option.
	Superseded by the alias 'modus-themes-italic-constructs'.
	(modus-themes-org-agenda, modus-themes-mode-line): Update user option.
	(modus-themes-scale-headings, modus-themes-scale-4): Update doc
	string.
	(modus-themes-scale-5): Remove obsolete user option.  Superseded by
	the alias 'modus-themes-scale-title'.
	(modus-themes-scale-small, modus-themes-tabs-accented): Add new user
	option.
	(modus-themes--agenda-date, modus-themes--mode-line-attrs)
	(modus-themes--tab): Update internal functions.
	(modus-themes-faces): Update variousface attributes.

	Detailed change log here:
	<https://protesilaos.com/codelog/2021-09-29-modus-themes-1-6-0/>.

2021-09-29  Philip Kaludercic  <philipk@posteo.net>

	Remove rcirc-omit-responses-after-join option

	The implementation does not work as expected and behaves
	unpredictably.

	* lisp/net/rcirc.el (rcirc-omit-responses-after-join): Remove
	option
	(rcirc-joined): Remove variable
	(rcirc-reconnect): Remove rcirc-joined code
	(rcirc-get-buffer-create): Remove rcirc-joined code
	(rcirc-print): Remove rcirc-omit-responses-after-join check
	* doc/misc/rcirc.texi (Notices): Remove documentation
	* etc/NEWS: Remove mention

2021-09-29  Stefan Kangas  <stefankangas@gmail.com>

	New user option mpc-cover-image-re

	* lisp/mpc.el (mpc-cover-image-re): New user option.
	(mpc-format): Find cover image based on regexp given by above new user
	option.  Treat "folder.png" as a valid cover image name.

2021-09-29  Martin Rudalics  <rudalics@gmx.at>

	Fix 'window-toggle-side-windows' (Bug#50867)

	* lisp/window.el (window-toggle-side-windows): Bind
	'window-combination-resize' to t around 'window-state-put'
	calls (Bug#50867).

2021-09-29  Michael Albinus  <michael.albinus@gmx.de>

	Some inmprovements in emba CI files

	* test/infra/Dockerfile.emba: Remove superfluous "make -j4".

	* test/infra/gitlab-ci.yml (.test-template): Add 'allow_failure' clause.
	(test-all-inotify): Add 'needs' clause.

2021-09-29  Juri Linkov  <juri@linkov.net>

	* lisp/net/dictionary.el (context-menu-dictionary): Add autoload cookie.

	(context-menu-functions): Remove context-menu-dictionary from hook (bug#50552)

2021-09-29  Lars Ingebrigtsen  <larsi@gnus.org>

	Tweak the whitespace before "This is a generic function"

	* lisp/emacs-lisp/cl-generic.el (cl--generic-describe): Make the
	number of blank lines before this section consistent (whether
	there's an indented section before it or not).

2021-09-29  Lars Ingebrigtsen  <larsi@gnus.org>

	Improve the max-specpdl-size doc string

	* src/eval.c (syms_of_eval): Mention what "specpdl" means.

2021-09-29  Amin Bandali  <bandali@gnu.org>

	Switch the order of ERC's '/whois' arguments sent to the server

	* lisp/erc/erc.el (erc-cmd-WHOIS): Switch the order of 'server' and
	'user' arguments sent to the server.  Per RFC 1459 and RFC 2812, the
	optional 'server' argument command comes before the 'user' argument,
	not after.  While at it, update the doc string to explain why one may
	want to specify the 'server' argument.
	* etc/NEWS: Announce the change.

2021-09-29  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/mpc.el (mpc-format): Fix printing after last format spec.

2021-09-29  Amin Bandali  <bandali@gnu.org>

	Unobsolete erc-compat.el

	* lisp/obsolete/erc-compat.el: Move from here...
	* lisp/erc/erc-compat.el: ...back to here.  ERC will soon be added to
	GNU ELPA, and erc-compat.el will be used to provide compatibility
	functions and/or variables for using ERC on older Emacsen.
	* etc/NEWS: Remove the previously added obsoletion news item.

2021-09-29  Stefan Kangas  <stefankangas@gmail.com>

	* etc/NEWS: Announce Eshell bookmarks.

2021-09-29  Stefan Kangas  <stefankangas@gmail.com>

	Add bookmark.el support to eww

	* lisp/net/eww.el (eww-bookmark-name, eww-bookmark-make-record)
	(eww-bookmark-jump): New defuns.
	(eww-mode): Set up bookmark handler.

2021-09-29  Dmitry Gutov  <dgutov@yandex.ru>

	Enable show-paren-mode by default

	* etc/NEWS (https): Mention the change.

	* lisp/paren.el (show-paren-mode):
	Enable by default, as discussed on emacs-devel.

2021-09-29  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/net/eww.el (eww-mode): Show keybindings in docstring.

2021-09-28  Juri Linkov  <juri@linkov.net>

	* lisp/mouse.el (context-menu-map): Fix when menu is a command (bug#50851)

	* lisp/help.el (help--analyze-key): Get information at the position
	of mouse click such as 'C-h k' on a context menu item (bug#50067).

2021-09-28  Stefan Kangas  <stefankangas@gmail.com>

	Add shortdoc for text properties

	* lisp/emacs-lisp/shortdoc.el (text-properties): New shortdoc.

	e for your changes. Lines starting

2021-09-28  Stefan Kangas  <stefankangas@gmail.com>

	Mention describe-symbol in cl-defstruct docstring

	* lisp/emacs-lisp/cl-macs.el (cl-defstruct): Mention 'describe-symbol'
	in docstring.

2021-09-28  Stefan Kangas  <stefankangas@gmail.com>

	Mention cl-describe-type in cl-defstruct docstring

	* lisp/emacs-lisp/cl-macs.el (cl-defstruct): Mention
	'cl-describe-type' in docstring.

2021-09-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/emacs-lisp/map.el: Restore compatibility with Emacs-26

	Don't use the new `eql` syntax.

2021-09-28  Michael Albinus  <michael.albinus@gmx.de>

	Adapt tramp-tests.el for macOS

	* test/lisp/net/tramp-tests.el (tramp-test29-start-file-process)
	(tramp-test30-make-process): Adapt for macOS.

2021-09-28  Stefan Kangas  <stefankangas@gmail.com>

	* doc/man/emacs.1.in: Add --no-x-resources.  (Bug#50855)

2021-09-28  Stefan Kangas  <stefankangas@gmail.com>

	Improve coding conventions for error messages

	* doc/lispref/tips.texi (Programming Tips): Clarify coding
	conventions for error messages to say that an error message can
	start with a Lisp symbol.  (Bug#50658)

2021-09-28  Stefan Kangas  <stefankangas@gmail.com>

	Improve docstrings of ert-resource-{directory,file}

	* lisp/emacs-lisp/ert-x.el (ert-resource-directory)
	(ert-resource-file): Improve docstrings.

2021-09-28  Stefan Kangas  <stefankangas@gmail.com>

	Signal error on newline in internal--format-docstring-line

	* lisp/subr.el (internal--format-docstring-line): Signal error
	when trying to fill a line containing a newline.

	* lisp/cedet/semantic/decorate/mode.el
	(define-semantic-decoration-style):
	* lisp/emacs-lisp/easy-mmode.el (define-globalized-minor-mode):
	Don't pass newlines to 'internal--format-docstring-line'.

2021-09-28  Eli Zaretskii  <eliz@gnu.org>

	Make the build of source tarball produce *.eln files

	* lisp/emacs-lisp/comp.el (batch-native-compile): Accept an
	optional argument; if non-nil, place the .eln file as appropriate
	for building a source tarball.

	* doc/lispref/compile.texi (Native-Compilation Functions):
	Document the new optional argument of 'batch-native-compile'.

	* lisp/Makefile.in (.PHONY, $(THEFILE)n) [HAVE_NATIVE_COMP]: New
	targets.

	* src/Makefile.in (%.eln) [HAVE_NATIVE_COMP]: New recipe.
	(all) [HAVE_NATIVE_COMP]: Add ../native-lisp to prerequisites.
	(elnlisp) [HAVE_NATIVE_COMP]: New list of *.eln files.
	(../native-lisp) [HAVE_NATIVE_COMP]: New recipe.

	* src/verbose.mk.in (AM_V_ELN): New macro.

2021-09-28  Lars Ingebrigtsen  <larsi@gnus.org>

	Adjust ispell-look-command type

	* lisp/textmodes/ispell.el (ispell-look-command): Adjust :type
	after previous change.

2021-09-28  André A. Gomes  <andremegafone@gmail.com>

	Fix search of the look program

	* lisp/textmodes/ispell.el (ispell-look-command): Fix logic
	concerning the existence of the look program (bug#50852) -- search
	through the executable path.
	(ispell-look-p): Adjust logic.

2021-09-28  Lars Ingebrigtsen  <larsi@gnus.org>

	Use ert-resource-file in the shorthand tests

	Also move to the standard directory naming.

2021-09-28  Stefan Kangas  <stefankangas@gmail.com>

	checkdoc: Allow Lisp symbols to start a message

	* lisp/emacs-lisp/checkdoc.el (checkdoc-message-text-engine): Allow
	Lisp symbols to start a message.
	(checkdoc--error-bad-format-p): New helper function.

	* test/lisp/emacs-lisp/checkdoc-tests.el
	(checkdoc-test-error-format-is-good)
	(checkdoc-test-error-format-is-bad): New helper functions.
	(checkdoc-tests-error-message-bad-format-p)
	(checkdoc-tests-error-message-bad-format-p/defined-symbols)
	(checkdoc-tests-error-message-bad-format-p/not-capitalized):
	New tests.

2021-09-27  Ken Brown  <kbrown@cornell.edu>

	Make .eln files executable on Cygwin

	* Makefile.in (INSTALL_ELN): New variable, equal to $(INSTALL) on
	Cygwin and $(INSTALL_DATA) on other platforms.
	(install-eln): Use INSTALL_ELN instead of INSTALL_DATA.
	(Bug#50818)

2021-09-27  Michael Albinus  <michael.albinus@gmx.de>

	Simplify `file-notify--rm-descriptor'

	* lisp/filenotify.el (file-notify--rm-descriptor):
	Use `file-notify-handle-event'.

2021-09-27  Juri Linkov  <juri@linkov.net>

	* lisp/mouse.el (context-menu-region): Check for nil for char-after at eobp.

2021-09-27  Mattias Engdegård  <mattiase@acm.org>

	* lisp/progmodes/flymake.el (flymake-menu): Don't use obsolete name.

2021-09-27  Alan Third  <alan@idiocy.org>

	Fix GNUstep build failure

	* src/nsfns.m (Fns_hide_emacs): NSRunningApplication is only available
	in GNUstep 0.27 and above.

2021-09-27  Robert Pluim  <rpluim@gmail.com>

	Document 'glyphless-char-display-control' changes

	* etc/NEWS: Document 'glyphless-char-display-control' changes for
	Variation Selectors.

2021-09-27  Robert Pluim  <rpluim@gmail.com>

	Try to be consistent about user options in NEWS

	* etc/NEWS: Try to be consistent about calling 'user options' that
	instead of 'variables'.

2021-09-27  Alan Third  <alan@idiocy.org>

	Fix resizing glitches in NS port (bug#50413)

	* src/nsterm.m ([EmacsView resizeWithOldSuperviewSize:]): Use the
	superview's size instead of trusting the view's size.

2021-09-27  Alan Third  <alan@idiocy.org>

	Attempt to debug a graphical glitch on macOS

	* src/nsterm.m (ns_scroll_run):
	(ns_shift_glyphs_for_insert): Switch to using NSPoint for destination.
	([EmacsView copyRect:to:]): Use NSPoint for the destination, always
	use the view's layer, and log any questionable copy requests.

2021-09-27  Alan Third  <alan@idiocy.org>

	Fix NS toolbar again (bug#50534)

	* src/nsmenu.m (free_frame_tool_bar): Remove toolbar.
	(update_frame_tool_bar_1): New function.
	(update_frame_tool_bar): Move most of the functionality to
	update_frame_tool_bar_1.
	* src/nsterm.h: Definitions of functions and methods.
	* src/nsterm.m (ns_update_begin):
	([EmacsView windowDidEnterFullScreen]):
	([EmacsView windowDidExitFullScreen]): We no longer need to reset the
	toolbar visibility as that's done when we create the new fullscreen
	window.
	([EmacsWindow initWithEmacsFrame:fullscreen:screen:]): Move the check
	for undecorated frames into createToolbar:.
	([EmacsWindow createToolbar:]): Check whether a toolbar should be
	created, and run the toolbar update immediately.

2021-09-27  Stefan Kangas  <stefankangas@gmail.com>

	Fix automatic filling of docstring in cl-defstruct

	* lisp/emacs-lisp/cl-macs.el (cl-defstruct): Fix bug where a paragraph
	was filled as if it were a single line, which led to garbled
	output in the docstring.  (Bug#50839)

	* test/lisp/subr-tests.el
	(subr-test-internal--format-docstring-line): New test.

2021-09-27  Eli Zaretskii  <eliz@gnu.org>

	Minor fix in 'w32-find-non-USB-fonts'

	* lisp/term/w32-win.el (w32--filter-USB-scripts): Handle
	representative characters given as a vector, not a list.

2021-09-27  João Távora  <joaotavora@gmail.com>

	* etc/NEWS (Shorthands for Lisp symbols): Reword.

2021-09-27  Robert Pluim  <rpluim@gmail.com>

	Enhance font_range to check for emoji composition triggers

	If the codepoint that triggered composition is from the emoji script,
	use the emoji font to check the string being composed, rather than the
	font of the first character of the string.  This makes e.g.

	"emoji codepoint with Emoji_Presentation = No followed by VS-16 (FE0F)"

	display the emoji version of the glyph for that codepoint.

	* admin/unidata/blocks.awk: Add VS-1 through VS-16 to the emoji
	script.
	* src/composite.c (autocmp_chars): Accept additional argument CH for
	the codepoint that triggered composition, pass it to font_range.
	(composition_reseat_it, find_automatic_composition): Pass codepoint
	that triggered composition to autocmp_chars.
	* src/font.c (font_range): Accept additional argument CH for the
	triggering codepoint.  If the codepoint is from the 'emoji' script,
	use Vscript_representative_chars to find the font to use for the
	composition attempt.
	(syms_of_font): Add Qemoji symbol.
	* src/font.h: Update font_range prototype for argument CH.
	* etc/NEWS: Announce change.

2021-09-27  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix checkdoc-related test failure

	Fix two doc-related test failures

2021-09-27  Michael Albinus  <michael.albinus@gmx.de>

	Optimize emba builds

	* test/infra/Dockerfile.emba (emacs-base): Install also
	libdbus-1-dev and libacl1-dev.

	* test/infra/gitlab-ci.yml (prep-image-base): Comment out.  This
	stage is activated by default in Dockerfile.emba.

2021-09-27  Eli Zaretskii  <eliz@gnu.org>

	Minor stylistic fixes of shorthand code in C

	* src/lread.c (oblookup_considering_shorthand): Now static.  Move
	prototype to where it belongs.
	(read1, Fintern, Fintern_soft, Funintern)
	(oblookup_considering_shorthand, syms_of_lread): Fix style of
	braces and indentation, comments, and doc strings.

2021-09-27  Eli Zaretskii  <eliz@gnu.org>

	Minor fixes of Lisp doc strings for shorthands feature

	* lisp/progmodes/elisp-mode.el (obarray-cache)
	(elisp--completion-local-symbols):
	* lisp/international/mule.el (hack-elisp-shorthands)
	(load-with-shorthands-and-code-conversion): Doc string fixes.

2021-09-27  Eli Zaretskii  <eliz@gnu.org>

	Minor fixes in documentation of shorthands

	* etc/NEWS:
	* doc/lispref/symbols.texi (Symbol Components, Creating Symbols)
	(Shorthands): Improve wording, fix indexing and typos.

2021-09-27  Lars Ingebrigtsen  <larsi@gnus.org>

	Make comint understand the ccrypt password phrases

	* lisp/comint.el (comint-password-prompt-regexp): Add the ccrypt
	confirmation phrase (bug#50837).

	* lisp/international/mule-conf.el (password-word-equivalents): Add
	the ccrypt phrases.

2021-09-27  Lars Ingebrigtsen  <larsi@gnus.org>

	Add "passwd" (change password) prompt to comint

	* lisp/comint.el (comint-password-prompt-regexp): Add "passwd" (to
	change the password) first promp in Debian bullseye.

2021-09-27  Lars Ingebrigtsen  <larsi@gnus.org>

	Note that the Packaging sub-nodes are mostly for maintainers

	* doc/lispref/package.texi (Packaging): Note that the information
	is mostly for ELPA maintainers (bug#50825).

2021-09-27  dickmao  <none>

	Get a `package-test-signed` to work again

	The test signing key succumbed to either expiration or bitrot.
	I hope I didn't just publish my secret key to the world.

	* test/lisp/emacs-lisp/package-resources/key.pub: Refresh.
	* test/lisp/emacs-lisp/package-resources/key.sec: Refresh.

2021-09-27  Lars Ingebrigtsen  <larsi@gnus.org>

	Move test-cl-flet-indentation to the right file

2021-09-27  Lars Ingebrigtsen  <larsi@gnus.org>

	Improve describe-char buffer extremely slightly

	* lisp/descr-text.el (describe-char): Add a colon to further
	signify that we're talking about the following line (bug#50795).

2021-09-27  João Távora  <joaotavora@gmail.com>

	Document shorthands in the Elisp manual section on Symbols

	* doc/lispref/symbols.texi (Symbol Components): Mention "Shorthands".
	(Creating Symbols): Mention shorthands.  Correct references to Common
	Lisp.
	(Shorthands): New section.

	* etc/NEWS (Shorthands): New entry.

2021-09-27  João Távora  <joaotavora@gmail.com>

	Add #_ reader macro to escape shorthand renaming

	* src/lread.c (read1): Add skip_shorthand variable.  Add a '#_'
	case.  If skip_shorthand call oblookup instead of
	oblookup_considering_shorthand.

	* test/lisp/progmodes/elisp-mode-tests.el
	(elisp-shorthand-escape): New test.

	* test/lisp/progmodes/elisp-resources/simple-shorthand-test.el
	(#_f-test4---): New fixture function.

2021-09-27  João Távora  <joaotavora@gmail.com>

	Consider shorthands in Elisp's elisp-completion-at-point

	Instead of referencing obarray directly, that function has to consider
	a collection of completions which includes the shorthand versions of
	some of the symbols.  That collection changes from buffer to buffer,
	depending on the choice of elisp-shorthands.

	To make this process efficient, and avoid needless recalculation of
	the above collection, a new obarray-specific cache was invented.  The
	Elisp variable obarray-cache is immediately nullified if something
	touches the obarray.

	* lisp/progmodes/elisp-mode.el : New helper.
	(elisp-completion-at-point): Use new helpers.
	(elisp--completion-local-symbols)
	(elisp--fboundp-considering-shorthands)
	(elisp--bboundp-considering-shorthands): New helpers

	* src/lread.c (intern_driver): Nullify Qobarray_cache.
	(syms_of_lread): Add Qobarray_cache.

	* test/lisp/progmodes/elisp-mode-tests.el
	(elisp-shorthand-completion-at-point): New test.

	* test/lisp/progmodes/elisp-resources/simple-shorthand-test.el
	(f-test-complete-me): New fixture.

2021-09-27  João Távora  <joaotavora@gmail.com>

	Rework Elisp shorthands to only allow only prefix substitution

	This simplification in requirements makes for more complex C code but
	that code is much less wasteful in Lisp strings than the previous
	implementation.

	* src/lread.c (read1): Rework.
	(Fintern): Rework.
	(Fintern_soft): Rework.
	(Funintern): Rework.
	(oblookup_considering_shorthand): Rewrite.

	* test/lisp/progmodes/elisp-mode-tests.el (elisp-shorthand-read-buffer)
	(elisp-shorthand-read-from-string): Use new format of
	elisp-shorthands.

	* test/lisp/progmodes/elisp-resources/simple-shorthand-test.el (f-test)
	(f-test2, f-test3): Use new form of elisp-shorthands.

2021-09-27  João Távora  <joaotavora@gmail.com>

	Move most of the shorthand implementation to C code

	It passes the tests designed for the previous Elisp implementation.

	Likely, this isn't the final form of the implementation.  For one, the
	reader is much slower and allocates a Lisp string for every atom read,
	regardless if its already interned or not.  This has the potential to
	be catastrophic in terms of GC.

	Also rename the main variable to elisp-shorthands, from the
	repetitive shorthand-shorthands.

	For some reason, I had to put 'hack-elisp-shorthands' and
	'load-with-shorthands-and-code-conversion', the new source-file
	loading functions, in lisp/international/mule.el.

	Otherwise, lisp/loadup.el wouldn't see them, for some reason that I
	didn't investigate.  This should probably be fixed.

	* lisp/shorthand.el: Remove.

	* test/lisp/shorthand-tests.el: Remove.

	* src/lread.c:
	(read1, Fintern, Fintern_soft, Funintern): Use
	oblookup_considering_shorthand.
	(oblookup_considering_shorthand): New helper.
	(syms_of_lread): Declare elisp-shorthands.

	* lisp/progmodes/elisp-mode.el (elisp-shorthands):
	Put a safe-local-variable spec.

	* test/lisp/progmodes/elisp-mode-tests.el (elisp-shorthand-read-buffer)
	(elisp-shorthand-read-from-string)
	(elisp-shorthand-byte-compile-a-file)
	(elisp-shorthand-load-a-file): New tests.

	* test/lisp/progmodes/elisp-resources/simple-shorthand-test.el: New file

	* lisp/loadup.el (load-source-file-function): Set to
	load-with-shorthands-and-code-conversion.

	* lisp/international/mule.el (hack-elisp-shorthands): Move here.
	(load-with-shorthands-and-code-conversion): And here.

2021-09-27  João Távora  <joaotavora@gmail.com>

	First Elisp version of lisp/shorthand.el, failing some tests

	* lisp/shorthand.el: New file

	* test/lisp/shorthand-tests.el: New file

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	Add 'doc-string' declaration to defcalcmodevar

	* lisp/calc/calc.el (defcalcmodevar): Add 'doc-string' declaration.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	Move two incorrectly named test files

	* test/lisp/emacs-lisp/tabulated-list-test.el: Move from here...
	* test/lisp/emacs-lisp/tabulated-list-tests.el: ...to here.
	* test/lisp/url/url-handlers-test.el: Move from here...
	* test/lisp/url/url-handlers-tests.el: ...to here.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	checkdoc: Don't add "Commentary" header to test files

	* lisp/emacs-lisp/checkdoc.el (checkdoc-file-comments-engine):
	Don't add "Commentary:" header if it looks like a test file.

2021-09-26  Robert Pluim  <rpluim@gmail.com>

	Add glyphless-char-display-control for Variation Selectors

	* lisp/international/characters.el (update-glyphless-char-display):
	(glyphless-char-display-control): Add control knob for U+FE00 through
	U+FE0F, defaulting to 'thin-space'.
	* doc/lispref/display.texi (Glyphless Chars): Document it.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	Explicitly make the rest of erc-compat.el obsolete

	* lisp/obsolete/erc-compat.el (erc-decode-coding-string)
	(erc-encode-coding-string, erc-set-write-file-functions)
	(erc-emacs-build-time, erc-replace-match-subexpression-in-string)
	(erc-member-if, erc-delete-if, erc-remove-if-not, erc-subseq):
	Explicitly declare obsolete.
	(erc-define-minor-mode): Make into obsolete function alias for
	'define-minor-mode'.
	(erc-user-emacs-directory): Make into obsolete variable alias for
	'user-emacs-directory'.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	Add fast-path to ert--explain-string-equal

	* lisp/emacs-lisp/ert.el (ert--explain-string-equal): Add fast-path to
	avoid doing extra work.
	Problem reported by Mattias Engdegård <mattiase@acm.org>.

2021-09-26  Michael Albinus  <michael.albinus@gmx.de>

	* test/infra/gitlab-ci.yml (variables): Set DOCKER_BUILDKIT.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	Rename "Homepage" field to "Website" in package description

	* lisp/emacs-lisp/package.el (describe-package-1): Rename
	"Homepage" field to "Website".

	* test/lisp/emacs-lisp/package-tests.el
	(package-test-describe-package)
	(package-test-describe-installed-multi-file-package)
	(package-test-describe-non-installed-package)
	(package-test-describe-non-installed-multi-file-package): Update tests.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	Prefer https for other domains than gnu.org in package URL

	* lisp/emacs-lisp/package.el (describe-package-1): Prefer https for
	some other common domains in the package URL.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	Add test for lm-website

	* lisp/emacs-lisp/lisp-mnt.el (lm-website): Use rx.
	* test/lisp/emacs-lisp/lisp-mnt-tests.el
	(lm--tests-lm-website): New test.

2021-09-26  Mattias Engdegård  <mattiase@acm.org>

	Rx documentation touch-ups (bug#46910)

	* doc/lispref/searching.texi (Rx Constructs, Rx Functions):
	Add clarifications and improve naming of arguments.  Add examples
	illustrating the differences between `rx` and `rx-to-string`.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	Warn about overly long docstring in lambda

	* lisp/emacs-lisp/bytecomp.el
	(byte-compile-docstring-length-warn): Warn about overly long
	docstring in lambda.  (Bug#44858)

	(byte-compile--wide-docstring-p): Improve comment.
	* test/lisp/emacs-lisp/bytecomp-tests.el
	("warn-wide-docstring-defun.el"): Update to test for the above new
	warning.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	Avoid warning about long docstring lines in defcustom

	* lisp/custom.el (defcustom): Avoid warning about long docstring
	lines.  This was caused by the value of the defcustom being treated as
	docstring due to it being wrapped in a lambda.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	Fill some auto-generated docstring lines

	* lisp/cedet/mode-local.el (define-mode-local-override):
	* lisp/cedet/semantic/decorate/mode.el (define-semantic-decoration-style):
	* lisp/cedet/semantic/idle.el (define-semantic-idle-service):
	* lisp/emacs-lisp/derived.el (derived-mode-make-docstring):
	* lisp/emacs-lisp/eieio.el (defclass): Fill auto-generated docstring
	lines.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	Avoid false positives in bytecomp docstring width warning

	* lisp/emacs-lisp/bytecomp.el (byte-compile--wide-docstring-p):
	Ignore more function argument lists.
	* test/lisp/emacs-lisp/bytecomp-tests.el
	(bytecomp-tests-byte-compile--wide-docstring-p): New test.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	Improve filling of generated docstring lines

	* lisp/subr.el (internal--fill-string-single-line): Improve filling to
	use full width.  Fix bug where line was not wrapped correctly.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	ert: Add basic explainer for string-equal

	* lisp/emacs-lisp/ert.el (ert--explain-string-equal): Add basic
	explainer for 'string-equal' based on 'ert--explain-equal'.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	Unbreak ert tests

	* test/lisp/emacs-lisp/tabulated-list-test.el (tabulated-list-print)
	(tabulated-list-sort): Update tests for recent change.

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	Doc fix: mode name in local variables needs no suffix

	* doc/emacs/custom.texi (Specifying File Variables): Clarify that a
	mode name does not need the "-mode" suffix.  (Bug#50801)

2021-09-26  Stefan Kangas  <stefankangas@gmail.com>

	checkdoc: Library footer must match package.el requirement

	* lisp/emacs-lisp/checkdoc.el (checkdoc-file-comments-engine):
	Don't accept footer format unless it matches the requirement in
	package.el.

2021-09-26  Michael Albinus  <michael.albinus@gmx.de>

	Adapt Tramp's make-process for macOS.

	* lisp/net/tramp-sh.el (tramp-check-remote-uname): New defun.
	(tramp-sh-handle-file-ownership-preserved-p)
	(tramp-sh-handle-make-process, tramp-find-executable)
	(tramp-find-shell, tramp-get-remote-stat): Use it.  (Bug#50748)

	* test/lisp/net/tramp-tests.el (tramp-check-remote-uname): Declare.
	(tramp-test29-start-file-process, tramp-test30-make-process):
	Instrument for macOS.
	(tramp--test-hpux-p): Adapt function.
	(tramp--test-macos-p): New defun.

2021-09-26  Lars Ingebrigtsen  <larsi@gnus.org>

	Expand the ` doc string slightly

	* lisp/emacs-lisp/backquote.el (backquote): Note that ` is used
	for other things in some macros (bug#25462).

2021-09-26  Lars Ingebrigtsen  <larsi@gnus.org>

	Fix rendering non-ASCII text with links

	* lisp/gnus/mm-view.el (mm-text-html-renderer-alist): Add a new
	form for links.
	(mm-links-remove-leading-blank): Make obsolete.
	(mm-inline-wash-with-file):
	(mm-inline-render-with-file): Make obsolete -- they were awkwardly
	defined and only used with links.
	(mm-inline-render-with-links): New function.

2021-09-26  Lars Ingebrigtsen  <larsi@gnus.org>

	Add new macro with-environment-variables

	* doc/lispref/os.texi (System Environment): Document it.

	* lisp/env.el (with-environment-variables): New macro.

2021-09-25  Stefan Kangas  <stefankangas@gmail.com>

	Revert "; Fix capitalization of F1..F12 keys in docs"

	This reverts commit fe5b20410f68546821e6c87577d7f826167491dc.

